Package: plyxp
Title: Data masks for SummarizedExperiment enabling dplyr-like
        manipulation
Version: 1.7.3
Authors@R: c(
    person("Justin", "Landis", email = "jtlandis314@gmail.com", role = c("aut", "cre"),
    comment = c(ORCID = "0000-0001-5501-4934")),
    person("Michael", "Love", email = "michaelisaiahlove@gmail.com", role = "aut",
    comment = c(ORCID = "0000-0001-8401-0545")))
Description: The package provides `rlang` data masks for the SummarizedExperiment class. The enables the evaluation of unquoted expression in different contexts of the SummarizedExperiment object with optional access to other contexts. The goal for `plyxp` is for evaluation to feel like a data.frame object without ever needing to unwind to a rectangular data.frame.
License: MIT + file LICENSE
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.3
VignetteBuilder: knitr
Imports: dplyr, purrr, rlang, SummarizedExperiment, tidyr, tidyselect,
        vctrs, tibble, pillar, cli, glue, S7, S4Vectors, utils, methods
Depends: R (>= 4.5.0)
Suggests: devtools, knitr, rmarkdown, testthat, airway, IRanges, here
LazyData: true
URL: https://github.com/jtlandis/plyxp,
        https://jtlandis.github.io/plyxp
BugReports: https://www.github.com/jtlandis/plyxp/issues
biocViews: Annotation, GenomeAnnotation, Transcriptomics
Config/testthat/edition: 3
Collate: 'as.data.frame.R' 'connect_masks.R' 'context-utils.R' 'data.R'
        'dplyr-across.R' 'dplyr-arrange.R' 'dplyr-filter.R'
        'dplyr-group_by.R' 'dplyr-mutate.R' 'dplyr-pull.R'
        'dplyr-select.R' 'dplyr-slice.R' 'dplyr-summarise.R'
        'group_utils.R' 'grouped_list.R' 'vctrs-S4-.R' 'vctrs-S4-rep.R'
        'vctrs-S4-unchop.R' 'vctrs-S4-chop.R' 'mask_env_top.R'
        'plyxp-R6-manager.R' 'plyxp-R6.R' 'plyxp-class.R'
        'plyxp-package.R' 'plyxp-quos.R' 'plyxp.R' 'plyxp_cannot.R'
        'print.R' 'reexports-SummarizedExperiment.R'
        'reexports-dplyr.R' 'utils.R' 'vctrs-S4-group.R'
        'vctrs-S4-recycle.R' 'vctrs-S4-slice.R' 'zzz-globals.R' 'zzz.R'
git_url: https://git.bioconductor.org/packages/plyxp
git_branch: devel
git_last_commit: ed59c03
git_last_commit_date: 2026-07-28
Repository: Bioconductor 3.24
Date/Publication: 2026-07-29
NeedsCompilation: no
Packaged: 2026-07-29 23:29:30 UTC; biocbuild
Author: Justin Landis [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-5501-4934>),
  Michael Love [aut] (ORCID: <https://orcid.org/0000-0001-8401-0545>)
Maintainer: Justin Landis <jtlandis314@gmail.com>

# `plyxp` <a href="https://jtlandis.github.io/plyxp"><img src="man/figures/plyxp_hexsticker2.png" align="right" height="200" alt="plyxp website" style="float:right; height:200px;" /></a>

# Description

_plyxp_ proposes an expressive grammar for manipulating annotated matrix data, 
with syntax to access, modify, and append matrix data and tabular row and 
column metadata, including row-wise or column-wise grouped operations.
By defining multiple contexts and providing pronouns for specific recall 
and assignment within and across these contexts, _plyxp_ makes using common 
_dplyr_ functions as natural as working with a data.frame or tibble.

_plyxp_ is an implementation of this grammar for the R/Bioconductor ecosystem, 
with efficient abstractions for the _SummarizedExperiment_ class. 
Data within the _SummarizedExperiment_ are lazily bound to a series of environments, 
meaning expressions are evaluated only when the user forces their symbols. 
This gives users more freedom in how they choose to work with their data.
_plyxp_ uses 
[data-masking](https://rlang.r-lib.org/reference/topic-data-mask-programming.html)
from the _rlang_ package to connect _dplyr_ verbs to _SummarizedExperiment_ 
slots in an intuitive and unambiguous manner.

The _tidySummarizedExperiment_ package, released with 
Bioconductor 3.12 in 2020, also provides _dplyr_-like access to 
_SummarizedExperiment_ objects within the tidyomics project, allowing 
datasets to be directly piped into _ggplot2_ plotting functions, 
for example. _plyxp_ and _tidySummarizedExperiment_ can be used in 
parallel, as users engage plyxp functions by casting their SE 
objects with `new_plyxp()`.

# Installing plyxp

```r
# plyxp is available via BiocManager
BiocManager::install("plyxp")
# To use the latest updated version please use the github
remotes::install_github("jtlandis/plyxp")
```

# Documentation

See [Get started](https://jtlandis.github.io/plyxp/articles/plyxp.html)
for the package vignette, and 
[Reference](https://jtlandis.github.io/plyxp/reference/index.html)
for function man pages.

# Citation

If you use _plyxp_ in published research, please cite:

> Landis JT, Love MI (2026). "Efficient and Tidy Manipulation of Annotated Matrix Data with plyxp." *bioRxiv*. 
> [10.64898/2026.05.06.721669](https://doi.org/10.64898/2026.05.06.721669)

# Feedback

We would love to hear your feedback. Please post to
[Bioconductor support site](https://support.bioconductor.org)
or the
`#tidiness_in_bioc` Slack channel on community-bioc
for software usage help,
or post an
[Issue on GitHub](https://github.com/jtlandis/plyxp/issues),
for software development questions.

# Funding

_plyxp_ was supported by an EOSS grant from 
The Wellcome Trust, and NIH NHGRI R01-HG009937.

# How plyxp works

**Data masking a SummarizedExperiment**

The _SummarizedExperiment_ object contains three main components/"contexts" that we mask,
the `assays()`, `rowData()`[^1] and `colData()`.

[^1]: At this moment `rowRanges()` is not supported in `plyxp` but may become
its own pronoun in the future.

![Simplified view of data masking structure. Figure made with [Biorender](https://biorender.com)](man/figures/Overview-bindings.png)

\
_plyxp_ provides variables as-is to data **within their current contexts** enabling you
to call S4 methods on S4 objects with _dplyr_ verbs. If you require access to
variables _outside the context_, you may use
pronouns made available through _plyxp_ to specify where to find those
variables.

![Simplified view of reshaping pronouns. Arrows indicates to where the pronoun provides access. For each pronoun listed, there is an `_asis` variant that returns underlying data without reshaping it to fit the context. Figure made with [Biorender](https://biorender.com)](man/figures/Overview-pronouns.png)

\

The `.assays`, `.rows` and `.cols` pronouns outputs depends on the evaluating
context. Users should expect that the underlying data returned from `.rows` or
`.cols` pronouns in the _**assays context**_ is a vector, replicated to match
size of the assay context.
\
Alternatively, using a pronoun in either the `rows()` or `cols()`
contexts will likely return a list equal in length to either `nrows(rowData())`
or `nrows(colData())` respectively.

# Note on plyxp for Bioc 3.21 or 3.20

_plyxp_ is still under active development. We have recently discovered an error in `group_by(xp, rows(foo)) |> summarize(some_assay = <expr>)` operations in which the resulting assay matrix was being collected incorrectly. This has been fixed with [this commit](https://github.com/jtlandis/plyxp/commit/ee3f3945761b62232df6f4c42d617fef614370f2) and has been pushed to `plyxp 1.4.3` on Bioconductor version 3.22. With this being said, we cannot update older version of plyxp on Bioconductor 3.21 and 3.20 - however we have cherry-picked this commit into the github branch images.

Thus if you wish to use _plyxp_ from Bioconductor 3.21 or 3.20, 
please install from github to ensure you have the latest fixes.

```r
remotes::install_github("jtlandis/plyxp@RELEASE_3_21")
```

# The following variables are referred to via NSE syntax
# somewhere in plyxp. As such, they show up as NOTES in
# R CMD Check. This is to satisfy R CMD Check
name <- NULL
.features <- NULL
.samples <- NULL
.rows_group_id <- NULL
key <- loc <- NULL

## from mask_env_top.R
## these bindings are ceated in the data-mask
`plyxp:::ctx::nrow` <- NULL
`plyxp:::ctx::ncol` <- NULL
.group_id <- NULL
`.rows::.indices_group_id` <- NULL
`.cols::.indices_group_id` <- NULL
`plyxp:::ctx:::n_groups` <- NULL
`plyxp:::ctx` <- NULL
`plyxp:::ctx:::group_chop_ids` <- NULL
`plyxp:::ctx:::group_id` <- NULL
`plyxp:::ctx:::ncol` <- NULL
`plyxp:::ctx:::nrow` <- NULL
`plyxp:::assays:::group_chop_ids` <- NULL
`plyxp:::rows:::group_chop_ids` <- NULL
`plyxp:::cols:::group_chop_ids` <- NULL
`plyxp:::dim:::nrow` <- NULL
`plyxp:::dim:::ncol` <- NULL
`plyxp:::dim:::size` <- NULL
`plyxp:::dim:::n` <- NULL

#' @importFrom dplyr bind_cols reframe across everything group_vars

# faster implementation
expand_groups2 <- function(.rows, .cols) {
  names(.rows) <- sprintf(".rows::%s", names(.rows))
  names(.cols) <- sprintf(".cols::%s", names(.cols))
  .nrow <- nrow(.rows)
  .ncol <- nrow(.cols)
  .rows <- map(.rows, vec_rep, times = .ncol)
  .cols <- map(.cols, vec_rep_each, times = .nrow)
  out <- c(.rows, .cols)
  n <- .nrow * .ncol
  out[[".nrows"]] <- map_int(out[[".rows::.indices"]], length)
  out[[".ncols"]] <- map_int(out[[".cols::.indices"]], length)
  attr(out, "row.names") <- c(NA_integer_, -n)
  class(out) <- c("tbl_df", "tbl", "data.frame")
  attr(out, "plyxp:::unique_row_ind") <- seq_len(.nrow)
  attr(out, "plyxp:::unique_col_ind") <- ((seq_len(.ncol) - 1L) * .nrow) + 1L

  # due to this ordering here, I had introduced an unexpected
  # column-wise ordering of assays. I have changed it and commented
  # it out and also revered to the original intent of row-wise ordering.
  # o <- order(
  #   out[[".cols::.indices_group_id"]],
  #   out[[".rows::.indices_group_id"]]
  # )
  # out <- out[o,]
  out$.group_id <- seq_len(n)
  out
}

# inefficient and possibly defunct
# expand_groups <- function(.rows, .cols) {
#   #
#   .nrow <- nrow(.rows)
#   .ncol <- nrow(.cols)
#   bind_cols(
#     nest(
#       .rows,
#       .row_keys = -c(.indices, .indices_group_id)
#     ) |>
#       reframe(
#         across(
#           everything(),
#           ~vec_rep(.x, times = .env$.ncol)
#         ) |>
#           rename_with(.fn = \(x) gsub(".indices", ".rows", x = x))
#       ),
#     nest(
#       .cols,
#       .col_keys = -c(.indices, .indices_group_id)
#     ) |>
#       reframe(
#         across(
#           everything(),
#           ~vec_rep_each(.x, times = .env$.nrow)
#         ) |>
#           rename_with(.fn = \(x) gsub(".indices", ".cols", x = x))
#       ),
#     .name_repair = "minimal"
#   ) |>
#     arrange(
#       .rows_group_id,
#       .cols_group_id
#     ) |>
#     mutate(
#       .group_id = 1:n()
#     )
# }

mat_index <- function(rows_ind, cols_ind, nrows) {
  shift <- (cols_ind - 1L) * nrows
  vctrs::vec_rep(rows_ind, length(cols_ind)) +
    vctrs::vec_rep_each(shift, length(rows_ind))
}

is_grouped_rows <- function(.groups) {
  !is_empty(.groups$row_groups)
}

is_grouped_cols <- function(.groups) {
  !is_empty(.groups$col_groups)
}

#' @name group_vars
#' @title get PlySummarizedExperiment grouping Variables
#' @description
#' like in [dplyr::group_vars()] will get character strings for
#' groupings with the exection of the return value
#' being a list for each grouped context
#'
#' @param x PlySummarizedExperiment
#' @examples
#'
#' out <- group_by(se_simple, rows(direction))
#' group_vars(out)
#'
#' @return NULL or list containing names of grouping columns
#' @export
group_vars.PlySummarizedExperiment <- function(x) {
  group_vars_se_impl(se(x))
}

group_vars_se_impl <- function(x) {
  map(
    group_data_se_impl(x),
    function(x) {
      grep(
        x = names(x),
        pattern = "^.indices",
        value = TRUE,
        invert = TRUE
      )
    }
  )
}


into_dimlist <- function(assay_ind) {
  # we should always trust the groups sent to us,
  # using unique may change the expected number of
  # groups when constructing the object
  row_chops <- attr(assay_ind, "plyxp:::row_chop_ind")
  row_chops <- if (is.null(row_chops)) {
    rlang::missing_arg()
  } else {
    vctrs::vec_slice(row_chops, attr(assay_ind, "plyxp:::unique_row_ind"))
  }
  col_chops <- attr(assay_ind, "plyxp:::col_chop_ind")
  col_chops <- if (is.null(col_chops)) {
    rlang::missing_arg()
  } else {
    vctrs::vec_slice(col_chops, attr(assay_ind, "plyxp:::unique_col_ind"))
  }
  list(
    row_chops,
    col_chops
  )
}

chop_assays_outer <- function(obj, .ind) {
  dimlist <- into_dimlist(.ind)
  chop_dims_outer(obj, dimlist)
}

chop_dims_outer <- function(obj, .dims) {
  # is_missing <- vapply(.dims, rlang::is_missing, FUN.VALUE = logical(1))
  n <- length(.dims)
  nlens <- lengths(.dims)
  out_size <- Reduce(`*`, nlens, right = TRUE, accumulate = 1L)

  curr_dim <- n
  obj_slice <- NULL
  objs <- out <- vector("list", out_size[[1L]])
  objs[[1L]] <- out[[1L]] <- obj
  n_obj <- 1L
  slice_expr <- expr(.slice)
  dim_args <- vec_rep(list(rlang::missing_arg()), n)
  while (curr_dim > 0) {
    .slices <- .dims[[curr_dim]]

    i_seq <- seq_len(nlens[curr_dim])
    nn <- length(i_seq)
    n_out <- out_size[curr_dim]
    out_seq <- seq_len(n_out)

    if (!is_missing(.slices)) {
      dim_args[[curr_dim]] <- slice_expr
      e <- inject(expr(obj_slice[!!!dim_args, drop = FALSE]))
      # out <- vector("list", out_size[curr_dim])
      for (j in seq_len(n_obj)) {
        obj_slice <- .subset2(objs, j)
        shift <- (j - 1L) * nn
        for (i in i_seq) {
          .slice <- .subset2(.slices, i)
          out[[shift + i]] <- eval(e)
        }
      }
      dim_args[[curr_dim]] <- missing_arg()
    }

    n_obj <- n_out
    curr_dim <- curr_dim - 1L
    objs[out_seq] <- out[out_seq]
  }
  out
}

vec_chop_assays <- function(.data, .indices) {
  map2(
    attr(.indices, "plyxp:::row_chop_ind"),
    attr(.indices, "plyxp:::col_chop_ind"),
    function(.x, .y, .data) .data[.x, .y, drop = FALSE],
    .data = .data
  )
}

vec_chop_assays_row <- function(.data, .indices) {
  map(attr(.indices, "plyxp:::row_chop_ind"),
    function(.i, .data) .data[.i, , drop = FALSE],
    .data = .data
  )
}

vec_chop_assays_col <- function(.data, .indices) {
  map(attr(.indices, "plyxp:::col_chop_ind"),
    function(.i, .data) .data[, .i, drop = FALSE],
    .data = .data
  )
}


create_groups <- function(.data, .rename = ".indices") {
  # check if length > 0
  if (is_empty(.data)) {
    return(NULL)
  }
  # check first index has length > 0
  # assumes all others have similar length (probably not always true)
  if (length(.data[[1]]) == 0) {
    .data <- as_tibble(.data)
    .data[[.rename]] <- list()
    .data[[sprintf("%s_group_id", .rename)]] <- integer()
    return(.data)
  }
  .data |>
    as_tibble() |>
    vec_group_loc() |>
    unnest(key) |>
    rename("{.rename}" := loc) |>
    mutate("{.rename}_group_id" := seq_len(n()))
}

plyxp_groups <- function(row_groups = NULL, col_groups = NULL) {
  out <- list(
    row_groups = create_groups(row_groups),
    col_groups = create_groups(col_groups)
  )
  type <- ""
  if (!is.null(out$row_groups)) {
    type <- "row"
  }
  if (!is.null(out$col_groups)) {
    type <- paste0(type, "col")
  }
  class(out) <- "plyxp_groups"
  # attr(out, "type") <- type
  if (type == "") {
    return(NULL)
  }
  out
}

get_group_indices <- function(
  .groups,
  .details,
  type = c("assays", "rowData", "colData")
) {
  if (is.null(.groups)) {
    return(NULL)
  }
  type <- match.arg(type, c("assays", "rowData", "colData"))
  switch(type,
    assays = {
      #
      out <- map2(
        .details[[".rows::.indices"]],
        .details[[".cols::.indices"]],
        .f = function(row, col, n) {
          mat_index(row, col, nrows = n)
        }, n = attr(.groups, "obj_dim")[1]
      )
      attr(out, "plyxp:::row_chop_ind") <- .details[[".rows::.indices"]]
      attr(out, "plyxp:::col_chop_ind") <- .details[[".cols::.indices"]]
      attr(out, "plyxp:::unique_row_ind") <- attr(.details, "plyxp:::unique_row_ind")
      attr(out, "plyxp:::unique_col_ind") <- attr(.details, "plyxp:::unique_col_ind")
      # attr(out, "type") <- attr(.groups, "type")
      out
    },
    rowData = {
      if (isFALSE(attr(.groups, "grouped_rows"))) {
        NULL
      } else {
        .groups$row_groups$.indices
      }
    },
    colData = {
      if (isFALSE(attr(.groups, "grouped_cols"))) {
        NULL
      } else {
        .groups$col_groups$.indices
      }
    }
  )
}

# group_type <- function(obj) {
#   result <- attr(obj, "type")
#   if (is.null(result)) {
#     return("none")
#   }
#   result
# }

# `group_type<-` <- function(obj, value) {
#   value <- match.arg(value, choices = c("rowcol", "row", "col"))
#   attr(obj, "type") <- value
#   obj
# }

group_details <- function(obj) {
  group_data <- group_data_se_impl(obj)
  if (is.null(group_data$row_groups)) {
    group_data$row_groups <- tibble(.indices = list(seq_len(nrow(obj))), .indices_group_id = 1L)
    attr(group_data, "grouped_rows") <- FALSE
  }

  if (is.null(group_data$col_groups)) {
    group_data$col_groups <- tibble(.indices = list(seq_len(ncol(obj))), .indices_group_id = 1L)

    attr(group_data, "grouped_cols") <- FALSE
  }

  # out <- list(
  #   row_groups = row_groups,
  #   col_groups = col_groups
  # )
  # out <- expand_groups2(row_groups, col_groups)
  attr(group_data, "obj_dim") <- dim(obj)
  # attr(out, "type") <- attr(group_data, "type")
  # out |>
  #   mutate(
  #     .nrows = map_int(`.rows::.indices`, length),
  #     .ncols = map_int(`.cols::.indices`, length)
  #   )
  group_data
}

group_ind <- function(x, n) {
  int <- integer(n)
  for (i in seq_along(x)) {
    int[x[[i]]] <- i
  }
  int
}

slice_group_data <- function(groups, indices, .size, .preserve = FALSE) {
  if (is.null(groups)) {
    return(groups)
  }
  group_inds <- group_ind(groups$.indices, .size)
  new_id <- vctrs::vec_slice(group_inds, indices)
  new_grps <- vctrs::vec_group_loc(new_id)
  inds <- lapply(seq_len(nrow(groups)), function(i) integer())
  inds[new_grps$key] <- new_grps$loc
  groups$.indices <- inds
  if (!.preserve) {
    groups <- groups[new_grps$key, ]
    groups$.indices_group_id <- seq_len(nrow(groups))
  }
  groups
}

#' @name slice
#' @title Slice a PlySummarizedExperiment
#' @description
#' `slice()` selects rows and/or columns by position.
#' @param .data a PlySummarizedExperiment object
#' @param ... expressions that resolve to integer values to slice, .data by.
#' Note that only the `rows()` and `cols()` contexts are available here.
#' @param .preserve Logical value. When FALSE, the default, group combinations
#' are recomputed based on the resulting data. When TRUE, group combinations
#' are retained, despite any groups being empty.
#' @examples
#' gse <- group_by(se_simple, rows(direction), cols(condition))
#' sgse <- slice(gse, rows(which(direction == "-")))
#' group_data(gse)
#' group_data(sgse)
#' sgse2 <- slice(gse, rows(which(direction == "-")), .preserve = TRUE)
#' group_data(sgse2)
#' @export
slice.PlySummarizedExperiment <- function(.data, ..., .preserve = FALSE) {
  plyxp(.data, slice_se_impl, ..., .preserve = .preserve)
}

slice_se_impl <- function(.data, ..., .preserve = FALSE) {
  # we will update .slice_data with some conviencence columns
  # then use that to slice the original data at the end
  # .slice_data <- .data
  .env <- caller_env()
  # slice in dplyr only keeps indices that are within the current group
  # we will add a post transfrom to filter each evaluated expression.
  in_bounds <- quote(\(.x) base::Filter(x = .x, \(x) x <= `plyxp:::ctx:::n`))
  quos <- plyxp_quos(
    ...,
    .ctx = c("assays", "rows", "cols"),
    .trans = list(
      rows = in_bounds,
      cols = in_bounds
    )
  )

  ctxs <- vapply(quos, attr, FUN.VALUE = "", which = "plyxp:::ctx")
  if (any(err <- ctxs %in% "assays")) {
    plyxp_assays_cannot(do = "slice", review = err)
  }
  named_quos <- quos_is_named(quos = quos)
  if (any(named_quos)) {
    plyxp_should_not_named("slice")
  }
  # rename the quos so we can find them later
  names(quos) <- sprintf("..slice_%i", seq_along(quos))
  nms <- names(quos)
  quos <- quos_enforce_named(quos, nms)
  # to make this function consistent
  # groups <- group_data_se_impl(.data)
  # metadata(.data)[["group_data"]] <- NULL
  # rowData(.slice_data)[[".plyxp:::index"]] <- seq_len(nrow(.slice_data))
  # colData(.slice_data)[[".plyxp:::index"]] <- seq_len(ncol(.slice_data))
  mask <- new_plyxp_manager.SummarizedExperiment(obj = .data)
  poke_ctx_local("plyxp:::caller_env", .env)
  poke_ctx_local("plyxp:::manager", mask)
  poke_ctx_local("plyxp:::dplyr_verb", "slice")
  mask <- plyxp_evaluate(mask, quos, ctxs, nms, .env)
  # we may have empty values, thus we do not collect with
  # mask$results, instead we will get the values raw and
  # handle the correct index
  chops <- mask$apply(
    .f = function(mask, name) {
      added <- mask$added
      names(added) <- added
      lapply(added, mask$get_chop)
    },
    .on_masks = c("rows", "cols")
  )
  chops <- flatten_slice_chops(chops, groups = group_data_se_impl(.data))
  which_ctx <- unique(ctxs)
  switch(length(which_ctx),
    `1` = {
      switch(which_ctx,
        rows = plyxp_slice_se(.data, chops$rows,
          .preserve = .preserve
        ),
        cols = plyxp_slice_se(.data, , chops$cols,
          .preserve = .preserve
        )
      )
    },
    `2` = {
      plyxp_slice_se(
        .data,
        chops$rows,
        chops$cols,
        .preserve = .preserve
      )
    }
  )
}

flatten_by_slice_expr <- function(ctx_chops, ctx_group) {
  if (is.null(ctx_group)) {
    # no groups - ctx_chops is a list off
    # index exprs
    do.call("c", ctx_chops)
  } else {
    # ctx_chops[[1]] --> expr1
    # ctx_chops[[2]] --> expr2 ...
    #
    # ctx_chops[[1]][...] --> expr1[group1, ..., groupn]
    chops <- lapply(ctx_chops,
      function(chop, true_ind) {
        Map(`[`, true_ind, chop)
      },
      true_ind = ctx_group$.indices
    )
    lapply(
      seq_along(ctx_group$.indices),
      function(i, chops) {
        do.call("c", lapply(chops, .subset2, i))
      },
      chops = chops
    )
  }
}

flatten_slice_chops <- function(chops, groups = NULL) {
  Map(
    flatten_by_slice_expr,
    ctx_chops = chops,
    ctx_group = groups %||% list(NULL, NULL)
  ) |>
    lapply(function(by_expr) {
      #
      if (is.list(by_expr)) {
        by_expr <- do.call("c", by_expr)
      }
      if (!(is.numeric(by_expr) || is.null(by_expr))) {
        stop("`slice` should resolve numeric slices")
      }
      by_expr
    })
}

#' @include vctrs-S4-.R


#' @title Recycle a vector
#' @name vctrs-vec_recycle
#' @description
#' A re-export of [`vctrs::vec_recycle`][vctrs::vec_recycle] as an S7 generic
#' function to allow `S4Vectors`.
#' @inheritParams vctrs::vec_recycle
#' @return a S3 or S4 vector
#' @examples
#' vec_recycle(1L, size = 5L)
#' vec_recycle(S4Vectors::Rle(1L), size = 5L)
#'
#' @export
vec_recycle <- new_generic("vec_recycle",
  dispatch_args = "x",
  function(x, size, ..., x_arg = "",
           call = caller_env()) {
    S7_dispatch()
  }
)

method(vec_recycle, class_vctrs) <- function(x, size, ..., x_arg = "",
                                             call = caller_env()) {
  vctrs::vec_recycle(x = x, size = size, ..., x_arg = x_arg, call = call)
}

method(vec_recycle, class_s4_vctrs) <- function(x, size, ..., x_arg = "",
                                                call = caller_env()) {
  if (length(size) != 1L) rlang::abort("argument `size` should be length 1L")
  if (!is.numeric(size)) rlang::abort("argument `size` should be integer-ish")
  vec_len <- length(x)
  vec_len |>
    match(c(1L, size), nomatch = 0L) |>
    as.character() |>
    switch(
      `1` = vec_slice(x, vctrs::vec_rep(1L, size)),
      `2` = x,
      rlang::abort(glue::glue("Can't recycle inpute of size {vec_len} to size {size}."),
        call = call
      )
    )
}

# conflict_info <- c(
#     "Note that these packages are exclusive and present different APIs ",
#     "for working with {.cls SummarizedExperiment} objects. As such conflicts ",
#     "and unexpected behaviors may arise!"
# )

# rule <- function (pad = "-", gap = 2L) {
#   paste0(rep(pad, getOption("width") - gap), collapse = "")
# }

# tidySE_opt <- list(quote(tidySummarizedExperiment), "tidySummarizedExperiment")

# attaching_tidySE <- function(expr) {
#   if (is_call(expr, name = "library")) {
#     call <- match.call(library, call = expr)
#     out <- tidySE_opt |>
#       vapply(identical, y = call$package, logical(1)) |>
#       any()
#     return(out)
#   }
#   FALSE

# }



# you_have_loaded <- function(pkg1, pkg2, .class = NULL) {
#   if (!is.null(.class)) {
#     local_options(cli.message_class = .class)
#   }
#   withRestarts({
#     cli::cli_rule()
#     cli::cli_alert_warning(
#       "you have loaded {.pkg {pkg1}} after {.pkg {pkg2}}\n"
#     )
#     cli::cli_text("")
#     cli::cli_text(conflict_info)
#     cli::cli_text("")
#   },
#   muffleMessage = function() NULL)

# }

# # a package can either be loaded, or completely attached. R only informs
# # of conflicts when the package is loaded, and when attached these can be
# # overwritten silently

# .onAttach <- function(libname, pkgname) {
#   # check if `tidySummarizedExperiment` is already loaded
#   conflict <- grep("tidySummarizedExperiment", search(), value = TRUE)
#   if (length(conflict)) {
#     you_have_loaded("plyxp","tidySummarizedExperiment",
#                     .class = c("packageStartupMessage", "message"))
#   }
#   # set hook for if `tidySummarizedExperiment` gets attached latter
#   setHook(
#     packageEvent(pkgname = "tidySummarizedExperiment",
#                  event = "attach"),
#     function(...) {
#       you_have_loaded("tidySummarizedExperiment","plyxp",
#                       .class = c("packageStartupMessage", "message"))
#     }

#   )
#   # hook for when tidySummarizedExperiment:: is used after plyxp is attached
#   setHook(
#     packageEvent(pkgname = "tidySummarizedExperiment",
#                  event = "onLoad"),
#     function(...) {
#       calls <- sys.calls()
#       called_via_library <- vapply(calls, attaching_tidySE, logical(1))
#       if (!any(called_via_library)) {
#         # if this callback was not executed via library(tidySummarizedExperiment)
#         # then warn that plyxp dplyr methods have likely been overwritten!
#         # otherwise, let the .onAttach method warn the user
#         cli::cli_inform(
#           .frequency = "regularly",
#           .frequency_id = "tidySummarizedExperiment_loaded_after_plyxp_attach",
#           class = "plyxp_loaded_conflict",
#           message = c(
#             "!" = paste0(
#               "You have likely loaded {.pkg tidySummarizedExperiment} after ",
#               "{.pkg plyxp} via {.code tidySummarizedExperiment::...}"
#             ),
#             "*" = paste(conflict_info, collapse = ""),
#             "!" = "This has likely caused {.pkg dplyr} methods from {.pkg plyxp} to be over-written!",
#             "i" = "If this wasn't your intention, consider restarting your R session"))
#       }

#     }
#   )
# }

# .onDetach <- function(libpath) {
#   # remove verbose message when `plyxp` is removed from attach list
#   setHook(packageEvent("tidySummarizedExperiment", "attach"), NULL, "replace")
#   setHook(packageEvent("tidySummarizedExperiment", "onLoad"), NULL, "replace")
# }

# check_dplyr_s3_method <- function(method) {
#   tbl <- getNamespace("dplyr")[[".__S3MethodsTable__."]]
#   res <- tbl[[method]]
#   if (!is.null(res) && is.function(res)) {
#     env_name <- environmentName(environment(res))
#     if (env_name != "plyxp") {
#       rlang::warn(
#         paste0(c("`plyxp` shows that `", env_name, "` is already loaded")))
#     }
#   }
#   res
# }

#' @name select
#' @title select assays, rowData, and colData names
#' @description
#' Select one or more values from each context. By default omitting an expression
#' for a context is the same as selecting NOTHING from that context.
#'
#' The <[`tidy-select`][dplyr::dplyr_tidy_select]> implementation within
#' `plyxp` is almost similar to `dplyr` except when used within the
#' `across()` function. When used from `accross()`, the data provided to
#' [eval_select][tidyselect::eval_select] is a zero length slice of the data.
#' This was an intentional choice to prevent the evaluation of potentionally
#' expensive chopping operations for S4Vectors. This means that predicate
#' function from [`where()`][tidyselect::where] will NOT be able to query the
#' original data.
#'
#'
#' @param .data An object Inheriting from `PlySummarizedExperiment`, the wrapper
#' class for `SummarizedExperiment` objects
#' @param ... <[`tidy-select`][dplyr::dplyr_tidy_select]> one or more selection
#' expressions. Supports wrapping expressions within the
#' <[`plyxp-contexts`][plyxp::plyxp-context]>.
#' @return an object inheriting PlySummarizedExperiment class
#' @examples
#'
#'
#' # only keep assays, other contexts are dropped
#' select(se_simple, everything())
#'
#' # only keep rowData, other contexts are dropped
#' select(se_simple, rows(everything()))
#'
#' select(se_simple, rows(where(is.numeric)))
#'
#' # Note on `where()` clause, all data is available within select
#' select(se_simple, rows(where(~ any(grepl("-", .x)))))
#'
#' # within an `across()`, only a zero-length slice avialble, so the
#' # `where()` predicate cannot access the data
#' mutate(
#'   se_simple,
#'   rows(
#'     across(
#'       where(~ any(grepl("-", .x))),
#'       ~ sprintf("%s foo", .x)
#'     )
#'   )
#' )
#' # here is an acceptable usage of the `where()` predicate
#' mutate(
#'   se_simple,
#'   rows(
#'     across(
#'       where(is.character),
#'       ~ sprintf("%s foo", .x)
#'     )
#'   )
#' )
#'
#' @export
select.PlySummarizedExperiment <- function(.data, ...) {
  plyxp(.data, select_se_impl, ...)
}

select_se_impl <- function(.data, ...) {
  .env <- caller_env()
  poke_ctx_local("plyxp:::caller_env", .env)
  poke_ctx_local("plyxp:::dplyr_verb", "select")
  quos <- plyxp_quos(..., .ctx = c("assays", "rows", "cols"))
  ctxs <- vapply(quos, attr, FUN.VALUE = "", which = "plyxp:::ctx")
  # nms  <- names(quos)


  selected <- plyxp_eval_select(
    quos = quos, ctxs = ctxs, data = .data
  )


  assays(.data) <- assays(.data)[selected[["assays"]]]
  rowData(.data) <- rowData(.data)[selected[["rows"]]]
  colData(.data) <- colData(.data)[selected[["cols"]]]

  .data
}

# underlying selection function. This may need to be an S3 generic
# for when `plyxp` extends to other classes
plyxp_eval_select <- function(quos, ctxs, data) {
  out <- vector("list", length(quos))
  .data <- list(
    assays = as.list(assays(data)),
    rows = as.list(rowData(data)),
    cols = as.list(colData(data))
  )

  for (i in seq_along(quos)) {
    quo <- quos[[i]]
    ctx <- ctxs[i]
    out[[i]] <- tidyselect::eval_select(quo, .data[[ctx]])
  }

  ctxs <- factor(ctxs, levels = c("assays", "rows", "cols"))
  split(out, ctxs) |>
    lapply(function(.x) {
      unlist(.x) |>
        unique()
    })
}

# Meant to be used to propagate NULL when a downstream
# function could take NULLs
`%|!|%` <- function(x, y) if (!is_empty(x)) y else NULL

#' @name filter
#' @title filter PlySummarizedExperiment
#' @description
#'
#' The `filter()` function is used to subset an object, returning the observations
#' that satisfy your conditions. An observation must return TRUE for all conditions
#' within a context to be retained. Note, to guarantee a valid
#' `PlySummarizedExperiment` is returned, filtering in the `assays` evaluation
#' context is disabled.
#'
#' @param .data An object Inheriting from `PlySummarizedExperiment`, the wrapper
#' class for `SummarizedExperiment` objects
#' @param ... conditions to filter on. These must be wrapped in `cols()` and or
#' `rows()`
#' @param .preserve Relevant when the .data input is grouped. If .preserve = FALSE
#' (the default), the grouping structure is recalculated based on the resulting data,
#' i.e. the number of groups may change.
#' @return an object inheriting `PlySummarizedExperiment` class
#' @examples
#' # example code
#' filter(
#'   se_simple,
#'   rows(length > 30),
#'   cols(condition == "drug")
#' )
#'
#' filter(
#'   se_simple,
#'   rows(rowSums(.assays_asis$counts) > 40),
#'   cols(colSums(.assays_asis$counts) < 50)
#' )
#'
#' # assay context is disabled
#' filter(
#'   se_simple,
#'   counts > 12
#' ) |> try()
#'
#' # convert to `data.frame` first
#' as.data.frame(se_simple) |>
#'   filter(counts > 12)
#'
#' @export
filter.PlySummarizedExperiment <- function(.data, ..., .preserve = FALSE) {
  plyxp(.data, filter_se_impl, ..., .preserve = .preserve)
}

filter_se_impl <- function(.data, ..., .preserve = FALSE) {
  .env <- caller_env()
  .groups <- group_data_se_impl(.data)
  mask <- new_plyxp_manager.SummarizedExperiment(obj = .data)
  poke_ctx_local("plyxp:::caller_env", .env)
  poke_ctx_local("plyxp:::manager", mask)
  poke_ctx_local("plyxp:::dplyr_verb", "filter")
  quos <- plyxp_quos(..., .ctx = c("assays", "rows", "cols"))
  ctxs <- vapply(quos, attr, FUN.VALUE = "", which = "plyxp:::ctx")
  if (any(err <- ctxs %in% "assays")) {
    plyxp_assays_cannot(do = "filter", review = err)
  }
  nms <- names(quos)
  mask <- plyxp_evaluate(mask, quos, ctxs, nms, .env)
  results <- mask$results()
  filter_ <- ""
  if (!is_empty(results$rows)) {
    row_logic <- vctrs::vec_cast_common(
      splice(results$rows),
      .to = logical()
    ) |>
      splice() |>
      vec_recycle_common() |>
      reduce(`&`)
    filter_ <- "row"
  }
  if (!is_empty(results$cols)) {
    col_logic <- vctrs::vec_cast_common(
      splice(results$cols),
      .to = logical()
    ) |>
      splice() |>
      vec_recycle_common() |>
      reduce(`&`)
    filter_ <- paste0(filter_, "col")
  }
  switch(filter_,
    rowcol = plyxp_slice_se(.data, row_logic, col_logic, .preserve = .preserve),
    row = plyxp_slice_se(.data, row_logic, .preserve = .preserve),
    col = plyxp_slice_se(.data, , col_logic, .preserve = .preserve),
    .data
  )
}

plyxp_assays_cannot <- function(do, review) {
  cli::cli_abort(
    message = c(
      "Cannot {do} in `assays` context",
      "x" = sprintf(
        "review expression: %s",
        paste0("..", which(review), collapse = ", ")
      ),
      "i" = "consider wrapping expressions in rows(...) or cols(...)"
    ),
    call = caller_env()
  )
}


plyxp_should_not_named <- function(fun) {
  cli::cli_abort(
    message = c(
      "Expressions should not be named in {.fun {fun}}",
      "i" = "did you mean to use `==` instead of `=`?"
    ),
    call = caller_env()
  )
}

#' @include vctrs-S4-.R

#' @title replicate a vector
#' @name vctrs-vec_rep
#' @description
#' A re-export of [`vctrs::vec_rep`][vctrs::vec_rep] and
#' [`vctrs::vec_rep_each`][vctrs::vec_rep_each] as an S7 generic
#' function to allow `S4Vectors`.
#' @inheritParams vctrs::vec_rep
#' @return a new S3 or S4 vector replicated by specified times
#' @examples
#' vec_rep(1:2, times = 5)
#' vec_rep(S4Vectors::Rle(1:2), times = 5)
#'
#' vec_rep_each(1:2, times = 5)
#' vec_rep_each(S4Vectors::Rle(1:2), times = 5)
#' @export
vec_rep <- new_generic("vec_rep",
  dispatch_args = "x",
  function(x, times, ...,
           error_call = caller_env(), x_arg = "x",
           times_arg = "times") {
    S7_dispatch()
  }
)

method(vec_rep, class_vctrs) <- function(x, times, ...,
                                         error_call = caller_env(), x_arg = "x",
                                         times_arg = "times") {
  vctrs::vec_rep(x = x, times = times, ..., x_arg = x_arg, times_arg = times_arg, error_call = error_call)
}

method(vec_rep, class_s4_vctrs) <- function(x, times, ...,
                                            error_call = caller_env(),
                                            x_arg = "x",
                                            times_arg = "times") {
  times <- vctrs::vec_cast(times, integer(1), x_arg = times_arg)
  if (length(length) != 1L) rlang::abort("`times` must be a single number")
  rep(x, times)
}

#' @rdname vctrs-vec_rep
#' @export
vec_rep_each <- new_generic("vec_rep_each",
  dispatch_args = "x",
  function(x, times, ...,
           error_call = caller_env(), x_arg = "x",
           times_arg = "times") {
    S7_dispatch()
  }
)

method(vec_rep_each, class_vctrs) <- function(x, times, ...,
                                              error_call = caller_env(),
                                              x_arg = "x",
                                              times_arg = "times") {
  vctrs::vec_rep_each(
    x = x, times = times, ..., x_arg = x_arg,
    times_arg = times_arg, error_call = error_call
  )
}

method(vec_rep_each, class_s4_vctrs) <- function(x, times, ...,
                                                 error_call = caller_env(),
                                                 x_arg = "x",
                                                 times_arg = "times") {
  times <- vctrs::vec_cast(times, integer(1), x_arg = times_arg)
  if (length(length) != 1L) rlang::abort("`times` must be a single number")
  rep(x, each = times)
}

sep_ <- function(n) {
  x <- vctrs::vec_rep("|", times = n)
  class(x) <- "sep!"
  x
}

#' @export
`vec_ptype_abbr.sep!` <- function(x, ..., prefix_named, suffix_shape) {
  NULL
}

class_vec_phantom <- S7::new_S3_class("vec_phantom")

#' @rdname plyxp-printing
#' @export
vec_phantom <- function(x) {
  vctrs::new_vctr(
    seq_len(length.out = length(x)),
    phantomData = x,
    class = "vec_phantom"
  )
}

#' @export
vec_restore.vec_phantom <- function(x, to, ...) {
  # cannot make assumptions on what
  # the phantomData is, we use base subset
  phantom_data <- vec_slice(attr(to, "phantomData"), x)
  vec_phantom(phantom_data)
}

#' @export
vec_ptype_abbr.vec_phantom <- function(x, ...) {
  vec_ptype_abbr(attr(x, "phantomData"), ...)
}

# x <- vec_phantom(letters)
# attr(x[1], "phantomData")

#' @export
pillar_shaft.vec_phantom <- function(x, ...) {
  fmt <- plyxp_pillar_format(attr(x, "phantomData"), ...)
  cur_width <- max(nchar(fmt), 2, na.rm = TRUE)
  min_width <- min(10, cur_width)
  pillar::new_pillar_shaft_simple(
    formatted = fmt,
    ...,
    width = cur_width,
    min_width = min_width,
    shorten = "mid"
  )
}

#' @name plyxp-printing
#' @title Printing within tibble with S4 objects
#' @description
#' `plyxp` uses [pillar][pillar::pillar-package] for its printing.
#' If you want to change how your S4 object is printed within
#' `plyxp`'s print method, consider writing a method for
#' this function.
#'
#' To print S4 objects in a tibble, `plyxp` hacks a custom
#' integer vector built from [`vctrs`][vctrs::new_vctr] where
#' the S4 object lives in an attribute named "phantomData".
#' You can create your own S4 phantom vector with `vec_phantom()`.
#' This function is not used outside of printing for `plyxp`
#'
#' The default method for formatting a `vec_phantom()` is to call
#' [`showAsCell()`][S4Vectors::showAsCell].
#'
#' @section tidy printing:
#'
#' By default, `plyxp` will not affect the show method for
#' `SummarizedExperiment` objects. The `PlySummarizedExperiment` object will
#' always use the tibble abstraction method. If you want to use tibble
#' abstraction, you may use `use_show_tidy()` to enable or `use_show_default()` #' to disable this feature. These functions are called for their side effects, #' modifying the global option
#' "show_SummarizedExperiment_as_tibble_abstraction".
#'
#' To show an object as the tibble abstraction regardless of the set option,
#' use the S3 generic `show_tidy(...)`.
#'
#'
#' @param x The S4 object
#' @param ... other arguments passed from [`pillar_shaft`][pillar::pillar_shaft]
#' @examples
#'
#' if (require("IRanges")) {
#'   ilist <- IRanges::IntegerList(list(c(1L, 2L, 3L), c(5L, 6L)))
#'   phantom <- vec_phantom(ilist)
#'   pillar::pillar_shaft(phantom)
#'
#'   plyxp_pillar_format.CompressedIntegerList <- function(x) {
#'     sprintf("Int: [%i]", lengths(x))
#'   }
#'   print(pillar::pillar_shaft(phantom))
#'   rm(plyxp_pillar_format.CompressedIntegerList)
#' }
#'
#' # default printing for PlySummarizedExperiment object
#' se_simple
#' # default printing for SummarizedExperiment object
#' se <- se(se_simple)
#' se
#' # use `plyxp` tibble abstraction
#' use_show_tidy()
#' se
#' # restore default print
#' use_show_default()
#' se
#' # explicitly using tibble abstraction
#' show_tidy(se)
#'
#' @returns
#' `plyxp_pillar_format` -> formatted version of your S4 vector
#' `vec_phantom` -> integer vector with arbitrary object in `phatomData` attribute.
#' @export
plyxp_pillar_format <- function(x, ...) {
  UseMethod("plyxp_pillar_format")
}

#' @export
plyxp_pillar_format.default <- function(x, ...) {
  S4Vectors::showAsCell(x)
}

maybe_phantom <- function(x) {
  if (isS4(x)) {
    return(vec_phantom(x))
  }
  x
}

#' @export
length.vec_phantom <- function(x, ...) {
  length(attr(x, "phantomData"))
}

#' @rdname plyxp-printing
#' @export
show_tidy <- function(x, ...) {
  UseMethod("show_tidy")
}

#' @export
show_tidy.default <- function(x, ...) {
  methods::show(object = x)
}

#' @export
show_tidy.SummarizedExperiment <- function(x, n = 10, ...) {
  top_n <- ceiling(n / 2)
  bot_n <- floor(n / 2)
  onr <- nr <- nrow(x)
  row_slice <- if (nr < 2 * n) {
    seq_len(nr)
  } else {
    c(seq_len(n), (nr - n + 1):nr)
  }

  onc <- nc <- ncol(x)
  col_slice <- if (nc < 2 * n) {
    seq_len(nc)
  } else {
    c(seq_len(n), (nc - n + 1):nc)
  }
  # get first 5 and last 5 rows and cols
  x_ <- x[row_slice, col_slice]
  nr <- nrow(x_)
  nc <- ncol(x_)
  .features <- rownames(x_) %||% seq_len(onr)[row_slice]
  .samples <- colnames(x_) %||% seq_len(onc)[col_slice]
  assays_ <- map(assays(x_), as_vec)
  row_ <- map(rowData(x_), vec_rep, times = nc) |> map(maybe_phantom)
  col_ <- map(colData(x_), vec_rep_each, times = nr) |> map(maybe_phantom)
  nn <- nc * nr
  out <- c(
    list(
      .features = vctrs::vec_rep(.features, times = nc),
      .samples = vctrs::vec_rep_each(.samples, times = nr)
    ),
    list(sep_(nn)),
    assays_,
    list(sep_(nn)),
    row_,
    list(sep_(nn)),
    col_
  )
  #
  attr(out, "row.names") <- c(NA_integer_, -nn)
  class(out) <- c("SE_abstraction", "tbl_df", "tbl", "data.frame")

  #
  sub_seq <- if (nn < 2 * top_n) {
    seq_len(nn)
  } else {
    c(
      seq_len(top_n),
      (nn - bot_n + 1):nn
    )
  }
  # if (diff(min(top_half):max(bot_half)))
  out_sub <- out[sub_seq, ]

  if (nrow(out_sub) == nn) {
    attr(out_sub, "plyxp:::has_break_at") <- 0L
  } else {
    attr(out_sub, "plyxp:::has_break_at") <- max(top_n)
  }
  attr(out_sub, "plyxp:::data") <- x
  print(out_sub, n = n, ...)
  invisible(x)
}

collapse <- function(x) {
  paste(x, collapse = ", ")
}

#' @export
format.plyxp_pillar_rid_type <- function(x, width = NULL, ...) {
  ""
}

#' @export
format.plyxp_pillar_rid_shaft <- function(x, width, ...) {
  new_ornament(
    style_subtle(
      align(x$row_ids, width = width, align = "right")
    ),
    width = width,
    align = "right"
  )
}

#' @export
ctl_new_rowid_pillar.SE_abstraction <- function(
  controller,
  x,
  width,
  ...,
  title = NULL,
  type = NULL
) {
  if (val <- attr(controller, "plyxp:::has_break_at")) {
    #
    template <- names(
      ctl_new_pillar(controller, vector(), width, title = title)
    )
    if (!length(template)) {
      return(NULL)
    }
    out <- map(set_names(template), function(.x) "")
    top_half <- seq_len(val)
    bot_half <- rev(seq_len(nrow(controller) - (val + 1L)))
    data <- if (length(bot_half)) {
      spec <- sprintf("n-%i", bot_half)
      c(
        top_half,
        align(
          c(spec, "n"),
          align = "left"
        )
      )
    } else {
      c(top_half, "n")
    }
    if ("type" %in% template) {
      out$type <- pillar_component(
        structure(
          list(),
          class = "plyxp_pillar_rid_type",
          width = 1L
        )
      )
    }
    data <- new_pillar_shaft(
      list(row_ids = data),
      width = max(nchar(data)),
      class = "plyxp_pillar_rid_shaft"
    )
    if ("data" %in% template) {
      out$data <- pillar_component(data)
    }
    new_pillar(out, width = attr(data, "width", exact = TRUE))
  } else {
    NextMethod()
  }
}

#' @export
`pillar_shaft.sep!` <- function(x, ...) {
  new_pillar_shaft_simple(
    style_subtle(x),
    align = "left",
    min_width = 1L
  )
}

#' @export
tbl_sum.SE_abstraction <- function(x) {
  se <- attr(x, "plyxp:::data")
  out <- dim_desc(se)
  out <- sprintf("A %s-tibble Abstraction: %s", class(se), out)
  # names(out) <- sprintf("A %s-tibble Abstraction", class(se))
  if (!is.null(groups <- group_data_se_impl(se))) {
    gv <- group_vars_se_impl(se)
    vars <- c(
      if (!is_empty(gv$row_groups)) {
        sprintf("rows(%s)", collapse(gv$row_groups))
      },
      if (!is_empty(gv$col_groups)) sprintf("cols(%s)", collapse(gv$col_groups))
    )
    out <- c(out, sprintf("Groups: %s", collapse(vars)))
  }
  out
}

#' @export
tbl_format_setup.SE_abstraction <- function(
  x,
  width,
  ...,
  n,
  max_extra_cols,
  max_footer_lines,
  focus
) {
  # pillar 1.10.0 now passes 'setup' as NULL on first call
  # If we fail to check, the setup$body will always be NULL
  dots_setup <- ...names() %in% "setup"
  is_first_call <- any(dots_setup) && is.null(...elt(which(dots_setup)))
  setup <- NextMethod()
  setup$rows_total <- prod(dim(attr(x, "plyxp:::data")))
  # on second call, setup$body should exist
  if (
    !is_first_call &&
      !is.null(setup$body) &&
      (val <- attr(x, "plyxp:::has_break_at"))
  ) {
    body_idx <- val + 2L
    prev_line <- cli::ansi_strip(setup$body[body_idx])
    position <- gregexec("[^ |]+", prev_line)[[1]]
    len <- attr(position, "match.length")
    new_line <- vctrs::vec_rep(" ", times = nchar(prev_line))
    new_line[position + floor(len / 2)] <- style_subtle(cli::symbol$continue)
    setup$body <- append(
      setup$body,
      paste(new_line, collapse = ""),
      body_idx
    ) |>
      glue::as_glue()
  }
  setup
}

#' @export
ctl_new_pillar.SE_abstraction <- function(
  controller,
  x,
  width,
  ...,
  title = NULL
) {
  if (inherits(x, "sep!")) {
    p <- pillar(x, title = "|", ...)
    class(p$title[[1]]) <- "blank_pillar_title"
    class(p$type[[1]]) <- "blank_pillar_type"
    attr(p$type, "width") <- 1L
    attr(p$type, "min_width") <- 1L
    attr(p$type[[1]], "width") <- 1L
    attr(p$type[[1]], "min_width") <- 1L
    p
  } else {
    NextMethod()
  }
}

#' @export
tbl_format_footer.SE_abstraction <- function(x, setup, ...) {
  out <- NextMethod()
  if (attr(x, "plyxp:::has_break_at")) {
    out <- c(
      style_subtle(
        sprintf(
          "# %s n = %s",
          cli::symbol$info,
          format(
            setup$rows_total,
            big.mark = ",",
            scientific = FALSE,
            digits = 1
          )
        )
      ),
      out
    )
  }
  out
}

#' @export
format.blank_pillar_type <- function(x, width, ...) {
  style_subtle("|")
}

#' @export
format.blank_pillar_title <- format.blank_pillar_type

setMethod(
  f = "show",
  signature = "SummarizedExperiment",
  definition = function(object) {
    if (
      isTRUE(
        x = getOption(
          x = "show_SummarizedExperiment_as_tibble_abstraction",
          default = FALSE
        )
      )
    ) {
      show_tidy(object)
    } else {
      methods::getMethod(
        f = "show",
        signature = "SummarizedExperiment",
        where = asNamespace(ns = "SummarizedExperiment")
      )(object)
    }
  }
)

#' @rdname plyxp-printing
#' @export
use_show_tidy <- function() {
  options(show_SummarizedExperiment_as_tibble_abstraction = TRUE)
}

#' @rdname plyxp-printing
#' @export
use_show_default <- function() {
  options(show_SummarizedExperiment_as_tibble_abstraction = FALSE)
}

test_that("Default printing is `SummarizedExperiment`", {
  expect_snapshot(se(se_simple))
})

test_that("enabling `plyxp` printing", {
  expect_snapshot({
    use_show_tidy()
    se(se_simple)
  })
})

test_that("re-enabling default printing", {
  expect_snapshot({
    use_show_default()
    se(se_simple)
  })
})

test_that("force `plyxp` printing", {
  expect_snapshot(show_tidy(se(se_simple)))
})

test_that("printing `PlySummarizedExperiment` as is", {
  expect_snapshot(se_simple)
})

test_that("printing `PlySummarizedExperiment` with `show_tidy()`", {
  expect_snapshot({
    show_tidy(se_simple)
  })
})

#' @export
.AtNames.plyxp_envs <- function(x, pattern = "") {
  options <- setdiff(names(attributes(x)), c("class", "names"))
  if (identical(pattern, "")) {
    options
  } else {
    grep(pattern, options, value = TRUE)
  }
}

#' @export
`@.plyxp_envs` <- function(obj, name) {
  attr(obj, name, exact = TRUE)
}

#' @export
`@<-.plyxp_envs` <- function(obj, name, value) {
  attr(obj, name) <- value
  invisible(obj)
}

#' @title New Mask Binding Function
#' @description
#' Utility function to make new bindings on the fly.
#' @param .expr an expression that will be evaluated and bound in `.env_expr`.
#' It is recommened to use `base::quote()` so that `.expr` can contain diffusion
#' operators such as `!!`
#' @param .env_expr the environment that `.expr` is evaluated in, such as a quosure
#' @param .env_bind where the expression will be bound
#' @param type the type of binding function to implement, "standard",
#'  "lazy", or "active"
#' @return a function taking a single argument `name` and performs a binding
#' determined by `type`.
#' @keywords internal
#' @examples
#'
#' # example code
#'
#' env <- new_environment(
#'   list(
#'     .iris = iris,
#'     .nrow = 10
#'   ),
#'   baseenv()
#' )
#' binding_func <- add_bind(
#'   .expr = quote(lapply(seq_len(.nrow),
#'     function(i, x) x[i],
#'     x = .iris[[!!name]]
#'   )),
#'   .expr_env = env,
#'   type = "lazy"
#' )
#' binding_func("Sepal.Width")
#' env$Sepal.Width
#' @noRd
add_bind <- function(.expr, .env_expr,
                     .env_bind = .env_expr,
                     type = c("standard", "lazy", "active")) {
  # type <- match.arg(type, c("standard", "lazy", "active"))
  fun <- switch(type,
    standard = expr(env_bind),
    lazy = expr(env_bind_lazy),
    active = expr(env_bind_active)
  )
  name_unquo <- quote(!!name)
  quosure_unquo <- quote(!!quosure)
  if (type == "active") {
    new_function(
      args = alist(name = ),
      body = expr({
        name_sym <- as.name(name)
        actv_fun <- new_function(pairlist(),
          inject(quote(!!.expr)),
          env = !!.env_expr
        )
        # active_fun <- eval_tidy(quosure, data = as_data_mask(base::baseenv()))
        (!!fun)(!!.env_bind, !!name_unquo := actv_fun)
      })
    )
  } else {
    new_function(
      args = alist(name = ),
      body = expr({
        name_sym <- as.name(name)
        quosure <- new_quosure(expr(!!.expr), env = !!.env_expr)
        (!!fun)(!!.env_bind, !!name_unquo := !!quosure_unquo)
      })
    )
  }
}

## due to challenges in passing BiocCheck, no longer documenting non-exported
## objects

#' @title `plyxp` Data Mask Object
#' @name plyxp_mask
#' @description
#' An R6 Object that tracks bindings of a list-like object.
#' This includes DFrame objects. There are several inherited
#' environments that the data is stored within.
#'
#' Environments:
#'
#' .shared_env --> curr_group_ctx --> foreign --> lazy --> chops --> active_mask
#'
#' * .shared_env : environment provided at initialization. This may be shared
#'                 with multiple other BiocDataMasks.
#' * curr_group  : Currently not used.
#' * foreign     : space to put foreign bindings, i.e. object unrelated to `.data`
#'                 provided at initialization. This space is currently used to
#'                 place the pronouns into related contexts.
#' * lazy        : A strict lazy binding to the data within `.data`. This binding
#'                 is made only at initialization.
#' * chops       : lazy data but chopped into list by `.indices`. New bindings
#'                 for this BiocDataMask context are expected to be in a
#'                 "chopped" format and are assigned here.
#' * active_mask : An active binding to chops in which the proper list index is
#'                 used depending on the current group context. The current group
#'                 context is at this moment determined by the .shared_env NOT
#'                 the curr_group. I have plans to remove the curr_group
#'                 environment.
#'
#' @return an R6 object of class `plyxp`
#' @examples
#' # note: this R6 class is not exported at this moment
#'
#' mask <- getNamespace("plyxp")$plyxp_masknew(iris,
#'   .env_bot = rlang::env(`plyxp:::ctx:::group_id` = 1L)
#' )
#' mask$eval(quote(Sepal.Width))
#'
#' @noRd
plyxp_mask <- R6::R6Class(
  "plyxp_mask",
  cloneable = FALSE,
  public = list(
    #' @description
    #' Create a plyxp from `.data`. `.data` is chopped by
    #' `.indices`, and environments are built from `.env`
    #'
    #' @param .data a named list like object to create a mask
    #' @param .indices the indices that will be used to chop `.data`
    #' @param .env_bot an environment that the resulting mask will be built
    #' from.
    #' @param .env_top an environment that `.env_bot` inherits from
    initialize = function(.data, .indices = NULL,
                          .env_bot, .env_top = .env_bot) {
      private$.shared_env <- .env_bot
      private$.top_env <- .env_top
      private$.data <- .data
      private$.indices <- .indices
      private$init_current_group_info()

      private$.names <- setNames(nm = names(.data))
      private$.ptype <- lapply(.data, vec_slice, i = 0L)
      private$.env_size <- length(private$.names) + 20L

      private$init_foreign_data()

      private$init_data_lazy()

      private$init_data_chop()

      # get current chop
      private$init_mask_bind()

      private$init_environments()
      invisible(self)
    },
    #' @description
    #' appends a callback function that is executed after a value is bound
    #' to this mask. Mainly used to inform other masks of new values
    #'
    #' @param .fun a function created from `add_bind()`
    on_bind = function(.fun) {
      private$.on_bind <- append(private$.on_bind, .fun)
      invisible(self)
    },
    #' @description
    #' binds value to an name within the chops environment.
    #'
    #' @param name a character scalar
    #' @param value results from `$eval` in the form of chops
    bind = function(name, value) {
      needs_unbind <- private$.bind_self(name, value)
      # needs_unbind <- private$push(name)
      binding_funcs <- private$.on_bind
      if (needs_unbind) {
        for (i in seq_along(binding_funcs)) {
          func <- binding_funcs[[i]]
          env_unbind(environment(func)$.env_bind, name)
          func(name)
        }
      } else {
        for (func in binding_funcs) {
          func(name)
        }
      }
      invisible(value)
    },
    #' @param name name of binding to retrieve chopped
    get_chop = function(name) {
      private$env_data_chop[[name]]
    },
    #' @param name name of binding to retrieve and unchop
    unchop = function(name) {
      data <- self$get_chop(name)
      if (is.null(data)) {
        return(NULL)
      }
      if (is.null(private$.indices)) {
        .subset2(data, 1L)
      } else {
        list_unchop(
          data,
          indices = private$.indices
        )
      }
    },
    #' @description
    #' finds all newly added values and returns an unchopped result
    #' @return named list of evaluated expression, unchopped
    results = function() {
      added <- private$.added
      names(added) <- added
      lapply(added, self$unchop)
    },
    #' @description
    #' evaluates a quoted expression within a new datamask
    #' @param quo a quosure to evaluate
    #' @param env an environment to search after mask
    eval = function(quo, env = caller_env()) {
      mask <- new_data_mask(private$env_mask_bind, top = private$.top_env)
      trans <- attr(quo, "plyxp:::transform")
      if (!is.null(trans)) {
        exp <- quo_get_expr(quo)
        quo <- quo_set_expr(
          quo,
          expr((!!exp) |> (!!trans)())
        )
        if (identical(emptyenv(), quo_get_env(quo))) {
          quo <- quo_set_env(quo, env)
        }
      }
      eval_tidy(quo, data = mask, env = env)
    }
  ),
  active = list(
    #' @field environments the hierarchy of environments for this mask
    environments = function() {
      private$.environments
    },
    #' @field names the associated names of data in mask
    names = function() {
      private$.names
    },
    #' @field ptype get zero-length slices of underlying data
    ptype = function() {
      private$.ptype
    },
    #' @field added newly added names to the mask
    added = function() {
      private$.added
    }
  ),
  private = list(
    init_current_group_info = function() {
      private$env_current_group_info <- new_environment(
        list(
          .indices = private$.indices
        ),
        private$.shared_env
      )
    },
    init_foreign_data = function() {
      private$env_foreign_data <- new.env(parent = private$env_current_group_info)
    },
    init_data_lazy = function() {
      .data <- private$.data
      # normal data ... do we need it to be lazy??
      private$env_data_lazy <- new.env(
        parent = private$env_foreign_data,
        size = private$.env_size
      )
      env_bind_lazy(
        private$env_data_lazy,
        !!!lapply(private$.names, function(x) quo(.data[[!!x]]))
      )
    },
    init_data_chop = function() {
      # chops
      private$env_data_chop <- new.env(
        parent = private$env_data_lazy,
        size = private$.env_size
      )
      private$handle_chops(private$.indices)
      env_bind_lazy(
        private$env_data_chop,
        !!!lapply(private$.names, as.name) |>
          lapply(private$chop_data) |>
          lapply(new_quosure,
            env = private$env_data_lazy
          )
      )
    },
    init_mask_bind = function() {
      private$env_mask_bind <- new.env(parent = private$env_data_chop, size = private$.env_size)
      env_bind_active(
        private$env_mask_bind,
        !!!lapply(private$.names,
          function(name, env) {
            name <- sym(name)
            new_function(
              args = pairlist(),
              body = expr(.subset2(!!name, `plyxp:::ctx:::group_id`)),
              env = env
            )
          },
          env = private$env_data_chop
        )
      )
    },
    init_environments = function() {
      out <- c(
        list(private$env_mask_bind),
        env_parents(private$env_mask_bind, private$.shared_env)
      )
      class(out) <- c("plyxp_envs", "rlang_envs")
      attr(out, "env_mask_bind") <- private$env_mask_bind
      attr(out, "env_data_chop") <- private$env_data_chop
      attr(out, "env_data_lazy") <- private$env_data_lazy
      attr(out, "env_foreign_data") <- private$env_foreign_data
      attr(out, "env_current_group_info") <- private$env_current_group_info
      private$.environments <- out
      invisible(NULL)
    },
    handle_chops = function(indices) {
      private$.indices <- indices
      private$.ngroups <- if (is.null(indices)) 1L else length(indices)
      fun <- private$get_chop_fun()
      test_output <- fun(test)
      stopifnot(is_expression(test_output))
      # environment(fun) <- private$env_data_lazy
      private$chop_data <- fun
      invisible(self)
    },
    # extending function
    get_chop_fun = function() {
      if (is.null(private$.indices)) {
        function(name) {
          name <- enexpr(name)
          expr(list(!!name))
        }
      } else {
        function(name) {
          name <- enexpr(name)
          expr(vec_chop(!!name, indices = .indices))
        }
      }
    },
    # function to chop data
    chop_data = NULL,
    # @param name scalar character vector
    # @param value vector in the form of chops
    .bind_self = function(name, value) {
      private$env_data_chop[[name]] <- value
      name_sym <- sym(name)
      fun <- new_function(
        args = pairlist(),
        body = expr(.subset2(!!name_sym, `plyxp:::ctx:::group_id`)),
        env = private$env_data_chop
      )
      env_bind_active(
        private$env_mask_bind,
        !!name := fun
      )


      needs_unbind <- name %in% private$.names
      private$.names[name] <- name
      private$.added[name] <- name
      private$.ptype[[name]] <- vec_slice(value[[1]], 0L)
      invisible(needs_unbind)
    },
    .on_bind = list(),
    # data input
    .data = NULL,
    # list of indices
    .indices = NULL,
    # type of grouping, "none", "group"
    .grouped = NULL,
    .ngroups = NULL,
    .environments = NULL,
    # names of `.data`
    .names = NULL,
    # size 0 vectors of `.data`
    .ptype = NULL,
    # newly added names
    .added = character(),
    push = function(name) {
      needs_unbind <- name %in% private$.names
      private$.names <- union(private$.names, name)
      private$.added <- union(private$.added, name)
      invisible(needs_unbind)
    },
    # initial size of environments
    # number of elements of `.data` + 20L
    .env_size = NULL,
    .shared_env = NULL,
    .top_env = NULL, # should at least inherit from `baseenv()`
    #' holds grouping information
    #' for this object
    env_current_group_info = NULL,
    #' foreign bindings
    env_foreign_data = NULL,
    env_data_lazy = NULL,
    env_data_chop = NULL,
    env_mask_bind = NULL
  )
)


#' @title `plyxp` for SummarizedExperiment `assays()`
#' @name plyxp_mask-assays
#' @description
#' A more specialized version of the plyxp R6 object for the
#' assays list object. This includes chopping and unchopping
#' of matrix like objects.
#' @return an object inheriting [`plyxp`][plyxp::BiocDataMask].
#' @noRd
plyxp_assay <- R6::R6Class(
  "plyxp_assay",
  inherit = plyxp_mask,
  cloneable = FALSE,
  public = list(
    #' @description
    #' Create a plyxp from `.data`. `.data` is chopped by
    #' `.indices`, and environments are built from `.env`
    #'
    #' @param .data a named list like object to create a mask
    #' @param .indices the indices that will be used to chop `.data`
    #' @param .env_bot an environment that the resulting mask will be built from.
    #' @param .env_top an environment that `.env_bot` inherits from
    #' @param .nrow,.ncol the number of rows and columns of each element of `.data` respectively
    initialize = function(.data, .indices, .env_bot, .env_top = .env_bot, .nrow, .ncol) {
      super$initialize(.data, .indices = .indices, .env_bot = .env_bot, .env_top = .env_top)
      env_bind(
        private$env_current_group_info,
        .nrow = .nrow,
        .ncol = .ncol
      )
      private$.nrow <- .nrow
      private$.ncol <- .ncol
    },
    #' @description
    #' unchop data within the mask, returns a matrix
    #' @param name name of binding to retrieve and unchop
    unchop = function(name) {
      data <- self$get_chop(name)
      unchopped <- if (is.null(private$.indices)) {
        .subset2(data, 1L)
      } else {
        list_unchop(
          lapply(data, as.vector),
          indices = private$.indices
        )
      }
      if (is.null(unchopped)) {
        return(unchopped)
      }
      matrix(
        unchopped,
        nrow = private$.nrow,
        ncol = private$.ncol
      )
    }
  ),
  private = list(
    get_chop_fun = function() {
      .indices <- private$.indices
      if (is.null(.indices)) {
        # private$.e <- private$.env_col_chop <- private$env_data_chop
        return(function(name) {
          name <- enexpr(name)
          expr(list(!!name))
        })
      } else {
        # .indices would have been created by get_group_indices()
        #
        # type <- attr(.indices, "type")
        private$.ngroups <- length(.indices)
        fun <- function(name) {
          name <- enexpr(name)
          expr(chop_assays_outer(!!name, .indices))
        }
        return(fun)
      }
    },
    .nrow = NULL,
    .ncol = NULL
  )
)

# gbm <- group_by(se_simple, rows(direction), cols(condition)) |>
#   new_plyxp_manager()
#
# assays_mask <- bm$masks[["assays"]]
# rows_mask <- bm$masks[["cols"]]
# cols_mask <- bm$masks[["rows"]]

test_that("evaluation works", {
  bm <- plyxp:::new_plyxp_manager(se(se_simple))
  expect_error(bm$eval(rlang::quo("foo")), "requires quosure from")
  quo <- plyxp:::plyxp_quos(
    foo = rep(1L, n()),
    rows(foo = rep(1L, n())),
    cols(foo = rep(1L, n())),
    .ctx = c("assays", "rows", "cols")
  )
  bm$eval(quo[[1]])
  bm$ctx <- "rows"
  bm$eval(quo[[2]])
  bm$ctx <- "cols"
  bm$eval(quo[[3]])
  res <- bm$results()
  expect_identical(sum(res$assays$foo), 20L)
  expect_identical(sum(res$rows$foo), 5L)
  expect_identical(sum(res$cols$foo), 4L)
})

quos <- plyxp:::plyxp_quos(
  foo,
  ctx2(foo),
  ctx3(foo),
  .ctx = c("ctx1", "ctx2", "ctx3")
)
foo_sym <- quote(foo)

test_that("`plyxp_quos` returns list of quosures", {
  expect_type(quos, "list")
  expect_s3_class(quos[[1]], "quosure")
  expect_s3_class(quos[[2]], "quosure")
  expect_s3_class(quos[[3]], "quosure")
})

test_that("sentinel quosures return inner expressions", {
  expect_identical(rlang::quo_get_expr(quos[[1]]), foo_sym)
  expect_identical(rlang::quo_get_expr(quos[[2]]), foo_sym)
  expect_identical(rlang::quo_get_expr(quos[[3]]), foo_sym)
})


test_that("quosures contain correct context attribute", {
  expect_attr_val <- function(object, attr, expected) {
    act <- quasi_label(rlang::enquo(object), arg = "object")
    act$attr <- attr(act$val, which = attr, exact = TRUE)
    expect(
      ok = !is.null(act$attr),
      sprintf("%s does not have attribute `%s`", act$lab, attr)
    )
    expect(
      ok = act$attr == expected,
      sprintf(
        "%s's `%s` attribute was %s, expected %s", act$lab, attr,
        act$attr, expected
      )
    )
    invisible(act$val)
  }
  expect_attr_val(quos[[1]], "plyxp:::ctx", "ctx1")
  expect_attr_val(quos[[2]], "plyxp:::ctx", "ctx2")
  expect_attr_val(quos[[3]], "plyxp:::ctx", "ctx3")
})



test_that("`:=` works within contexts", {
  foo <- "bar"
  quos <- plyxp:::plyxp_quos(
    "{foo}" := foo,
    ctx2("{foo}" := foo),
    ctx3("{foo}" := !!foo),
    .ctx = c("ctx1", "ctx2", "ctx3")
  )

  expect_identical(names(quos), c("bar", "bar", "bar"))
  expect_identical(rlang::quo_get_expr(quos[[1]]), foo_sym)
  expect_identical(rlang::quo_get_expr(quos[[2]]), foo_sym)
  expect_identical(rlang::quo_get_expr(quos[[3]]), "bar")
})

#' @name group_data
#' @title get grouping data
#' @description
#' retrieve grouping information from a `SummarizedExperiment` object. This
#' is stored within the `metadata()` of the object.
#' @aliases ungroup
#' @param .data An object Inheriting from `PlySummarizedExperiment`, the wrapper
#' class for `SummarizedExperiment` objects
#' @return list of groupings for an SummarizedExperiment
#' @examples
#' group_by(se_simple, rows(direction), cols(condition)) |> group_data()
#' @export
group_data.PlySummarizedExperiment <- function(.data) {
  group_data_se_impl(se(.data))
}

group_data_se_impl <- function(.data) {
  out <- list(
    row_groups = group_data_DF_impl(rowData(.data)),
    col_groups = group_data_DF_impl(colData(.data))
  )
  if (all(vapply(out, is.null, FUN.VALUE = FALSE))) {
    return(NULL)
  }
  structure(out, class = "plyxp_groups")
}

# when setting grouping data, if field is absent or NULL
# then it will have the effect of removing said group.
`group_data_se_impl<-` <- function(.data, value) {
  row_groups <- value[["row_groups"]]
  group_data_DF_impl(rowData(.data)) <- row_groups
  col_groups <- value[["col_groups"]]
  group_data_DF_impl(colData(.data)) <- col_groups
  .data
}

group_data_DF_impl <- function(.data) {
  metadata(.data)[["group_data"]]
}

`group_data_DF_impl<-` <- function(.data, value) {
  if (is.null(value)) {
    metadata(.data)["group_data"] <- value
  } else {
    metadata(.data)[["group_data"]] <- value
  }

  .data
}


#' @name group_by
#' @title apply groups to PlySummarizedExperiment
#' @description
#' create grouping variables about the rowData and colData of a
#' `PlySummarizedExperiment` object. Unlike the `data.frame` method
#' the resulting output class is left unchanged. Thus `dplyr` generics for
#' `PlySummarizedExperiment` must check grouping information manually.
#' @param .data An object Inheriting from `PlySummarizedExperiment`, the wrapper
#' class for `SummarizedExperiment` objects
#'
#' ## S4 Compatibility
#'
#' At the moment, grouping on S4 Vectors is not yet supported. This is due to
#' `plyxp` using `[vec_group_loc][vctrs::vec_group_loc]` to form grouping
#' information. `plyxp` will eventually develop a method to handle S4 Vectors.
#'
#' @param ... expressions to group on. Grouping may only be done on
#' rowData and/or colData by `rows()` and `cols()` respectively.
#' @param .add When `FALSE`, the default, `group_by()` will override
#' existing groups.
#' @return `PlySummarizedExperiment` object
#' @examples
#'
#' group_by(se_simple, rows(direction), cols(condition))
#'
#' @export
group_by.PlySummarizedExperiment <- function(.data, ..., .add = FALSE) {
  plyxp(.data, group_by_se_impl, ..., .add = .add)
}

group_by_se_impl <- function(.data, ..., .add = FALSE) {
  #
  .env <- caller_env()
  # to maintain consistency with dplyr
  # force any computations to occur on ungrouped data
  .groups <- group_data_se_impl(.data)
  group_data_se_impl(.data) <- NULL
  mask <- new_plyxp_manager.SummarizedExperiment(obj = .data)
  poke_ctx_local("plyxp:::caller_env", .env)
  poke_ctx_local("plyxp:::manager", mask)
  poke_ctx_local("plyxp:::dplyr_verb", "group_by")
  quos <- plyxp_quos(..., .ctx = c("assays", "rows", "cols"))
  ctxs <- vapply(quos, attr, FUN.VALUE = "", which = "plyxp:::ctx")
  if (any(err <- ctxs %in% "assays")) {
    plyxp_assays_cannot(do = "group_by", review = err)
  }
  nms <- names(quos)
  mask <- plyxp_evaluate(mask, quos, ctxs, nms, .env)
  results <- mask$results()
  # nms <- names(results$assays)
  # for (i in seq_along(results$assays)) {
  #   assays(.data, withDimnames = FALSE)[[nms[i]]] <- results$assays[[i]]
  # }

  if (.add && !is_empty(curr_groups <- group_data_se_impl(.data))) {
    if (!is_empty(curr_groups$row_groups)) {
      curr <- select(curr_groups$row_groups, -starts_with(".indices")) |>
        names()
      curr <- rowData(.data)[curr]
      curr[names(results$rows)] <- results$rows
      results$rows <- curr
    }
    if (!is_empty(curr_groups$col_groups)) {
      curr <- select(curr_groups$col_groups, -starts_with(".indices")) |>
        names()
      curr <- colData(.data)[curr]
      curr[names(results$cols)] <- results$cols
      results$cols <- curr
    }
  }

  rnms <- names(results$rows)
  if (".features" %in% rnms) {
    rownames(.data) <- results$rows$.features
    results$rows$.features <- NULL
    rnms <- names(results$rows)
  }
  if (length(rnms)) {
    row_data <- rowData(.data)
    row_data[rnms] <- results$rows
    # push nms to the front
    row_data <- row_data[c(rnms, setdiff(names(row_data), rnms))]
    rowData(.data) <- row_data
  }


  cnms <- names(results$cols)
  if (".samples" %in% cnms) {
    colnames(.data) <- results$cols$.samples
    results$cols$.samples <- NULL
    cnms <- names(results$cols)
  }
  if (length(cnms)) {
    col_data <- colData(.data)
    col_data[cnms] <- results$cols
    # push nms to the front
    col_data <- col_data[c(cnms, setdiff(names(col_data), cnms))]
    colData(.data) <- col_data
  }
  groups <- plyxp_groups(
    row_groups = rowData(.data)[rnms],
    col_groups = colData(.data)[cnms]
  )
  group_data_se_impl(.data) <- groups
  .data
}

#' @describeIn group_by Ungroup a PlySummarizedExperiment object
#'
#' @param x An object Inheriting from `PlySummarizedExperiment`, the wrapper
#' class for `SummarizedExperiment` objects
#' @param ... [contextual expressions][plyxp::plyxp-context] specifying
#' which columns to ungroup. Omitting `...` ungroups the entire object.
#' @export
ungroup.PlySummarizedExperiment <- function(x, ...) {
  plyxp(x, ungroup_se_impl, ...)
}

ungroup_se_impl <- function(x, ...) {
  quos <- plyxp_quos(
    ...,
    .named = FALSE,
    .ctx = c("assays", "rows", "cols")
  )
  curr_groups <- group_data_se_impl(x)
  if (is_empty(curr_groups)) {
    return(x)
  }
  n_quo <- length(quos)
  if (n_quo == 0L) {
    group_data_se_impl(x) <- NULL
    return(x)
  }
  ctxs <- vapply(quos, attr, FUN.VALUE = "", which = "plyxp:::ctx")
  if (any(err <- ctxs %in% "assays")) {
    plyxp_assays_cannot(do = "ungroup", review = err)
  }
  by_ctx <- split(quos, ctxs)
  update_cols <- update_rows <- NULL
  update_ <- ""
  if (!is_empty(by_ctx$rows) || !is.null(curr_groups$row_groups)) {
    if (is.null(curr_groups$row_groups)) {
      abort("no row groups to ungroup")
    }
    old_groups <- select(curr_groups$row_groups, -starts_with(".indices")) |>
      names()
    select_expr <- call2("c", splice(by_ctx$rows))
    to_remove <- eval_select(
      select_expr,
      data = as.list(rowData(x)),
      allow_rename = FALSE
    )
    to_remove <- names(to_remove)
    new_groups <- setdiff(old_groups, to_remove)
    update_rows <- call2("rows", splice(syms(new_groups)))
    update_ <- "row"
  }
  if (!is_empty(by_ctx$cols) || !is.null(curr_groups$col_groups)) {
    if (is.null(curr_groups$col_groups)) {
      abort("no col groups to ungroup")
    }
    old_groups <- select(curr_groups$col_groups, -starts_with(".indices")) |>
      names()
    select_expr <- call2("c", splice(by_ctx$cols))
    to_remove <- eval_select(
      select_expr,
      data = as.list(colData(x)),
      allow_rename = FALSE
    )
    to_remove <- names(to_remove)
    new_groups <- setdiff(old_groups, to_remove)
    update_cols <- call2("cols", splice(syms(new_groups)))
    update_ <- paste0(update_, "col")
  }
  switch(update_,
    rowcol = group_by_se_impl(x, !!update_rows, !!update_cols),
    row = group_by_se_impl(x, !!update_rows),
    col = group_by_se_impl(x, !!update_cols)
  )
}

#' @export
groups.PlySummarizedExperiment <- function(x) {
  groups_se_impl(se(x))
}

groups_se_impl <- function(x) {
  map(
    group_vars_se_impl(x),
    syms
  )
}

plyxp_curr_groups <- function(x) {
  vars <- groups_se_impl(x)
  row_v <- if (is_empty(vars$row_groups)) {
    NULL
  } else {
    call2("rows", splice(vars$row_groups))
  }
  col_v <- if (is_empty(vars$col_groups)) {
    NULL
  } else {
    call2("cols", splice(vars$col_groups))
  }
  c(row_v, col_v)
}

#' @name group_split
#' @title Split a PlySummarizedExperiment based on groups
#'
#' @description
#' Splits a grouped PlySummarizedExperiment based on groups. Note the elements
#' of the return value are ungrouped PlySummarizedExperiment objects.
#'
#' @param .tbl a PlySummarizedExperiment object
#' @param ... ignored if the `.tbl` is grouped, otherwise it is passed to
#' [plyxp::group_by].
#' @param .keep logical indicating of grouping variables should be kept
#' @return A list of PlySummarizedExperiment objects
#' @examples
#'
#' gse <- group_by(se_simple, rows(direction), cols(condition))
#' gse |> group_split()
#' gse |> group_split(.keep = FALSE)
#'
#' @export
group_split.PlySummarizedExperiment <- function(.tbl, ..., .keep = TRUE) {
  groups <- group_data_se_impl(.tbl)

  quos <- rlang::enquos(...)
  if (!is_empty(quos)) {
    if (!is.null(groups)) {
      rlang::warn("... is ignored when `.tbl` is grouped")
    } else {
      .tbl <- group_by(.tbl, !!!quos)
      groups <- group_data_se_impl(.tbl)
    }
  }
  # grab groups
  group_vars <- group_vars_se_impl(.tbl)

  # always ungroups resulting data
  group_data_se_impl(.tbl) <- NULL
  grouped_rows <- is_grouped_rows(group_vars)
  grouped_cols <- is_grouped_cols(group_vars)
  is_grouped <- grouped_rows || grouped_cols


  if (!.keep && is_grouped) {
    if (grouped_rows) {
      rowData(.tbl) <- rowData(.tbl)[,
        setdiff(
          names(rowData(.tbl)),
          group_vars$row_groups
        ),
        drop = FALSE
      ]
    }
    if (grouped_cols) {
      colData(.tbl) <- colData(.tbl)[,
        setdiff(
          names(colData(.tbl)),
          group_vars$col_groups
        ),
        drop = FALSE
      ]
    }
  }
  type <- paste0(
    c("rows", "cols")[c(grouped_rows, grouped_cols)],
    collapse = ""
  )
  switch(type,
    rows = lapply(
      groups$row_groups$.indices,
      \(i, .data) new_plyxp(.data[i, ]),
      .data = se(.tbl)
    ),
    cols = lapply(
      groups$col_groups$.indices,
      \(j, .data) new_plyxp(.data[, j]),
      .data = se(.tbl)
    ),
    rowscols = map2(
      vctrs::vec_rep(groups$row_groups$.indices, nrow(groups$col_groups)),
      vctrs::vec_rep_each(groups$col_groups$.indices, nrow(groups$row_groups)),
      \(i, j, .data) new_plyxp(.data[i, j]),
      .data = se(.tbl)
    ),
    list(.tbl)
  )
}

# The following functions have a lot of boilerplate code

# whenever new binding in assays, ensure mask_rows has access.
connect_assays_to_rows <- function(mask_assays, mask_rows) {
  assay_names <- mask_assays$names
  size <- length(assay_names) + 20L
  env_mask_bind <- mask_rows$environments[[1]] # last level
  env_asis <- new.env(hash = TRUE, parent = env_mask_bind, size = size)
  env_pronoun <- new.env(hash = TRUE, parent = env_asis, size = size)
  fun_asis <- add_bind(
    quote({
      # assumes !!name_sym is a matrix, if the user transforms a value in
      # assays to a non-matrix, and trys to access it, it may be incorrect
      chops <- `plyxp:::assays:::current_chops`
      data_chop <- .subset(!!name_sym, chops)
      as_is <- do.call("cbind", data_chop)
      if (length(chops) > 1) {
        col_ind <- attr(.indices, "plyxp:::col_chop_ind") |>
          .subset(chops)
        tryCatch(
          {
            as_is <- as_is[, order(list_unchop(col_ind)), drop = FALSE]
          },
          error = function(cnd) {
            if (!inherits(data_chop[[1]], "matrix")) {
              abort(
                paste(
                  "could not reconstruct 'asis' representation.",
                  "Underlying data was not a matrix."
                ),
                call = NULL
              )
            }
            abort("unexpected error", parent = cnd, call = NULL)
          }
        )
      }
      as_is
    }),
    # should be evaluated within the chopped context, cannot guarantee groupings
    .env_expr = mask_assays$environments@env_data_chop,
    .env_bind = env_asis,
    type = "active"
  )
  fun_mold <- add_bind(
    quote(
      lapply(seq_len(`plyxp:::ctx:::n`),
        function(i, x) x[i, , drop = TRUE],
        x = !!name_sym
      )
    ),
    .env_expr = env_asis,
    .env_bind = env_pronoun,
    type = "active"
  )
  walk(assay_names, fun_asis) |>
    walk(fun_mold)
  # whenever a new assay binding is made,
  # execute the prior functions
  mask_assays$on_bind(fun_asis)$on_bind(fun_mold)
  # allow assay data to be seen from rowData context
  mask_rows$environments@env_foreign_data |>
    env_bind(
      .assays_asis = as_data_pronoun(env_asis),
      .assays = as_data_pronoun(env_pronoun)
    )
  invisible(env_pronoun)
}
connect_assays_to_cols <- function(mask_assays, mask_cols) {
  assay_names <- mask_assays$names
  size <- length(assay_names) + 20L
  env_mask_bind <- mask_cols$environments[[1]] # last level
  env_asis <- new.env(hash = TRUE, parent = env_mask_bind, size = size)
  env_pronoun <- new.env(hash = TRUE, parent = env_asis, size = size)
  fun_asis <- add_bind(
    quote({
      # assumes !!name_sym is a matrix, if the user transforms a value in
      # assays to a non-matrix, and trys to access it, it may be incorrect
      chops <- `plyxp:::assays:::current_chops`
      data_chop <- .subset(!!name_sym, chops)
      as_is <- do.call("rbind", data_chop)
      if (length(chops) > 1) {
        row_ind <- attr(.indices, "plyxp:::row_chop_ind") |>
          .subset(chops)
        tryCatch(
          {
            as_is <- as_is[order(list_unchop(row_ind)), , drop = FALSE]
          },
          error = function(cnd) {
            if (!inherits(data_chop[[1]], "matrix")) {
              abort(
                paste(
                  "could not reconstruct 'asis' representation.",
                  "Underlying data was not a matrix."
                ),
                call = NULL
              )
            }
            abort("unexpected error", parent = cnd, call = NULL)
          }
        )
      }
      as_is
    }),
    # should be evaluated within the chopped context, cannot guarantee groupings
    .env_expr = mask_assays$environments@env_data_chop,
    .env_bind = env_asis,
    type = "active"
  )
  fun_mold <- add_bind(
    quote(
      lapply(seq_len(`plyxp:::ctx:::n`),
        function(i, x) x[, i, drop = TRUE],
        x = !!name_sym
      )
    ),
    .env_expr = env_asis,
    .env_bind = env_pronoun,
    type = "active"
  )
  walk(assay_names, fun_asis) |>
    walk(fun_mold)
  # whenever a new assay binding is made,
  # execute the prior functions
  mask_assays$on_bind(fun_asis)$on_bind(fun_mold)
  # allow assay data to be seen from rowData context
  mask_cols$environments@env_foreign_data |>
    env_bind(
      .assays_asis = as_data_pronoun(env_asis),
      .assays = as_data_pronoun(env_pronoun)
    )
  invisible(env_pronoun)
}

connect_rows_to_assays <- function(mask_rows, mask_assays) {
  row_names <- mask_rows$names
  size <- length(row_names) + 20L
  env_mask_bind <- mask_assays$environments[[1]] # last level
  env_asis <- new.env(hash = TRUE, parent = env_mask_bind, size = size)
  env_pronoun <- new.env(hash = TRUE, parent = env_asis, size = size)
  # assays is always the "richer" grouping, we can guarantee
  # that the current_chops scope has a scalar value
  fun_asis <- add_bind(
    quote(.subset2(!!name_sym, `plyxp:::rows:::current_chops`)),
    # should be evaluated within the chopped context, cannot guarantee groupings
    .env_expr = mask_rows$environments@env_data_chop,
    .env_bind = env_asis,
    type = "active"
  )
  fun_mold <- add_bind(
    quote(vec_rep(!!name_sym, times = `plyxp:::ctx:::ncol`)),
    .env_expr = env_asis,
    .env_bind = env_pronoun,
    type = "active"
  )
  walk(row_names, fun_asis) |>
    walk(fun_mold)
  # whenever a new row binding is made,
  # execute the prior functions
  mask_rows$on_bind(fun_asis)$on_bind(fun_mold)
  # allow row data to be seen from assay context
  mask_assays$environments@env_foreign_data |>
    env_bind(
      .rows_asis = as_data_pronoun(env_asis),
      .rows = as_data_pronoun(env_pronoun)
    )
  invisible(env_pronoun)
}

connect_cols_to_assays <- function(mask_cols, mask_assays) {
  col_names <- mask_cols$names
  size <- length(col_names) + 20L
  env_mask_bind <- mask_assays$environments[[1]] # last level
  env_asis <- new.env(hash = TRUE, parent = env_mask_bind, size = size)
  env_pronoun <- new.env(hash = TRUE, parent = env_asis, size = size)
  # assays is always the "richer" grouping, we can guarantee
  # that the current_chops scope has a scalar value
  fun_asis <- add_bind(
    quote(.subset2(!!name_sym, `plyxp:::cols:::current_chops`)),
    .env_expr = mask_cols$environments@env_data_chop,
    .env_bind = env_asis,
    type = "active"
  )
  fun_mold <- add_bind(
    quote(vec_rep_each(!!name_sym, times = `plyxp:::ctx:::nrow`)),
    .env_expr = env_asis,
    .env_bind = env_pronoun,
    type = "active"
  )
  walk(col_names, fun_asis) |>
    walk(fun_mold)
  # whenever a new col binding is made,
  # execute the prior functions
  mask_cols$on_bind(fun_asis)$on_bind(fun_mold)
  # allow col data to be seen from assay context
  mask_assays$environments@env_foreign_data |>
    env_bind(
      .cols_asis = as_data_pronoun(env_asis),
      .cols = as_data_pronoun(env_pronoun)
    )
  invisible(env_pronoun)
}

connect_rows_to_cols <- function(mask_rows, mask_cols) {
  row_names <- mask_rows$names
  size <- length(row_names) + 20L
  env_mask_bind <- mask_cols$environments[[1]] # last level
  env_asis <- new.env(hash = TRUE, parent = env_mask_bind, size = size)
  env_pronoun <- new.env(hash = TRUE, parent = env_asis, size = size)
  # bind
  fun_asis <- add_bind(
    # row data may be grouped. use vctrs::vec_c to concatenate vectors
    quote({
      # ;vec_c(splice(.subset(!!name_sym, `plyxp:::rows:::current_chops`)))
      chops <- `plyxp:::rows:::current_chops`
      data_chop <- .subset(!!name_sym, chops)
      as_is <- vec_c(splice(data_chop))
      if (length(chops) > 1) {
        ind <- .subset(.indices, chops) |>
          splice() |>
          vec_c()
        as_is <- vec_slice(as_is, order(ind, method = "radix"))
      }
      as_is
    }),
    .env_expr = mask_rows$environments@env_data_chop,
    .env_bind = env_asis,
    type = "active"
  )
  fun_mold <- add_bind(
    quote(vec_rep(list(!!name_sym), times = `plyxp:::ctx:::n`)),
    .env_expr = env_asis,
    .env_bind = env_pronoun,
    type = "active"
  )
  walk(row_names, fun_asis) |>
    walk(fun_mold)
  # whenever a new row binding is made,
  # execute the prior functions
  mask_rows$on_bind(fun_asis)$on_bind(fun_mold)
  # allow row data to be seen from colData context
  mask_cols$environments@env_foreign_data |>
    env_bind(
      .rows_asis = as_data_pronoun(env_asis),
      .rows = as_data_pronoun(env_pronoun)
    )
  invisible(env_pronoun)
}

connect_cols_to_rows <- function(mask_rows, mask_cols) {
  col_names <- mask_cols$names
  size <- length(col_names) + 20L
  env_mask_bind <- mask_rows$environments[[1]] # last level
  env_asis <- new.env(hash = TRUE, parent = env_mask_bind, size = size)
  env_pronoun <- new.env(hash = TRUE, parent = env_asis, size = size)
  # bind
  fun_asis <- add_bind(
    # col data may be grouped. use vctrs::vec_c to concatenate vectors
    quote({
      # ;vec_c(splice(.subset(!!name_sym, `plyxp:::cols:::current_chops`))))
      chops <- `plyxp:::cols:::current_chops`
      data_chop <- .subset(!!name_sym, chops)
      as_is <- vec_c(splice(data_chop))
      if (length(chops) > 1) {
        ind <- .subset(.indices, chops) |>
          splice() |>
          vec_c()
        as_is <- vec_slice(as_is, order(ind, method = "radix"))
      }
      as_is
    }),
    .env_expr = mask_cols$environments@env_data_chop,
    .env_bind = env_asis,
    type = "active"
  )
  fun_mold <- add_bind(
    quote(vec_rep(list(!!name_sym), times = `plyxp:::ctx:::n`)),
    .env_expr = env_asis,
    .env_bind = env_pronoun,
    type = "active"
  )
  walk(col_names, fun_asis) |>
    walk(fun_mold)
  # whenever a new col binding is made,
  # execute the prior functions
  mask_cols$on_bind(fun_asis)$on_bind(fun_mold)
  # allow col data to be seen from rowData context
  mask_rows$environments@env_foreign_data |>
    env_bind(
      .cols_asis = as_data_pronoun(env_asis),
      .cols = as_data_pronoun(env_pronoun)
    )
  invisible(env_pronoun)
}

connect_masks <- function(mask_assays, mask_rows, mask_cols) {
  col2row <- connect_cols_to_rows(mask_cols = mask_cols, mask_rows = mask_rows)
  row2col <- connect_rows_to_cols(mask_rows = mask_rows, mask_cols = mask_cols)
  col2assay <- connect_cols_to_assays(
    mask_cols = mask_cols, mask_assays = mask_assays
  )
  row2assay <- connect_rows_to_assays(
    mask_rows = mask_rows, mask_assays = mask_assays
  )
  assay2row <- connect_assays_to_rows(
    mask_assays = mask_assays, mask_rows = mask_rows
  )
  assay2col <- connect_assays_to_cols(
    mask_assays = mask_assays, mask_cols = mask_cols
  )

  list(
    assays = list(
      cols = col2assay,
      rows = row2assay
    ),
    rows = list(
      assays = assay2row,
      cols = col2row
    ),
    cols = list(
      assays = assay2col,
      rows = row2col
    )
  )
}

#' @include vctrs-S4-.R

#' @title unchop a list of objects
#' @name list_unchop
#' @description
#' A generic version of [`vctrs::list_unchop`][vctrs::list_unchop] meant to
#' support S4 Vectors.
#' @param x a list
#' @param ptype the expected prototype of the output
#' @param ... unused arguments
#' @param indices optional list of integer vectors whose size is equal to that
#' of x. This maps the the final index of each element in the output.
#' @return an object of type `ptype` or the common ptype of elements of x.
#' @export
list_unchop <- new_generic(
  "list_unchop",
  c("x", "ptype"),
  function(x, ptype = NULL, ..., indices = NULL) {
    S7::S7_dispatch()
  }
)


method(
  list_unchop,
  list(x = S7::class_list, ptype = class_vctrs)
) <- function(x, ptype, ..., indices = NULL) {
  vctrs::list_unchop(x, indices = indices, ptype = ptype)
}

method(
  list_unchop,
  list(x = S7::class_list, ptype = NULL)
) <- function(x, ptype, ..., indices = NULL) {
  ptype <- vec_ptype_common_list(x, NULL)
  # prevent recusion case
  if (is.null(ptype)) {
    return(NULL)
  }
  list_unchop(
    x,
    ptype = ptype,
    indices = indices
  )
}

method(
  list_unchop,
  list(x = S7::class_list, ptype = S7::class_any)
) <- function(x, ptype, ..., indices = NULL) {
  vctrs::list_unchop(x, indices = indices, ptype = ptype)
}

method(
  list_unchop,
  list(x = S7::class_list, ptype = class_s4_vctrs)
) <-
  function(x, ptype, ..., indices = NULL) {
    merged <- do.call("c", x)
    if (!is.null(indices)) {
      indices <- vctrs::list_unchop(indices)
      merged <- vec_slice(merged, order(indices))
    }
    merged
  }


vec_c <- function(...) {
  dots <- rlang::list2(...)
  list_unchop(x = dots, ptype = vec_ptype_common_list(dots, NULL))
}

#' Create a common prototype of two vectors
#' @description
#' given two objects, `vec_ptype2()` finds a common prototype
#' @param x first object
#' @param y second object
#' @param ... unused arguments
#' @return an object of size 0.
#' @export
vec_ptype2 <- new_generic(
  "vec_ptype2",
  c("x", "y"),
  function(x, y, ...) S7::S7_dispatch()
)

method(
  vec_ptype2,
  list(
    class_vctrs,
    class_vctrs
  )
) <- function(x, y, ...) {
  vctrs::vec_ptype2(x, y, ...)
}

method(
  vec_ptype2,
  list(
    S7::class_any,
    NULL
  )
) <- function(x, y, ...) {
  if (methods::is(x, "Vector")) {
    x[0]
  } else {
    vctrs::vec_ptype(x)
  }
}

method(
  vec_ptype2,
  list(
    NULL,
    S7::class_any
  )
) <- function(x, y, ...) {
  if (methods::is(y, "Vector")) {
    y[0]
  } else {
    vctrs::vec_ptype(y)
  }
}


attempt_ptype2 <- function(x, y) {
  out <- c(x, y)
  out[0]
}

method(
  vec_ptype2,
  list(
    class_s4_vctrs,
    class_vctrs
  )
) <- attempt_ptype2

method(
  vec_ptype2,
  list(
    class_vctrs,
    class_s4_vctrs
  )
) <- attempt_ptype2


method(
  vec_ptype2,
  list(
    class_s4_vctrs,
    class_s4_vctrs
  )
) <- attempt_ptype2

#' find the common ptype
#' @param ... <[`dynamic-dots`][rlang::dyn-dots]> a collection of objects
#' @param .ptype the expected prototype
#' @return an object of size 0.
#' @export
vec_ptype_common <- function(..., .ptype = NULL) {
  vec_ptype_common_list(rlang::list2(...), .ptype = .ptype)
}

vec_ptype_common_list <- function(dots, .ptype) {
  dots <- lapply(dots, vec_slice, 0L)
  ptype <- base::Reduce(vec_ptype2, x = dots, init = .ptype)
  # if (vctrs::is_partial(ptype)) {
  #   ptype <- vctrs::vec_ptype_finalise(ptype)
  # }
  vctrs::vec_ptype_finalise(ptype)
}

as_vec <- function(x) {
  x <- as.vector(x)
  # unintuitively, a matrix of lists does NOT
  # become a vector after `as.vector()`,
  # must remove dim
  dim(x) <- NULL
  x
}


prepend_rownames <- function(DF, column) {
  name_col <- rownames(DF) %||% as.character(seq_len(nrow(DF)))
  name_col <- list(name_col)
  names(name_col) <- column
  DF@listData <- c(name_col, DF@listData)
  DF
}

#' @title S7 classes for vctrs and S4 Vectors
#' @name vectors
#' @description
#' A set of S7 classes and Class unions that help establish S7 method dispatch.
#' These classes were made to re-export several `vctrs` functions such that
#' internals for `plyxp` were consistent with room for optimization.
#' @seealso [vec_rep()],[vec_recycle()],[vec_slice()]
#' @examples
#' # used for defining methods on S7 generics
#'
#' S7::method(vec_slice, class_s4_vctrs)
#'
#' @return S7 class union or base class
#' @export
class_vctrs <- S7::new_union(
  S7::class_atomic, S7::class_list,
  S7::class_data.frame, S7::class_factor,
  S7::class_Date, S7::class_POSIXct,
  S7::new_S3_class("vctrs_vctr"),
  S7::new_S3_class("vctrs_partial"),
  S7::new_S3_class("vctrs_sclr")
)

#' @rdname vectors
#' @export
class_s4_vctrs <- methods::getClass("Vector")

#' @rdname vectors
#' @export
class_DF <- methods::getClass("DataFrame")

# The following functions should
# be available to users from our package

#' @title reexports from other packages
#' @name reexports
#' @returns exported functions available from `plyxp`
#'
#' @seealso [plyxp::arrange()] [plyxp::mutate()] [plyxp::filter()]
#' [plyxp::summarize()] [plyxp::select()] [plyxp::pull()] [plyxp::group_by()]
#' [plyxp::group_data()] [plyxp::group_vars()] [plyxp::ungroup()]
#' [plyxp::group_split()]
#' @seealso [plyxp::PlySummarizedExperiment-methods]
#'
#' @examples
#' arrange(se_simple, rows(direction)) |>
#'   mutate(logp_counts = log1p(counts)) |>
#'   filter(cols(condition == "drug"))
#'
#' assays(se_simple)
#' rowData(se_simple)
#' colData(se_simple)
#'
NULL

#' @noRd
#' @export
dplyr::arrange

#' @noRd
#' @export
dplyr::mutate

#' @noRd
#' @export
dplyr::filter

#' @noRd
#' @export
dplyr::summarize

#' @noRd
#' @export
dplyr::summarise

#' @noRd
#' @export
dplyr::select

#' @noRd
#' @export
dplyr::slice

#' @noRd
#' @export
dplyr::pull

#' @noRd
#' @export
dplyr::group_by

#' @noRd
#' @export
dplyr::group_data

#' @noRd
#' @export
dplyr::group_vars

#' @noRd
#' @export
dplyr::ungroup

#' @noRd
#' @export
dplyr::group_split

#' @name pull
#' @title extract data from object
#' @description
#' similar to `dplyr::pull.data.frame` except allows to extract objects
#' from different contexts.
#' @param .data An object Inheriting from `PlySummarizedExperiment`, the wrapper
#' class for `SummarizedExperiment` objects
#' @param var A variable as specified by [dplyr::pull][dplyr::pull]
#' @param name ignored argument. Due to the range of data types a
#' `PlySummarizedExperiment` this argument is not supported
#' @param ... unused argument
#' @return an element from either the assays, rowData, or colData of a
#' `SummarizedExperiment` object
#' @examples
#'
#' # last element of default context (assays)
#' pull(se_simple, var = -1)
#' # first element of rows context
#' pull(se_simple, var = rows(1))
#' # element from col context by literal variable name
#' pull(se_simple, var = cols(condition))
#'
#' # use `pull()` to return contextual info
#' mutate(se_simple, rows(counts = .assays$counts)) |>
#'   # get last stored element
#'   pull(rows(-1))
#' @export
pull.PlySummarizedExperiment <- function(.data, var = -1, name = NULL, ...) {
  pull_se_impl(se(.data), var = {{ var }}, name = name, ...)
}

pull_se_impl <- function(.data, var = -1, name = NULL, ...) {
  #
  rlang::check_dots_empty()
  .env <- caller_env()
  quos <- plyxp_quos({{ var }}, .ctx = c("assays", "rows", "cols"))
  if (length(quos) > 1) rlang::abort("`var` can only pull one object")
  if (!is.null(name)) {
    rlang::warn("arg `name` is not used in pull.SummarizedExperiment()")
  }
  var <- quos[[1]]
  ctxs <- attr(var, which = "plyxp:::ctx")
  data_ctx <- switch(ctxs,
    "assays" = assays(.data),
    "rows" = rowData(.data),
    "cols" = colData(.data)
  )
  var <- try_fetch(
    tidyselect::vars_pull(names(data_ctx), !!var),
    error = function(cnd) {
      var <- rlang::as_label(var)
      if ((var == ".features" && ctxs == "rows") ||
        (var == ".samples" && ctxs == "cols")) {
        return(NULL)
      }
      # rethrow error
      abort(sprintf("failed to pull '%s' from '%s' context", var, ctxs),
        parent = cnd, call = .env
      )
    }
  )

  if (is.null(var)) {
    rownames(data_ctx) %||% seq_len(nrow(data_ctx))
  } else {
    data_ctx[[var]]
  }
}

#' @include vctrs-S4-chop.R
#' @include vctrs-S4-unchop.R
#' @include vctrs-S4-rep.R

# `skip!` <- structure(list(), class = "skip")
# skip <- function() {
#   `skip!`
# }
# print.skip <- function(x, ...) cat("<skip>\n")
# is_skip <- function(x) inherits(x, "skip")

ctx_env <- new.env(parent = emptyenv())

peek_ctx <- function(name) {
  ctx_env[[name]]
}

poke_ctx <- function(name, value) {
  old <- ctx_env[[name]]
  ctx_env[[name]] <- value
  invisible(old)
}

poke_ctx_local <- function(name, value) {
  old <- ctx_env[[name]]
  ctx_env[[name]] <- value
  quo <- expr(ctx_env[[!!name]] <- !!old)
  do.call(
    on.exit,
    list(quo, add = TRUE),
    envir = parent.frame()
  )
  invisible(old)
}

# this is the top of all our rlang data masks (inherited from base).
# it contains all expected functions for transforming values  in multi-tiered
# data masks.
# If future extensions need access to additional functions, they should consider
# creating their own top_env, or open a PR to add it here.
top_env <- new_environment(
  data = list(
    abort = rlang::abort,
    vec_chop = vec_chop,
    chop_assays_outer = chop_assays_outer,
    # vec_chop_assays = vec_chop_assays,
    # vec_chop_assays_row = vec_chop_assays_row,
    # vec_chop_assays_col = vec_chop_assays_col,
    vec_rep = vec_rep,
    vec_rep_each = vec_rep_each,
    vec_c = vec_c,
    list_unchop = list_unchop,
    splice = splice,
    # skip = skip,
    poke_ctx = poke_ctx,
    poke_ctx_local = poke_ctx_local,
    peek_ctx = peek_ctx,
    .current_group_id = 0L,
    .mask_manager = NULL
  ),
  parent = baseenv()
)

bot_env <- new.env(parent = top_env)

plyxp_group_ids2 <- function(
    groups,
    expanded,
    relative_to = c("assays", "rows", "cols")) {
  #
  relative_to <- match.arg(relative_to, c("assays", "rows", "cols"))
  Nr <- nrow(groups$row_groups)
  Nc <- nrow(groups$col_groups)
  switch(relative_to,
    assays = {
      out <- expanded
      list(
        assays = as.list(out[[".group_id"]]),
        rows = as.list(out[[".rows::.indices_group_id"]]),
        cols = as.list(out[[".cols::.indices_group_id"]]),
        .nrow = as.list(out[[".nrows"]]),
        .ncol = as.list(out[[".ncols"]]),
        .nsize = as.list(out[[".nrows"]] * out[[".ncols"]])
      )
    },
    rows = {
      g_row <- groups$row_groups
      g_ind <- as.list(g_row[[".indices_group_id"]])
      c_ind <- groups$col_groups[[".indices_group_id"]]
      r_nrow <- vapply(g_row[[".indices"]], length, 1L)
      r_ncol <- vapply(groups$col_groups[[".indices"]], length, 1L)
      r_ncol <- vec_rep(sum(r_ncol), Nr)
      r_nsiz <- r_nrow * r_ncol
      list(
        assays = lapply(g_ind, function(i) Nr * (c_ind - 1) + i),
        rows = g_ind,
        cols = vec_rep(list(c_ind), Nr),
        .nrow = as.list(r_nrow),
        .ncol = as.list(r_ncol),
        .nsize = as.list(r_nsiz)
      )
    },
    cols = {
      g_col <- groups$col_groups
      g_ind <- as.list(g_col[[".indices_group_id"]])
      r_ind <- groups$row_groups[[".indices_group_id"]]
      c_ncol <- vapply(g_col[[".indices"]], length, 1L)
      c_nrow <- vapply(groups$row_groups[[".indices"]], length, 1L)
      c_nrow <- vec_rep(sum(c_nrow), Nc) # ?
      c_nsiz <- c_nrow * c_ncol
      list(
        assays = lapply(g_ind, function(i) Nr * (i - 1L) + r_ind),
        rows = vec_rep(list(r_ind), Nc),
        cols = g_ind,
        .nrow = as.list(c_nrow),
        .ncol = as.list(c_ncol),
        .nsize = as.list(c_nsiz)
      )
    }
  )
}

# plyxp_group_ids <- function(.data, var) {
#   group_by(.data, {{ var }}) |>
#     mutate(rows_keep = !duplicated(.rows_group_id),
#            cols_keep = !duplicated(.cols_group_id)) |>
#     summarise(assays = list(.group_id[rows_keep | cols_keep]),
#               rows = list(.rows_group_id[rows_keep]),
#               cols = list(.cols_group_id[cols_keep]),
#               .nrow = list(sum(.nrows[rows_keep])),
#               .ncol = list(sum(.ncols[cols_keep])),
#               .nsize = list(.nrow[[1]]*.ncol[[1]])) |>
#     select(- {{ var }}) |>
#     as.list()
# }

env_group_id <- function(env) {
  force(env)
  function(id) {
    env[["plyxp:::ctx:::group_id"]] <- id
    invisible(id)
  }
}

# provides most of the connectivity for tracking how other
# contexts should collect certain data. Most of this headache is to support
# grouping operations.
prepare_shared_ctx_env <- function(groups, expanded) {
  # ind_d <- attr(groups, "obj_dim")

  inf_assay <- plyxp_group_ids2(groups, expanded, "assays")
  inf_rows <- plyxp_group_ids2(groups, expanded, "rows")
  inf_cols <- plyxp_group_ids2(groups, expanded, "cols")

  assay_group_id <- list(
    assays = inf_assay[["assays"]],
    rows = inf_rows[["assays"]],
    cols = inf_cols[["assays"]]
  )
  rows_group_id <- list(
    assays = inf_assay[["rows"]],
    rows = inf_rows[["rows"]],
    cols = inf_cols[["rows"]]
  )
  cols_group_id <- list(
    assays = inf_assay[["cols"]],
    rows = inf_rows[["cols"]],
    cols = inf_cols[["cols"]]
  )
  ctx_group_id <- list(
    assays = inf_assay[["assays"]],
    rows = inf_rows[["rows"]],
    cols = inf_cols[["cols"]]
  )

  nrow_info <- list(
    assays = inf_assay[[".nrow"]],
    rows = inf_rows[[".nrow"]],
    cols = inf_cols[[".nrow"]]
  )
  ncol_info <- list(
    assays = inf_assay[[".ncol"]],
    rows = inf_rows[[".ncol"]],
    cols = inf_cols[[".ncol"]]
  )
  nsize_info <- list(
    assays = inf_assay[[".nsize"]],
    rows = inf_rows[[".nsize"]],
    cols = inf_cols[[".nsize"]]
  )
  # this may be incorrect???
  nsize_ctx <- list(
    assays = inf_assay[[".nsize"]],
    rows = inf_rows[[".nrow"]],
    # is .ncol refering to size of output?
    cols = inf_cols[[".ncol"]]
  )

  shared_ctx_env <- new_environment(
    data = list(
      # current context
      `plyxp:::ctx` = "assays",
      # context group id
      `plyxp:::ctx:::group_id` = 1L,
      # list of all contexts, each contains
      # indices to retrieve data from that context
      # while evaluating from assays context
      `plyxp:::assays:::group_chop_ids` = assay_group_id,
      # list of all contexts, each contains
      # indices to retrieve data from that context
      # while evaluating from rows context
      `plyxp:::rows:::group_chop_ids` = rows_group_id,
      # list of all contexts, each contains
      # indices to retrieve data from that context
      # while evaluating from cols context
      `plyxp:::cols:::group_chop_ids` = cols_group_id,
      # shortcut to the current context's indices
      `plyxp:::ctx:::group_chop_ids` = ctx_group_id,
      # list of all contexts, each contains
      # the number of rows for the context
      `plyxp:::dim:::nrow` = nrow_info,
      # list of all contexts, each contains
      # the number of cols for the context
      # NOTE: assays context reports its dims, NOT how many assays
      `plyxp:::dim:::ncol` = ncol_info,
      # list of all contexts, each contains
      # expected size of output... example:
      # assays -> nrow * ncol
      # rows -> nrow of rowData
      # cols -> nrow of colData
      `plyxp:::dim:::size` = nsize_info,
      `plyxp:::dim:::n` = nsize_ctx,
      `plyxp:::ctx:::n_groups` = list(
        assays = max(expanded$.group_id),
        rows = max(expanded[[".rows::.indices_group_id"]]),
        cols = max(expanded[[".cols::.indices_group_id"]])
      )

      # expanded |>
      #  summarise(assays = max(.group_id),
      #            rows = max(`.rows::.indices_group_id`),
      #            cols = max(`.cols::.indices_group_id`)) |>
      #  as.list()
    ),
    parent = bot_env
  )

  # set of active bindings to retrieve above info dynamically
  env_bind_active(
    shared_ctx_env,
    # number of groups for current context
    `plyxp:::n_groups` = new_function(
      pairlist(),
      expr(.subset2(`plyxp:::ctx:::n_groups`, `plyxp:::ctx`)),
      env = shared_ctx_env
    ),
    # indices of current group in current context
    `plyxp:::ctx:::current_chops` = new_function(
      pairlist(),
      expr(
        .subset2(`plyxp:::ctx:::group_chop_ids`, `plyxp:::ctx`) |>
          .subset2(`plyxp:::ctx:::group_id`)
      ),
      env = shared_ctx_env
    ),
    # assays indices for current group
    `plyxp:::assays:::current_chops` = new_function(
      pairlist(),
      expr(
        .subset2(`plyxp:::assays:::group_chop_ids`, `plyxp:::ctx`) |>
          .subset2(`plyxp:::ctx:::group_id`)
      ),
      env = shared_ctx_env
    ),
    # rowData indices for current group
    `plyxp:::rows:::current_chops` = new_function(
      pairlist(),
      expr(
        .subset2(`plyxp:::rows:::group_chop_ids`, `plyxp:::ctx`) |>
          .subset2(`plyxp:::ctx:::group_id`)
      ),
      env = shared_ctx_env
    ),
    # colData indices for current group
    `plyxp:::cols:::current_chops` = new_function(
      pairlist(),
      expr(
        .subset2(`plyxp:::cols:::group_chop_ids`, `plyxp:::ctx`) |>
          .subset2(`plyxp:::ctx:::group_id`)
      ),
      env = shared_ctx_env
    ),
    # nrow for current context and group
    `plyxp:::ctx:::nrow` = new_function(
      pairlist(),
      expr(
        .subset2(`plyxp:::dim:::nrow`, `plyxp:::ctx`) |>
          .subset2(`plyxp:::ctx:::group_id`)
      ),
      env = shared_ctx_env
    ),
    # nrow for current context and group
    `plyxp:::ctx:::ncol` = new_function(
      pairlist(),
      expr(
        .subset2(`plyxp:::dim:::ncol`, `plyxp:::ctx`) |>
          .subset2(`plyxp:::ctx:::group_id`)
      ),
      env = shared_ctx_env
    ),
    # size for current context and group
    `plyxp:::ctx:::size` = new_function(
      pairlist(),
      expr(
        .subset2(`plyxp:::dim:::size`, `plyxp:::ctx`) |>
          .subset2(`plyxp:::ctx:::group_id`)
      ),
      env = shared_ctx_env
    ),
    #
    `plyxp:::ctx:::n` = new_function(
      pairlist(),
      expr(
        .subset2(`plyxp:::dim:::n`, `plyxp:::ctx`) |>
          .subset2(`plyxp:::ctx:::group_id`)
      ),
      env = shared_ctx_env
    )
  )
  shared_ctx_env$n <- new_function(
    pairlist(),
    quote(`plyxp:::ctx:::n`),
    shared_ctx_env
  )
  shared_ctx_env$cur_group_id <- new_function(
    pairlist(),
    quote(`plyxp:::ctx:::group_id`),
    shared_ctx_env
  )
  shared_ctx_env$set_group_id <- env_group_id(shared_ctx_env)
  shared_ctx_env
}

#' @title plyxp contexts
#' @name plyxp-context
#' @description
#' Contextual user-facing helper function for dplyr verbs with SummarizedExperiment
#' objects. These functions are intended to be used as the top level call to
#' any dplyr verbs `...` argument, similar to that of `across()`/`if_any()`/`if_all()`.
#'
#' @param x,... expressions to evaluate within its associated context
#' @param asis asis = FALSE (the default) will indicate using active bindings
#' that attempt to coerce the underlying data into a format that is appropriate
#' for the current context. Indicating TRUE will instead bind the underlying data
#' as is.
#' @return function called for its side-effects
#' @examples
#'
#' # cols
#' mutate(se_simple,
#'   cols(is_drug = condition == "drug"),
#'   # bind a different context
#'   effect = col_ctx(counts + (is_drug * rbinom(n(), 20, .3)))
#' )
#'
NULL

#' @rdname plyxp-context
#' @description
#' Specifies that the following expressions should be evaluated within the
#' colData context.
#' @export
cols <- function(...) {
  rlang::abort("`cols()` is a sentinal function for SummarizedExperiment dplyr verbs")
}

#' @rdname plyxp-context
#' @description
#' Specifies that the following expressions should be evaluated within the
#' rowData context.
#' @export
rows <- function(...) {
  rlang::abort("`rows()` is a sentinal function for SummarizedExperiment dplyr verbs")
}


#' @rdname plyxp-context
#' @description
#' Specify a single expression to evaluate in another context
#'
#' @export
col_ctx <- function(x, asis = FALSE) {
  env <- peek_ctx("plyxp:::caller_env")
  biocmanager <- peek_ctx("plyxp:::manager")
  ctx <- biocmanager$ctx
  if (ctx == "cols") rlang::abort("`col_ctx()` within cols(...) is redunant")
  quo <- new_quosure(enexpr(x), env = env)
  bot_env <- biocmanager$extended[["cols"]]
  if (asis) {
    bot_env <- parent.env(bot_env)
  }
  mask <- new_data_mask(bot_env, top_env)
  eval_tidy(quo, data = mask, env = env)
}

#' @rdname plyxp-context
#' @description
#' Specify a single expression to evaluate in another context
#'
#' @export
row_ctx <- function(x, asis = FALSE) {
  env <- peek_ctx("plyxp:::caller_env")
  biocmanager <- peek_ctx("plyxp:::manager")
  ctx <- biocmanager$ctx
  if (ctx == "rows") rlang::abort("`row_ctx()` within rows(...) is redunant")
  quo <- new_quosure(enexpr(x), env = env)
  bot_env <- biocmanager$extended[["rows"]]
  if (asis) {
    bot_env <- parent.env(bot_env)
  }
  mask <- new_data_mask(bot_env, top_env)
  eval_tidy(quo, data = mask, env = env)
}

#' @rdname plyxp-context
#' @description
#' Specify a single expression to evaluate in another context
#'
#' @export
assay_ctx <- function(x, asis = FALSE) {
  env <- peek_ctx("plyxp:::caller_env")
  biocmanager <- peek_ctx("plyxp:::manager")
  ctx <- biocmanager$ctx
  if (ctx == "assays") rlang::abort("`assay_ctx()` at top level ... is redundant")
  quo <- new_quosure(enexpr(x), env = env)
  bot_env <- biocmanager$extended[["assays"]]
  if (asis) {
    bot_env <- parent.env(bot_env)
  }
  mask <- new_data_mask(bot_env, top_env)
  eval_tidy(quo, data = mask, env = env)
}


#' @name dot-pronouns
#' @title contextual plyxp pronouns
#' @description
#' `plyxp` utilizes its own version of `rlang::.data` pronouns. These may be
#' used to gain access to other evaluation contexts for a managed set of
#' data-masks.
#'
#' Similar to `rlang::.data`, `plyxp::.assays` and other exported pronouns
#' are exported to pass R CMD Checks. When using a `plyxp` within your package,
#' import the associated pronoun from `plyxp` but only use the fully unqualified
#' name, `.assays`, `.assays_asis`, etc.
#' @return access to specific values behind the rlang pronoun
#' @examples
#' mutate(
#'   se_simple,
#'   # access via pronoun
#'   rows(sum = rowSums(.assays_asis$counts)),
#'   cols(sum = vapply(.assays$counts, sum, numeric(1)))
#' )
#'
NULL

#' @rdname dot-pronouns
#' @export
.assays <- NULL

#' @rdname dot-pronouns
#' @export
.assays_asis <- NULL


#' @rdname dot-pronouns
#' @export
.rows <- NULL

#' @rdname dot-pronouns
#' @export
.rows_asis <- NULL

#' @rdname dot-pronouns
#' @export
.cols <- NULL

#' @rdname dot-pronouns
#' @export
.cols_asis <- NULL

# rows = function(...) {
#   #
#   mask_manager <- peek_ctx("SE:::mask_manager")
#   fn <- peek_ctx("SE:::dplyr_function")
#   env <- peek_ctx("SE:::caller_env")
#   eval_fun <- switch(fn,
#                      mutate = mask_manager$eval_mutate_rows,
#                      group_by = mask_manager$eval_mutate_rows,
#                      stop(sprintf("`%s` is not yet implemented", fn)))
#   quos <- enquos(..., .named = TRUE)
#   nms <- names(quos)
#   for (i in seq_along(quos)) {
#     quo <- quo_set_env(quos[[i]], env)
#     name <- nms[i]
#     eval_fun(quo, name)
#   }
#   skip()
# },
# cols = function(...) {
#   mask_manager <- peek_ctx("SE:::mask_manager")
#   fn <- peek_ctx("SE:::dplyr_function")
#   env <- peek_ctx("SE:::caller_env")
#   eval_fun <- switch(fn,
#                      mutate = mask_manager$eval_mutate_cols,
#                      group_by = mask_manager$eval_mutate_cols,
#                      stop(sprintf("`%s` is not yet implemented", fn)))
#   quos <- enquos(..., .named = TRUE)
#   nms <- names(quos)
#   for (i in seq_along(quos)) {
#     quo <- quo_set_env(quos[[i]], env)
#     name <- nms[i]
#     eval_fun(quo, name)
#   }
#   skip()
# }

test_that("summarize works - no groups", {
  res <- expect_no_error(
    summarize(
      se_simple,
      sum = sum(counts),
      rows(sum = sum(length)),
      cols(sum = sum(1:n()))
    )
  )

  # outputs should be 1 x 1
  expect_identical(dim(res), c(1L, 1L))
})

test_that("summarize works - groups: rows", {
  gse <- group_by(se_simple, rows(direction))

  res <- expect_no_error(
    summarize(
      gse,
      sum = sum(counts),
      rows(sum = sum(.assays_asis$counts)),
      cols(sum = colSums(.assays_asis$counts))
    )
  )

  expect_identical(dim(res), c(2L, 4L))
})

test_that("summarize works - groups: cols", {
  gse <- group_by(se_simple, cols(condition))

  res <- expect_no_error(
    summarize(
      gse,
      sum = sum(counts),
      rows(sum = rowSums(.assays_asis$counts)),
      cols(sum = sum(.assays_asis$counts))
    )
  )

  expect_identical(dim(res), c(5L, 2L))
})

test_that("summarize works - groups: rows,cols", {
  gse <- group_by(se_simple, rows(direction), cols(condition))

  res <- expect_no_error(
    summarize(
      gse,
      sum = sum(counts),
      rows(sum = sum(.assays_asis$counts)),
      cols(sum = sum(.assays_asis$counts))
    )
  )

  expect_identical(dim(res), c(2L, 2L))
})

test_that("summarize places assays in correct order", {
  se_obj <- mutate(se_simple, seq = 1L:20L)
  rowse <- group_by(se_obj, rows(grps = 1:5)) |>
    summarise(seq = as.integer(colSums(seq)))
  expect_identical(unname(pull(rowse, seq)), unname(pull(se_obj, seq)))
  colse <- group_by(se_obj, cols(grps = 1:4)) |>
    summarise(seq = as.integer(rowSums(seq)))
  expect_identical(unname(pull(colse, seq)), unname(pull(se_obj, seq)))
})

test_that("mutate works - no groups", {
  res <- expect_no_error(
    mutate(se_simple,
      foo = 1:n(),
      rows(foo = 1:n()),
      cols(foo = 1:n())
    )
  )@se

  expect_identical(
    assay(res, "foo") |> unname(),
    matrix(1:20, nrow = 5, ncol = 4)
  )
  expect_identical(rowData(res)[["foo"]], 1:5)
  expect_identical(colData(res)[["foo"]], 1:4)
})

test_that("mutate works with scalars in assays ctx", {
  expect_no_error(res <- se_simple |> mutate(foo = 1L))
  expect_identical(unname(assay(res, "foo")), matrix(1L, 5L, 4L))
})

test_that("mutate works - with groups", {
  gse <- group_by(se_simple, rows(direction), cols(condition))

  res <- expect_no_error(
    mutate(gse,
      foo = cur_group_id(),
      rows(foo = cur_group_id()),
      cols(foo = cur_group_id())
    )@se
  )
  expect_identical(
    assay(res, "foo") |> unname(),
    matrix(c(
      rep(c(1L, 2L, 2L, 1L, 2L), 2),
      rep(c(3L, 4L, 4L, 3L, 4L), 2)
    ), nrow = 5, ncol = 4)
  )
  expect_identical(rowData(res)[["foo"]], c(1L, 2L, 2L, 1L, 2L))
  expect_identical(colData(res)[["foo"]], c(1L, 1L, 2L, 2L))
})

test_that("no groups exist", {
  expect_null(group_data(se_simple))
})

test_that("groups can be constructed", {
  gse <- group_by(se_simple, rows(direction), cols(condition))
  g <- group_data(gse)
  expect_s3_class(g, "plyxp_groups")
  expect_true("direction" %in% names(g$row_groups))
  expect_true("condition" %in% names(g$col_groups))
})

test_that("groups can be removed", {
  gse <- group_by(se_simple, rows(direction), cols(condition))
  expect_s3_class(group_data(gse), "plyxp_groups")
  gse2 <- ungroup(gse)
  expect_null(group_data(gse2))

  gse3 <- ungroup(gse, rows(direction))
  expect_s3_class(group_data(gse3), "plyxp_groups")
  expect_true("condition" %in% names(group_data(gse3)$col_groups))
  expect_null(group_data(gse3)$row_groups)

  gse4 <- ungroup(gse, cols(condition))
  expect_s3_class(group_data(gse4), "plyxp_groups")
  expect_true("direction" %in% names(group_data(gse4)$row_groups))
  expect_null(group_data(gse4)$col_groups)

  # again with multiple groups
  gse <- group_by(se_simple, rows(direction, gene), cols(condition, sample))
  expect_s3_class(group_data(gse), "plyxp_groups")
  gse2 <- ungroup(gse)
  expect_null(group_data(gse2))

  gse3 <- ungroup(gse, rows(direction))
  expect_s3_class(group_data(gse3), "plyxp_groups")
  expect_true("condition" %in% names(group_data(gse3)$col_groups))
  expect_true("gene" %in% names(group_data(gse3)$row_groups))
  expect_false("direction" %in% names(group_data(gse3)$row_groups))

  gse4 <- ungroup(gse, cols(condition))
  expect_s3_class(group_data(gse4), "plyxp_groups")
  expect_true("direction" %in% names(group_data(gse4)$row_groups))
  expect_true("sample" %in% names(group_data(gse4)$col_groups))
  expect_false("condition" %in% names(group_data(gse4)$col_groups))
})

test_that("groups change on data augment", {
  gse <- group_by(se_simple, rows(direction), cols(condition))
  gdata <- group_data(gse)
  expect_equal(nrow(gdata$row_groups), 2)
  gdata_ <- group_data(gse[1, ])
  expect_equal(nrow(gdata_$row_groups), 1)
  expect_identical(gdata$col_groups, gdata_$col_groups)
})

test_that("groups change on filter augment", {
  gse <- group_by(se_simple, rows(direction), cols(condition))
  gdata <- group_data(gse)
  expect_equal(nrow(gdata$row_groups), 2)
  gdata_ <- group_data(filter(gse, rows(direction == "-")))
  expect_equal(nrow(gdata_$row_groups), 1)
  expect_identical(gdata$col_groups, gdata_$col_groups)
  gdata_ <- group_data(filter(gse, rows(direction == "-"), .preserve = TRUE))
  expect_equal(nrow(gdata_$row_groups), 2)
  expect_identical(gdata_$row_groups$.indices, list(1:2, integer()))
  expect_identical(gdata$col_groups, gdata_$col_groups)
})

test_that("groups change on arrange augment", {
  gse <- group_by(se_simple, rows(direction), cols(condition))
  gdata <- group_data(gse)
  expect_equal(nrow(gdata$row_groups), 2)
  gdata_ <- group_data(arrange(gse, rows(dplyr::desc(.features))))
  expect_equal(nrow(gdata_$row_groups), 2)
  expect_identical(gdata$col_groups, gdata_$col_groups)
  expect_identical(gdata_$row_groups$.indices, list(c(1L, 3L, 4L), c(2L, 5L)))
  gdata_ <- group_data(arrange(gse, rows(dplyr::desc(.features)),
    .by_group = TRUE
  ))
  expect_equal(nrow(gdata_$row_groups), 2)
  expect_identical(gdata_$row_groups$.indices, list(1:3, 4:5))
  expect_identical(gdata$col_groups, gdata_$col_groups)
})


test_that("groups change on slice augment", {
  gse <- group_by(se_simple, rows(direction), cols(condition))
  gdata <- group_data(gse)
  expect_equal(nrow(gdata$row_groups), 2)
  gdata_ <- group_data(slice(gse, rows(which(direction == "-"))))
  expect_equal(nrow(gdata_$row_groups), 1)
  expect_identical(gdata$col_groups, gdata_$col_groups)
  gdata_ <- group_data(slice(gse, rows(which(direction == "-")),
    .preserve = TRUE
  ))
  expect_equal(nrow(gdata_$row_groups), 2)
  expect_identical(gdata_$row_groups$.indices, list(1:2, integer()))
  expect_identical(gdata$col_groups, gdata_$col_groups)
})

test_that("scalars provide appropriate indices", {
  se <- se_simple |> group_by(rows(foo = 6L))

  expect_identical(rowData(se)$foo, rep(6L, 5L))
  expect_identical(group_data(se)$row_groups$.indices, list(1:5))
})

test_that("select works", {
  res <- expect_no_error(
    select(
      se_simple,
      counts,
      rows(direction),
      cols(condition)
    )
  )
  
  expect_identical(assays(res) |> names(), "counts")
  expect_identical(rowData(res) |> names(), "direction")
  expect_identical(colData(res) |> names(), "condition")
})

test_that("filter works - no groups", {
  expect_error(
    filter(se_simple, counts >= 20),
    "Cannot filter in `assays` context"
  )

  res <- expect_no_error(
    filter(
      se_simple,
      rows(length > 30),
      cols(sample %in% c("s2", "s3"))
    )
  )

  expect_identical(dim(res), c(3L, 2L))
})


test_that("filter works - with groups", {
  gse <- group_by(se_simple, rows(direction), cols(condition))

  res <- expect_no_error(
    filter(
      gse,
      rows(length > 30),
      cols(sample %in% c("s2", "s3"))
    )
  )

  # still works regardless
  expect_identical(dim(res), c(3L, 2L))
})

test_that("endomorphism", {
  res <- se_simple |>
    filter(
      rows(length > 30),
      cols(sample %in% c("s2", "s3"))
    )

  endo <- local({
    row_sub <- rowData(se(se_simple))[["length"]] > 30
    col_sub <- colData(se(se_simple))[["sample"]] %in% c("s2", "s3")
    se_simple[row_sub, col_sub]
  })

  expect_identical(res, endo)

  # make a test for groups?
})

is_pronoun <- function(x) inherits(x, "rlang_data_pronoun")
plyxp_eval_ctx <- function(..., .ctx, .data, .results = c("chops", "results")) {
  bm <- plyxp:::new_plyxp_manager(se(.data))
  quos <- plyxp:::plyxp_quos(..., .ctx = .ctx)
  bm$ctx <- .ctx
  lapply(quos, bm$eval)
  .results <- match.arg(.results, choices = c("chops", "results"))
  switch(.results,
    chops = {
      # internal to get chops as-is without forcing data
      plyxp:::get_mask_chops(bm)[[.ctx]]
    },
    results = {
      bm$results()[[.ctx]]
    }
  )
}
eval_ctx_ungrouped <- function(..., .ctx, .data) {
  plyxp_eval_ctx(
    ...,
    .ctx = .ctx,
    .data = .data
  ) |> lapply(`[[`, 1L)
}

test_that("pronouns are available within assays context", {
  res <- eval_ctx_ungrouped(
    pronoun_cols = is_pronoun(.cols),
    pronoun_rows = is_pronoun(.rows),
    pronoun_cols_asis = is_pronoun(.cols_asis),
    pronoun_rows_asis = is_pronoun(.rows_asis),
    .ctx = "assays",
    .data = se_simple
  )

  # to dimensions
  expect_true(res$pronoun_rows)
  expect_true(res$pronoun_cols)

  # asis pronouns
  expect_true(res$pronoun_rows_asis)
  expect_true(res$pronoun_cols_asis)
})

test_that("pronouns are available within rows context", {
  res <- eval_ctx_ungrouped(
    pronoun_assays = is_pronoun(.assays),
    pronoun_cols = is_pronoun(.cols),
    pronoun_assays_asis = is_pronoun(.assays_asis),
    pronoun_cols_asis = is_pronoun(.cols_asis),
    .ctx = "rows",
    .data = se_simple
  )

  expect_true(res$pronoun_assays)
  expect_true(res$pronoun_cols)

  expect_true(res$pronoun_assays_asis)
  expect_true(res$pronoun_cols_asis)
})

test_that("pronouns are available within cols context", {
  res <- eval_ctx_ungrouped(
    pronoun_assays = is_pronoun(.assays),
    pronoun_rows = is_pronoun(.rows),
    pronoun_assays_asis = is_pronoun(.assays_asis),
    pronoun_rows_asis = is_pronoun(.rows_asis),
    .ctx = "cols",
    .data = se_simple
  )

  expect_true(res$pronoun_assays)
  expect_true(res$pronoun_rows)

  expect_true(res$pronoun_assays_asis)
  expect_true(res$pronoun_rows_asis)
})


test_that("assays context: non-'asis' pronouns coerce data -> matrix-like vec", {
  res <- eval_ctx_ungrouped(
    cols = .cols$condition,
    rows = .rows$length,
    .ctx = "assays",
    .data = se_simple
  )

  expect_type(res$cols, "character")
  expect_type(res$rows, "integer")

  expect_length(res$cols, 20L)
  expect_length(res$cols, 20L)
})

test_that("rows context: non-'asis' pronouns coerce data -> list vec", {
  res <- eval_ctx_ungrouped(
    assays = .assays$counts,
    cols = .cols$condition,
    .ctx = "rows",
    .data = se_simple
  )

  expect_type(res$assays, "list")
  expect_type(res$cols, "list")

  expect_length(res$assays, 5L)
  expect_length(res$cols, 5L)
  # specific to row-context viewing assays
  # Each is NOT a matrix anymore, slicing drops dimensions since we are
  # viewing element-wise.
  expect_true(
    all(vapply(res$assays, Negate(inherits), what = "matrix", FUN.VALUE = TRUE))
  )
  expect_true(
    all(vapply(res$assays, length, 1L) == 4L)
  )
  # specific to row-context viewing cols
  expect_true(
    all(vapply(res$cols[-1], identical, y = res$cols[[1]], FUN.VALUE = TRUE))
  )
})

test_that("cols context: non-'asis' pronouns coerce data -> list vec", {
  res <- eval_ctx_ungrouped(
    assays = .assays$counts,
    rows = .rows$length,
    .ctx = "cols",
    .data = se_simple
  )

  expect_type(res$assays, "list")
  expect_type(res$rows, "list")

  expect_length(res$assays, 4L)
  expect_length(res$rows, 4L)
  # specific to col-context viewing assays
  # Each is NOT a matrix anymore, slicing drops dimensions since we are
  # viewing element-wise.
  expect_true(
    all(vapply(res$assays, Negate(inherits), what = "matrix", FUN.VALUE = TRUE))
  )
  expect_true(
    all(vapply(res$assays, length, 1L) == 5L)
  )
  # specific to col-context viewing rows
  # all elements should be identical
  expect_true(
    all(vapply(res$rows[-1], identical, y = res$rows[[1]], FUN.VALUE = TRUE))
  )
})

small <- SummarizedExperiment(
  assays = list(
    x = matrix(1:12, 3, 4, dimnames = list(
      rownames = c("A", "B", "C"),
      colnames = c("D", "E", "F", "G")
    ))
  ),
  rowData = data.frame(y = c(1L, 2L, 1L)),
  colData = data.frame(z = c(1L, 2L, 2L, 1L))
) |> new_plyxp()

test_that("assays groups ordered by rows", {
  res <- summarise(
    group_by(small, rows(y), cols(z)),
    check = cur_group_id()
  )

  expect_identical(
    assay(se(res), "check"), matrix(1:4, 2, 2)
  )
})

test_that("assay pronouns reconstruct correct order", {
  res <- summarize(
    group_by(small, rows(y), cols(z)),
    check = list(x),
    rows(check = list(.assays_asis$x)),
    cols(check = list(.assays_asis$x))
  )@se
  # we should expect rownames for rows$check to be split by group
  expect_identical(lapply(rowData(res)$check, rownames), list(c("A", "C"), "B"))
  # we should expect rownames for cols$check to be in correct order
  expect_identical(lapply(colData(res)$check, rownames), list(
    c("A", "B", "C"),
    c("A", "B", "C")
  ))

  # we should expect colnames for rows$check to be in correct order
  expect_identical(
    lapply(rowData(res)$check, colnames),
    list(
      c("D", "E", "F", "G"),
      c("D", "E", "F", "G")
    )
  )
  # we should expect colnames for cols$check to be split by group
  expect_identical(
    lapply(colData(res)$check, colnames),
    list(c("D", "G"), c("E", "F"))
  )
})


test_that("rows pronouns reconstruct correct order", {
  res <- summarize(
    group_by(small, rows(y), cols(z)),
    check = list(.rows_asis$.features),
    rows(check = list(.features)),
    cols(check = list(.rows_asis$.features))
  )@se

  expect_identical(rowData(res)$check, list(c("A", "C"), "B"))
  expect_identical(colData(res)$check, list(c("A", "B", "C"), c("A", "B", "C")))
})

test_that("cols pronouns reconstruct correct order", {
  res <- summarize(
    group_by(small, rows(y), cols(z)),
    check = list(.cols_asis$.samples),
    rows(check = list(.cols_asis$.samples)),
    cols(check = list(.samples))
  )@se

  expect_identical(rowData(res)$check, list(
    c("D", "E", "F", "G"),
    c("D", "E", "F", "G")
  ))
  expect_identical(colData(res)$check, list(c("D", "G"), c("E", "F")))
})

test_that("arrange works - ungrouped", {
  expect_error(
    arrange(
      se_simple, counts
    )
  )

  res <- expect_no_error(
    arrange(
      se_simple,
      rows(length),
      cols(dplyr::desc(sample))
    )
  )@se

  expect_identical(
    rowData(res)[["direction"]],
    c("-", "+", "+", "-", "+")
  )
  expect_identical(
    colData(res)[["condition"]],
    c("drug", "drug", "cntrl", "cntrl")
  )
})


test_that("arrange works - grouped", {
  gse <- group_by(se_simple, rows(direction), cols(condition))

  res <- expect_no_error(
    arrange(
      gse,
      rows(length),
      cols(dplyr::desc(sample))
    )
  )@se

  expect_identical(
    rowData(res)[["direction"]],
    c("-", "+", "+", "-", "+")
  )
  expect_identical(
    colData(res)[["condition"]],
    c("drug", "drug", "cntrl", "cntrl")
  )
})

test_that("arrange works - grouped .by_group = TRUE", {
  gse <- group_by(se_simple, rows(direction), cols(condition))
  # testing .by_group = TRUE
  res <- expect_no_error(
    arrange(
      gse,
      rows(length),
      cols(dplyr::desc(sample)),
      .by_group = TRUE
    )
  )@se



  expect_identical(
    rowData(res)[["direction"]],
    c("+", "+", "+", "-", "-")
  )
  expect_identical(
    colData(res)[["condition"]],
    c("cntrl", "cntrl", "drug", "drug")
  )
})

test_that("endomorphism", {
  res <- arrange(
    se_simple,
    rows(length),
    cols(dplyr::desc(sample))
  )
  endo <- local({
    ro <- order(rowData(se(se_simple))[["length"]], method = "radix")
    co <- order(colData(se(se_simple))[["sample"]],
      decreasing = TRUE, method = "radix"
    )
    se_simple[ro, co]
  })

  expect_identical(res, endo)

  gse <- group_by(se_simple, rows(direction), cols(condition)) |>
    arrange(rows(length),
      cols(dplyr::desc(sample)),
      .by_group = TRUE
    ) |>
    ungroup() |>
    se()

  endo2 <- local({
    se <- se(se_simple)
    ro <- order(rowData(se)[["direction"]],
      rowData(se)[["length"]],
      method = "radix"
    )
    co <- order(colData(se)[["condition"]],
      colData(se)[["sample"]],
      decreasing = c(FALSE, TRUE), method = "radix"
    )
    out <- se[ro, co]
    # group_by reorders rowData and colData based on groups
    rowData(out) <- rowData(out)[c(3, 1, 2)]
    colData(out) <- colData(out)[c(2, 1)]
    out
  })

  expect_identical(gse, endo2)
})

test_that("unused arguments notify user", {
  expect_warning(
    pull(se_simple, name = "foo"),
    "arg `name` is not used in pull.SummarizedExperiment()"
  )
})

test_that("pull from assays", {
  expect_identical(
    assay(se(se_simple), 1),
    pull(se_simple, 1)
  )

  expect_identical(
    assay(se(se_simple), "counts"),
    pull(se_simple, counts)
  )

  expect_identical(
    assay(se(se_simple), length(assays(se_simple))),
    pull(se_simple, -1)
  )
})

test_that("pull from rows", {
  expect_identical(
    rowData(se(se_simple))[[1]],
    pull(se_simple, rows(1))
  )

  expect_identical(
    rowData(se(se_simple))[["direction"]],
    pull(se_simple, rows(direction))
  )

  expect_identical(
    rowData(se(se_simple))[[length(rowData(se(se_simple)))]],
    pull(se_simple, rows(-1))
  )

  expect_identical(
    rownames(rowData(se(se_simple))),
    pull(se_simple, rows(.features))
  )
})


test_that("pull from rows", {
  expect_identical(
    colData(se(se_simple))[[1]],
    pull(se_simple, cols(1))
  )

  expect_identical(
    colData(se(se_simple))[["condition"]],
    pull(se_simple, cols(condition))
  )

  expect_identical(
    colData(se(se_simple))[[length(colData(se(se_simple)))]],
    pull(se_simple, cols(-1))
  )

  expect_identical(
    rownames(colData(se(se_simple))),
    pull(se_simple, cols(.samples))
  )
})

bm <- new_plyxp_manager(se(se_simple))
gbm <- group_by(se_simple, rows(direction), cols(condition)) |>
  se() |>
  plyxp:::new_plyxp_manager()

test_that("`new_plyxp_manager` returns an R6 `plyxp_manager`", {
  expect_s3_class(bm, "R6")
  expect_s3_class(bm, "plyxp_manager")
  expect_s3_class(gbm, "R6")
  expect_s3_class(gbm, "plyxp_manager")
})

test_that("default context is `assays` for SummarizedExperiment", {
  expect_identical(bm$ctx, "assays")
  expect_identical(gbm$ctx, "assays")
})


test_that("context may be changed between `assays`, `rows` and `cols`", {
  bm$ctx <- "rows"
  expect_identical(bm$ctx, "rows")
  bm$ctx <- "cols"
  expect_identical(bm$ctx, "cols")
  bm$ctx <- "assays"
  # shouldnt be able to change it to something else
  expect_error(bm$ctx <- "foo", "should be one of")
  # bm$ctx should still be "assays" after the above failure
  expect_identical(bm$ctx, "assays")
})

test_that("correct number of groups for ungrouped and grouped `se_simple`", {
  expect_identical(bm$n_groups, 1L)
  expect_identical(gbm$n_groups, 4L) # rows(+, -), cols(condition, treatment)
  gbm$ctx <- "rows"
  expect_identical(gbm$n_groups, 2L)
  gbm$ctx <- "cols"
  expect_identical(gbm$n_groups, 2L)
  gbm$ctx <- "assays"
})

#' @name new_plyxp
#' @title SummarizedExperiment Shell Object
#' @description
#' A container object for the SummarizedExperiment class.
#' @param se SummarizedExperiment object
#' @aliases PlySummarizedExperiment
#' @return PlySummarizedExperiment object
#' @examples
#' se <- SummarizedExperiment(
#'   assays = list(counts = matrix(1:6, nrow = 3)),
#'   colData = S4Vectors::DataFrame(condition = c("A", "B"))
#' )
#' new_plyxp(se = se)
#' # or
#' PlySummarizedExperiment(se = se)
#' @export
new_plyxp <- function(se) {
  PlySummarizedExperiment(se = se)
}

#' @importClassesFrom SummarizedExperiment SummarizedExperiment

#' @rdname new_plyxp
#' @description
#' This S4 class is implemented to bring unique `dplyr`
#' syntax to the `SummarizedExperiment` object without clashing with the
#' `tidySummarizedExperiment` package. As such, this is a simple wrapper that
#' contains one slot, which holds a `SummarizedExperiment` object.
#' @slot se contains the underlying `SummarizedExperiment` class.
#' @export
setClass(
  "PlySummarizedExperiment",
  slots = c(
    se = "SummarizedExperiment"
  )
)

#' @rdname new_plyxp
#' @export
PlySummarizedExperiment <- function(se) {
  obj <- new("PlySummarizedExperiment")
  obj@se <- se(se)
  obj
}

setMethod(
  "show",
  "PlySummarizedExperiment",
  function(object) {
    show_tidy(se(object))
  }
)

#' @rdname PlySummarizedExperiment-methods
#' @export
setGeneric("se", function(x) standardGeneric("se"))

#' @describeIn PlySummarizedExperiment-methods get the se slot of the PlySummarizedExperiment object
#' @export
setMethod("se", "PlySummarizedExperiment", function(x) x@se)

#' @describeIn PlySummarizedExperiment-methods set the se slot of the PlySummarizedExperiment object
#' @export
setGeneric("se<-", function(x, value) standardGeneric("se<-"))

#' @describeIn PlySummarizedExperiment-methods set the se slot of the PlySummarizedExperiment object
#' @export
setMethod("se<-", "PlySummarizedExperiment", function(x, value) {
  x@se <- se(value)
  x
})

#' @describeIn PlySummarizedExperiment-methods get the SummarizedExperiment object
#' @export
setMethod("se", "SummarizedExperiment", function(x) x)

#' @describeIn PlySummarizedExperiment-methods get the SummarizedExperiment object
#' @export
setMethod("se<-", "SummarizedExperiment", function(x, value) se(value))

#' @name plyxp
#' @title Modify SummarizedExperiment Object
#' @description
#' Modify the underlying SummarizedExperiment object with a function.
#' @param .data a PlySummarizedExperiment object
#' @param .f within `plyxp()`: a function that returns a SummarizedExperiment object.
#' within `plyxp_on()`: `.f` should return a value compatible with `.on(se)<-`
#' @param ... additional arguments passed to `.f`
#' @param .caller environment in which plyxp should signal an error if one occurs.
#' @return a PlySummarizedExperiment object
#' @examples
#' plyxp(se_simple, function(x) x)
#' @export
plyxp <- function(.data, .f, ..., .caller = caller_env()) {
  #
  plyxp_function <- substitute(.f)
  .f <- rlang::as_function(.f)
  out <- try_fetch(
    .f(se(.data), ...),
    plyxp_on_failure = function(cnd) {
      rlang::abort(class = "plyxp_failure", parent = cnd, call = NULL)
    },
    error = function(cnd) {
      message <- NULL
      if (is_call(cnd$call, ".f")) {
        if (is_call(plyxp_function)) {
          # .f is likely an anonymous function
          cnd$call <- NULL
          message <- c(
            "error in plyxp()",
            "i" = "check the function passed to `.f` argument"
          )
        } else {
          cnd$call[[1]] <- plyxp_function
        }
      }
      rlang::abort(
        message = message,
        class = "plyxp_failure",
        parent = cnd,
        call = .caller
      )
    }
  )
  if (!methods::is(out, "SummarizedExperiment")) {
    cli::cli_abort("{.arg .f} must return a {.cls SummarizedExperiment} object")
  }
  se(.data) <- out
  .data
}

#' @describeIn plyxp pass a function to the result of an accessor of the
#' `SummarizedExperiment` Class
#' This function is a wrapper for the expression:
#' \preformatted{
#'  plyxp::plyxp(.data, function(se, ...) {
#'    .f <- rlang::as_function(.f)
#'    obj <- .on(se)
#'    obj <- .f(se, ...)
#'    .on(se) <- obj
#'    se
#'  }, ...)
#' }
#' where `.on` is the symbol for the accessor function into a
#' `SummarizedExperiment` Class. Note: the setter variant must exist in the
#' environment that `plyxp_on()` is called. All other arguments are diffused
#' as quosures and will be evaluated in the environment they were quoted.
#' @param .on a symbol matching an accessor and setter function for the
#' `SummarizedExperiment` Class.
#' @examples
#' plyxp_on(se_simple,
#'   .f = lapply, # function to call on `.on` args,
#'   .on = rowData, # data `.f` will be used on
#'   paste, "foo"
#' ) # arguments for `.f`
#' @export
plyxp_on <- function(.data, .f, ..., .on, .caller = caller_env()) {
  .on_sub <- substitute(.on)
  .f_sub <- substitute(.f)
  .on_name <- rlang::as_string(.on_sub)
  .on <- find_func(.on_name)
  `.on<-` <- find_func(sprintf("%s<-", .on_name))
  this_call <- caller_call(0)
  inner_function <- function(se, ...) {
    .f <- rlang::as_function(.f)
    try_fetch(
      {
        obj <- .on(se)
        obj <- .f(obj, ...)
        .on(se) <- obj
      },
      error = function(cnd) {
        message <- NULL
        case_call(
          cnd$call,
          .on = {
            cnd$call[[1]] <- sym(.on_name)
            message <- sprintf("error in `%s(se(.data))", .on_name)
          },
          .f = {
            cnd$call[[1]] <- .f_sub
            message <- sprintf(
              "error in `%s(%s(se(.data)), ...)",
              as_label(.f_sub),
              .on_name
            )
          },
          `.on<-` = {
            cnd$call[[1]] <- sym(sprintf("%s<-", .on_name))
            message <- sprintf("error in `%s(se(.data)) <- value`", .on_name)
          }
        )
        rlang::abort(
          message = message,
          class = "plyxp_on_failure",
          parent = cnd,
          plyxp_on_call = .caller,
          call = this_call
        )
      }
    )
    se
  }
  plyxp(.data, .f = inner_function, ..., .caller = .caller)
}

case_call <- function(x, ...) {
  env <- parent.frame(1)
  if (is.call(x)) {
    call_arg <- as_label(x[[1]])
    dots <- enexprs(...)
    expr <- expr(switch(!!call_arg,
      !!!dots
    ))
    eval(expr, envir = env)
  }
}

find_func <- function(func, .caller = caller_env()) {
  try_fetch(match.fun(func), error = function(cnd) {
    rlang::abort(sprintf("could not match %s()", func), parent = cnd, call = .caller)
  })
}

#' @export
print.PlySummarizedExperiment <- function(x, ...) {
  show_tidy(se(x), ...)
}

into_index <- function(indices, .size = NULL, .names = NULL) {
  switch(typeof(indices),
    integer = indices,
    double = indices,
    character = match(indices, .names, nomatch = 0L),
    logical = if ((l <- length(indices)) == 0L) {
      integer()
    } else if (l <= .size) {
      seq_len(.size)[indices]
    } else {
      stop(sprintf(
        "logical cannot be longer than %i",
        .size
      ), call. = FALSE)
    },
    stop(
      sprintf("cannot convert type '%s' into integer index", typeof(indices)),
      call. = FALSE
    )
  )
}

plyxp_slice_se <- function(se, i, j, .preserve = FALSE) {
  type <- NULL
  if (!missing(i)) {
    type <- "i"
  }
  if (!missing(j)) {
    type <- paste0(type, "j")
  }
  if (!is.null(groups <- group_data_se_impl(se))) {
    switch(type,
      i = {
        groups$row_groups <- slice_group_data(groups$row_groups,
          indices = into_index(i, .size = nrow(se), .names = rownames(se)),
          .size = nrow(se), .preserve = .preserve
        )
      },
      j = {
        groups$col_groups <- slice_group_data(groups$col_groups,
          indices = into_index(j, .size = ncol(se), .names = colnames(se)),
          .size = ncol(se), .preserve = .preserve
        )
      },
      ij = {
        groups$row_groups <- slice_group_data(groups$row_groups,
          indices = into_index(i, .size = nrow(se), .names = rownames(se)),
          .size = nrow(se), .preserve = .preserve
        )
        groups$col_groups <- slice_group_data(groups$col_groups,
          indices = into_index(j, .size = ncol(se), .names = colnames(se)),
          .size = ncol(se), .preserve = .preserve
        )
      }
    )
    group_data_se_impl(se) <- groups
  }

  se <- switch(type,
    i = se[i, ],
    j = se[, j],
    ij = se[i, j],
    se
  )
  se
}

#' @export
`[.PlySummarizedExperiment` <- function(x, i, j, ..., drop = TRUE) {
  se(x) <- plyxp_slice_se(se(x), i, j, ..., .preserve = FALSE)
  x
}


#' @export
`$.PlySummarizedExperiment` <- function(x, name) {
  colData(se(x))[[name]]
}

#' @export
`$<-.PlySummarizedExperiment` <- function(x, name, value) {
  colData(x)[[name]] <- value
  x
}

#' @export
dim.PlySummarizedExperiment <- function(x) {
  dim(se(x))
}

#' @name PlySummarizedExperiment-methods
#' @title PlySummarizedExperiment Methods
#' @description
#' Methods from SummarizedExperiment package re-implemented for PlySummarizedExperiment.
#' @param x PlySummarizedExperiment object
#' @param withDimnames logical
#' @param ... additional arguments
#' @param i character or numeric index
#' @param value replacement value
#' @param use.names logical
#' @return Replacement functions return a PlySummarizedExperiment object. Other functions will return the same object as the method from SummarizedExperiment.
#' @examples
#' assays(se_simple)
#' rowData(se_simple)
#' colData(se_simple)
#'
NULL

#' @describeIn PlySummarizedExperiment-methods get the assays o the PlySummarizedExperiment object
#' @export
setMethod(
  "assays",
  "PlySummarizedExperiment",
  function(x, withDimnames = TRUE, ...) {
    assays(se(x), withDimnames = withDimnames, ...)
  }
)

set_assays <- function(
    x,
    withDimnames = TRUE,
    ...,
    value) {
  plyxp(x, `assays<-`, value = value, withDimnames = withDimnames, ...)
}

# S7_signature <- function(...) {
#   out <- list(...)
#   class(out) <- "S7_signature"
#   out
# }

#' @describeIn PlySummarizedExperiment-methods set the assays of the PlySummarizedExperiment object
#' @export
setMethod(
  "assays<-",
  c("PlySummarizedExperiment", "list"),
  set_assays
)

#' @describeIn PlySummarizedExperiment-methods set the assays of the PlySummarizedExperiment object
#' @export
setMethod(
  "assays<-",
  c("PlySummarizedExperiment", "SimpleList"),
  set_assays
)

get_assay <- function(x, i, withDimnames = TRUE, ...) {
  assay(se(x), i = i, withDimnames = withDimnames, ...)
}

#' @describeIn PlySummarizedExperiment-methods get the first assay of the PlySummarizedExperiment object
#' @export
setMethod(
  "assay",
  c("PlySummarizedExperiment", "missing"),
  function(x, i, withDimnames = TRUE, ...) {
    assay(se(x), withDimnames = withDimnames, ...)
  }
)

#' @describeIn PlySummarizedExperiment-methods get assay from a PlySummarizedExperiment object
#' @export
setMethod("assay", c("PlySummarizedExperiment", "numeric"), get_assay)

#' @describeIn PlySummarizedExperiment-methods get assay from a PlySummarizedExperiment object
#' @export
setMethod("assay", c("PlySummarizedExperiment", "character"), get_assay)

set_assay <- function(x, i, withDimnames = TRUE, ..., value) {
  plyxp(x, `assay<-`, i = i, withDimnames = withDimnames, ..., value = value)
}

#' @describeIn PlySummarizedExperiment-methods set assay in a PlySummarizedExperiment object
#' @export
setMethod(
  "assay<-",
  c("PlySummarizedExperiment", "missing"),
  function(x, i, withDimnames = TRUE, ..., value = value) {
    plyxp(x, `assay<-`, withDimnames = withDimnames, ..., value = value)
  }
)

#' @describeIn PlySummarizedExperiment-methods set assay in a PlySummarizedExperiment object
#' @export
setMethod("assay<-", c("PlySummarizedExperiment", "numeric"), set_assay)

#' @describeIn PlySummarizedExperiment-methods set assay in a PlySummarizedExperiment object
#' @export
setMethod("assay<-", c("PlySummarizedExperiment", "character"), set_assay)

#' @describeIn PlySummarizedExperiment-methods get rowData in a PlySummarizedExperiment object
#' @export
setMethod(
  "rowData",
  "PlySummarizedExperiment",
  function(x, use.names = TRUE, ...) {
    rowData(se(x), use.names = use.names, ...)
  }
)

#' @describeIn PlySummarizedExperiment-methods set rowData in a PlySummarizedExperiment object
#' @export
setMethod(
  "rowData<-",
  "PlySummarizedExperiment",
  function(x,
           ...,
           value) {
    plyxp(x, `rowData<-`, ..., value = value)
  }
)

#' @describeIn PlySummarizedExperiment-methods get colData in a PlySummarizedExperiment object
#' @export
setMethod(
  "colData",
  "PlySummarizedExperiment",
  function(x, ...) {
    colData(se(x), ...)
  }
)

#' @describeIn PlySummarizedExperiment-methods set colData in a PlySummarizedExperiment object
#' @export
setMethod(
  "colData<-",
  c("PlySummarizedExperiment", "DataFrame"),
  function(x, ..., value) {
    plyxp(x, `colData<-`, ..., value = value)
  }
)

#' @rdname PlySummarizedExperiment-methods
#' @export
setMethod(
  "colData<-",
  c("PlySummarizedExperiment", "NULL"),
  function(x, ..., value) {
    plyxp(x, `colData<-`, ..., value = value)
  }
)

#' @rdname PlySummarizedExperiment-methods
#' @export
setMethod(
  "metadata",
  c("PlySummarizedExperiment"),
  function(x, ...) {
    metadata(se(x), ...)
  }
)

#' @rdname PlySummarizedExperiment-methods
#' @export
setMethod(
  "metadata<-",
  c("PlySummarizedExperiment"),
  function(x, ..., value) {
    plyxp(x, `metadata<-`, ..., value = value)
  }
)


#' @rdname PlySummarizedExperiment-methods
#' @export
setMethod(
  "rownames",
  c("PlySummarizedExperiment"),
  function(x) {
    names(se(x))
  }
)


#' @rdname PlySummarizedExperiment-methods
#' @export
setMethod(
  "colnames",
  c("PlySummarizedExperiment"),
  function(x) {
    rownames(colData(x))
  }
)

#' @rdname PlySummarizedExperiment-methods
#' @export
setMethod("nrow", "PlySummarizedExperiment", function(x) length(se(x)))

#' @rdname PlySummarizedExperiment-methods
#' @export
setMethod("ncol", "PlySummarizedExperiment", function(x) nrow(colData(se(x))))

#' @rdname PlySummarizedExperiment-methods
#' @export
setMethod(
  "dimnames", "PlySummarizedExperiment",
  function(x) {
    list(rownames(x), colnames(x))
  }
)

#' @rdname PlySummarizedExperiment-methods
#' @export
setMethod(
  "dimnames<-", c("PlySummarizedExperiment", "list"),
  function(x, value) {
    plyxp(x, `dimnames<-`, value = value)
  }
)

#' @rdname PlySummarizedExperiment-methods
#' @export
setMethod(
  "dimnames<-", c("PlySummarizedExperiment", "NULL"),
  function(x, value) {
    plyxp(x, `dimnames<-`, value = list(NULL, NULL))
  }
)

test_that("Plyxp can be made from plyxp", {
  expect_identical(new_plyxp(se_simple), se_simple)
})

test_that("se() returns identity", {
  se_ <- se(se_simple)
  expect_identical(se(se_), se_)
})

test_that("`se<-`() will assign values", {
  se_ <- se(se_simple)
  rowData(se_)$foo <- 1L
  se_2 <- se(se_simple)
  se(se_2) <- se(se_)
  expect_identical(se_2, se_)
})

ctx_quo <- function(expr, env, ctx) {
  quo <- new_quosure(expr = expr, env = env)
  attr(quo, "plyxp:::ctx") <- ctx
  quo
}

enforce_named <- function(exprs) {
  to_update <- FALSE
  nms <- names(exprs) %||% {
    to_update <- TRUE
    vapply(exprs, rlang::as_label, "")
  }
  char_len <- nzchar(nms)
  if (any(to_rename <- char_len == 0)) {
    nms[to_rename] <- vapply(exprs[to_rename], rlang::as_label, "")
    to_update <- TRUE
  }
  if (to_update) {
    names(exprs) <- nms
  }
  exprs
}

as_trans_fn <- function(fn) {
  if (is_call(fn)) {
    if (identical(fn[[1]], quote(`function`))) {
      return(fn)
    }
  }
  if (is_function(fn)) {
    return(fn)
  }
  NULL
}

#' @title plyxp quosures
#' @description
#' a consistent way to handle `...` for dplyr extensions.
#' This returns a list of quosures where each quosure
#' contains an attribute `plyxp:::ctx` indicating which
#' mask context it should be evaluate in.
#' @param ... rlang dots, supports splicing an quoting
#' @param .named should resulting expressions be named?
#' @param .ctx A character string of availablecontexts. The first
#' element is considered to be the default context, whereas the
#' rest are considered optional.
#' @param .ctx_trans A list of functions to eventually apply to
#' the expressions depending on their context. The names of the list
#' elements should match the contexts names provided by `.ctx`. These
#' functions will be quoted and in-lined into the expressions and thus
#' cannot rely on the environments the functions are constructed.
#' These functions are quoted
#' @return a quosure with attribute `plyxp:::ctx`.
#' @examples
#'
#' # in plyxp the default context is "assays"
#' # and optional contexts are "rows" and "cols"
#' quos <- plyxp_quos(
#'   foo = bar,
#'   ctx2(foo = bar),
#'   ctx3(foo = bar),
#'   .ctx_default = "ctx1",
#'   .ctx_opt = c("ctx2", "ctx3")
#' )
#' attr(quos[[1]], "plyxp:::ctx")
#' attr(quos[[2]], "plyxp:::ctx")
#' attr(quos[[3]], "plyxp:::ctx")
#'
#' @noRd
plyxp_quos <- function(
    ...,
    .named = TRUE,
    .ctx = NULL,
    .trans = list()) {
  #
  dots <- quos(...) |>
    as.list()
  if (is.null(.ctx)) rlang::abort("`.ctx` must be specified!")
  if (!is.list(.trans)) rlang::abort("`.trans` must be a list!")
  .trans <- lapply(.trans, as_trans_fn)
  .ctx_default <- .ctx[1] %||% rlang::abort("`.ctx` have at least 1 element!")
  .ctx_opt <- .ctx[-1]
  has_opt_ctx <- length(.ctx_opt) > 0
  # ctx_opt <- c("cols", "rows")
  nms <- rlang::names2(dots)
  is_nms <- nms != ""
  for (i in seq_along(dots)) {
    quo <- dots[[i]]
    if (quo_is_missing(quo)) {
      # skip missing quosures
      next
    }
    .env <- quo_get_env(quo)
    .expr <- quo_get_expr(quo)
    if (has_opt_ctx && is_call(.expr, .ctx_opt)) {
      ctx <- as_label(.expr[[1]])
      ctx_exprs <- as.list(.expr[-1])
      # recapture the inner arguments allowing for dynamic
      # dots and using `"{foo}" := bar` notation
      ctx_exprs <- rlang::inject(rlang::exprs(!!!ctx_exprs), env = .env)
      ctx_nms <- rlang::names2(ctx_exprs)
      ctx_is_named <- ctx_nms != ""
      ctx_quos <- pmap(
        list(ctx_exprs,
          name = ctx_nms, is_named = ctx_is_named
        ),
        plyxp_quo,
        env = .env,
        ctx = ctx,
        trans = .trans[[ctx]]
      )
      # remove empty arguments from calls
      ctx_quos <- Filter(Negate(rlang::quo_is_missing), ctx_quos)
      dots[[i]] <- splice(ctx_quos)
      next
    }

    dots[[i]] <- plyxp_quo(
      .expr,
      env = .env,
      ctx = .ctx_default,
      is_named = is_nms[i],
      name = nms[i],
      trans = .trans[[.ctx_default]]
    )
  }
  out <- do.call(dots_list, c(dots, list(.named = .named)))
  out <- Filter(Negate(is.null), out)
  if (.named) {
    # in case the prior expansion
    # of rows(...) and cols(...) need
    # a named argument
    out <- enforce_named(out)
  }
  out
}

plyxp_quo <- function(expr, env, ctx, trans, ...) {
  quo <- new_quosure(expr = expr, env = env)
  attr(quo, "plyxp:::ctx") <- ctx
  attr(quo, "plyxp:::transform") <- trans
  attr(quo, "plyxp:::data") <- list2(...)
  quo
}

enforce_matrix <- function(quos, ctxs) {
  is_assay_ctx <- ctxs == "assays"
  quos[is_assay_ctx] <- lapply(
    quos[is_assay_ctx],
    function(quo) {
      if (is.null(quo_get_expr(quo))) {
        return(quo)
      } else {
        quo <- quo_set_expr(
          quo,
          expr(
            matrix(
              !!quo,
              nrow = `plyxp:::ctx:::nrow`,
              ncol = `plyxp:::ctx:::ncol`
            )
          )
        )
        if (identical(quo_get_env(quo), empty_env())) {
          quo <- quo_set_env(quo, base_env())
        }
        quo
      }
    }
  )
  quos
}


quos_is_named <- function(quos) {
  lapply(quos, attr, which = "plyxp:::data") |>
    vapply(`[[`, "is_named", FUN.VALUE = logical(1))
}

quos_enforce_named <- function(quos, names) {
  for (i in seq_along(quos)) {
    data <- attr(quos[[i]], "plyxp:::data")
    data$is_named <- TRUE
    data$name <- names[i]
    attr(quos[[i]], "plyxp:::data") <- data
  }
  quos
}

#' @title expand across quosure
#' @description This function will transform a quosure
#' that uses the `across()` function and split it into a list
#' of quosures with the appropriate data to loop along. If the
#' quosure does not use `across()`, the quosure is returned as-is
#' in a list.
#' @param quo a quosure
#' @param ctx retrieves the current evaluation context of the quosure
#' @param mask the R6 mask-manager of all `rlang` data mask contexts
#' @param error_call function call to report there was an error if one is raised
#' @noRd
expand_across <- function(quo, ctx = attr(quo, "plyxp:::ctx"),
                          mask, error_call) {
  if (!quo_is_call(quo, "across", ns = c("", "dplyr"))) {
    return(list(quo))
  }
  #
  env <- quo_get_env(quo)
  expr <- match.call(
    definition = dplyr::across,
    call = quo_get_expr(quo),
    expand.dots = FALSE,
    envir = env
  )
  if (".cols" %in% names(expr)) {
    cols <- expr$.cols
  } else {
    # across_missing_cols_deprecate_warn()
    cols <- expr(everything())
  }
  cols <- as_quosure(cols, env)
  if (".fns" %in% names(expr)) {
    fns <- as_quosure(expr$.fns, env)
    # validate_fns <- dplyr:::quo_eval_fns
    fns <- validate_fns(fns,
      mask = mask$masks[[ctx]]$environments[[1]],
      error_call = error_call
    )
  } else {
    fns <- NULL
  }

  setup <- plyxp_across_setup(!!cols,
    fns = fns, names = eval(expr$.names),
    mask = mask$masks[[ctx]], manager = mask,
    error_call = error_call, .caller_env = env,
    ctx = ctx
  )

  vars <- setup$vars
  fns <- setup$fns
  names <- setup$names

  n_vars <- length(vars)
  n_fns <- length(fns)
  seq_vars <- seq_len(n_vars)
  seq_fns <- seq_len(n_fns)
  expressions <- vector(mode = "list", n_vars * n_fns)
  # columns <- character(n_vars * n_fns)
  k <- 1L
  for (i in seq_vars) {
    var <- vars[[i]]
    for (j in seq_fns) {
      var <- sym(var)
      fn <- fns[[j]]
      fn_call <- as_across_expr(fn, var)
      name <- names[[k]]
      expressions[[k]] <- plyxp_quo(fn_call,
        ctx = ctx, env = env,
        name = name,
        is_named = TRUE,
        column = var,
        trans = NULL
      )
      k <- k + 1L
    }
  }
  if (setup$ctx_swap) {
    ctx_swap <- switch(setup$ctx_swap,
      assays = expr(assay_ctx),
      rows = expr(row_ctx),
      cols = expr(col_ctx)
    )
    for (k in seq_along(expressions)) {
      quo <- expressions[[k]]
      expr_ <- quo_get_expr(quo)
      expressions[[k]] <- quo_set_expr(
        quo,
        expr((!!expr_) |> (!!ctx_swap)())
      )
    }
  }
  names(expressions) <- names
  expressions
}

#' @title setup across
#' @description
#' generate the list of new quosures based on the selected columns, functions
#' and returned names.
#' @param cols selected columns from across tidy-select
#' @param fns functions to apply to each selected column
#' @param names names to save the results into
#' @param mask specific data mask for evaluation context
#' @param ctx the evaluation context name
#' @param manager the R6 mask-manager
#' @param .caller_env environment the original quosure sure be evaluated within
#' @param error_call function call to report there was an error if one is raised
#' @noRd
plyxp_across_setup <- function(cols, fns, names, mask, ctx,
                               manager, .caller_env, error_call) {
  cols <- enquo(cols)
  if (is.null(fns) && quo_is_call(cols, "~")) {
    bullets <- c("Must supply a column selection.",
      i = glue::glue("You most likely meant: `{across_if_fn}(everything(), {as_label(cols)})`."),
      i = "The first argument `.cols` selects a set of columns.",
      i = "The second argument `.fns` operates on each selected columns."
    )
    rlang::abort(bullets, call = error_call)
  }
  ## check if cols is contextual
  ## suppose we are in rows_ctx, but want
  ## to do something across the assays...
  ctx_swap <- FALSE
  if (quo_is_call(cols, c("assays", "rows", "cols"), n = 0)) {
    ctx_swap <- TRUE
    ctx <- as_label(quo_get_expr(cols)[[1]])
    cols <- quo_set_expr(cols, expr(everything()))
  }

  if (identical(quo_get_expr(cols), quote(everything())) &&
    ctx %in% c("rows", "cols")) {
    # if identitcal AND we are in rows/cols context
    # explicitly change expr to remove either
    # .features/.samples.
    # These should only be changed
    rm <- switch(ctx,
      rows = expr(-.features),
      cols = expr(-.samples)
    )
    cols <- quo_set_expr(cols, rm)
  }

  data <- manager$masks[[ctx]]$ptype
  vars <- tidyselect::eval_select(cols, data = data, error_call = error_call)
  names_vars <- names(vars)
  vars <- names(data)[vars]
  # if (is.null(fns)) {
  #   if
  # }

  if (is.function(fns)) {
    names <- names %||% "{.col}"
    fns <- list(`1` = fns)
  } else {
    names <- names %||% "{.col}_{.fn}"
  }
  if (!is.list(fns) || length(fns) == 0L) {
    rlang::abort(
      c("Unxpected argument for `.fns`. across() expects one of:",
        i = "a function or lambda function",
        i = "a non-zero length list of functions or lambda functions"
      )
    )
  }
  if (is.null(names(fns))) {
    names_fns <- seq_along(fns)
  } else {
    names_fns <- names2(fns)
    empties <- which(names_fns == "")
    if (length(empties)) {
      names_fns[empties] <- empties
    }
  }

  glue_env <- env(.caller_env,
    .col = vec_rep_each(names_vars, times = length(fns)),
    .fn = vec_rep(names_fns, times = length(vars))
  )
  names <- vctrs::vec_as_names(glue::glue(names, .envir = glue_env),
    repair = "check_unique",
    call = error_call
  )
  list(
    vars = vars, fns = fns, names = names, ctx = ctx,
    ctx_swap = ctx_swap
  )
}

#' @title dplyr across internals
#' @name dplyr_across_internals
#' @description
#' the following functions were taken verbatim from the `dplyr` package such
#' that behaviors of `across()` were consistent between `dplyr` and `plyxp`
#' @keywords internal
#' @noRd
expr_substitute <- function(expr, old, new) {
  expr <- duplicate(expr)
  switch(typeof(expr),
    language = node_walk_replace(node_cdr(expr), old, new),
    symbol = if (identical(expr, old)) {
      return(new)
    }
  )
  expr
}

# @rdname dplyr_across_internals
node_walk_replace <- function(node, old, new) {
  while (!is_null(node)) {
    switch(typeof(node_car(node)),
      language = {
        if (!is_call(node_car(node), c("~", "function")) ||
          is_call(node_car(node), "~", n = 2)) {
          node_walk_replace(node_cdar(node), old, new)
        }
      },
      symbol = if (identical(node_car(node), old)) node_poke_car(node, new)
    )
    node <- node_cdr(node)
  }
}

# @rdname dplyr_across_internals
as_across_expr <- function(fn, var) {
  if (is_inlinable_lambda(fn)) {
    arg <- names(formals(fn))[[1]]
    expr <- body(fn)
    expr_substitute(expr, sym(arg), sym(var))
  } else {
    call2(fn, sym(var))
  }
}

# @rdname dplyr_across_internals
is_inlinable_lambda <- function(x) {
  is_function(x) && identical(fn_env(x), empty_env())
}

# @rdname dplyr_across_internals
validate_fns <- function(quo, mask, error_call = caller_env()) {
  sentinel_env <- empty_env()
  this <- current_env()
  out <- eval_tidy(quo({
    this$sentinel_env <- current_env()
    !!quo
  }))
  validate <- function(x) {
    if (is_formula(x) || is_function(x)) {
      if (identical(get_env(x), sentinel_env)) {
        if (is_inlinable_function(x)) {
          return(set_env(x, empty_env()))
        }
        if (is_inlinable_formula(x)) {
          x <- expr_substitute(x, quote(.), quote(.x))
          fn <- new_function(
            pairlist2(.x = ), f_rhs(x),
            empty_env()
          )
          return(fn)
        }
        x <- set_env(x, mask)
      }
      as_function(x, arg = ".fns", call = error_call)
    } else {
      rlang::abort("`.fns` must be a function, a formula, or a list of functions/formulas.",
        call = error_call
      )
    }
  }
  if (obj_is_list(out)) {
    map(out, function(elt) validate(elt))
  } else {
    validate(out)
  }
}

# @rdname dplyr_across_internals
is_inlinable_function <- function(x) {
  if (!is_function(x)) {
    return(FALSE)
  }
  fmls <- formals(x)
  if (length(fmls) != 1) {
    return(FALSE)
  }
  if ("return" %in% all.names(body(x))) {
    return(FALSE)
  }
  TRUE
}

# @rdname dplyr_across_internals
is_inlinable_formula <- function(x) {
  if (!is_formula(x, lhs = FALSE)) {
    return(FALSE)
  }
  nms <- all.names(x)
  unsupported_arg_rx <- "\\.\\.[0-9]|\\.y"
  if (any(grepl(unsupported_arg_rx, nms))) {
    return(FALSE)
  }
  if ("return" %in% nms) {
    return(FALSE)
  }
  TRUE
}

#' @importFrom dplyr summarize summarise
NULL

#' @name summarize
#' @title Summarize PlySummarizedExperiment
#' @param .data An object Inheriting from `PlySummarizedExperiment`, the wrapper
#' class for `SummarizedExperiment` objects
#' @param ... expressions to summarize the object
#' @param .retain This argument controls how `rowData()` or `colData()` is retained
#' after summarizing. When "auto" (the default), `.retain` behavior depends on
#' the groupings of `.data`. When exactly one dimension is grouped, "auto"
#' behaves like "ungrouped-dim", and "none" otherwise. When "ungrouped-dim",
#' the ungrouped dimension's data are retained in the resulting
#' `SummarizedExperiment` object and scalar outputs are recycled to the length
#' of the ungrouped dimension. When "none", all outputs are expected to be
#' scalar and only computed values are retained in `rowData()` and `colData()`
#' @aliases summarise
#' @return an object inheriting PlySummarizedExperiment class
#' @examples
#'
#' # outputs in assay context may be either
#' # length 1, or the length of the ungrouped
#' # dimension while .retain = "auto"/"ungrouped-dim"
#' se_simple |>
#'   group_by(rows(direction)) |>
#'   summarise(
#'     col_sums = colSums(counts),
#'     sample = sample(1:20, 1L)
#'   )
#'
#' # .retain = "none" will drop ungrouped dimensions and
#' # outputs of assay context should be length 1.
#' se_simple |>
#'   group_by(rows(direction)) |>
#'   summarise(
#'     col_sums = list(colSums(counts)),
#'     .retain = "none"
#'   )
#'
#' # using an `across()` function will help
#' # nest ungrouped dimensions
#' se_simple |>
#'   group_by(rows(direction)) |>
#'   summarise(
#'     col_sums = list(colSums(counts)),
#'     cols(across(everything(), list)),
#'     .retain = "none"
#'   )
#'
#' @export
summarize.PlySummarizedExperiment <- function(.data, ...,
                                              .retain = c("auto", "ungrouped", "none")) {
  plyxp(.data, summarize_se_impl, ..., .retain = .retain)
}

summarize_se_impl <- function(.data, ...,
                              .retain = c("auto", "ungrouped", "none")) {
  .env <- caller_env()

  .groups <- group_data_se_impl(.data)
  .retain <- match.arg(.retain, choices = c("auto", "ungrouped", "none"))
  .retain <- switch(.retain,
    auto = !is.null(.groups),
    ungrouped = TRUE,
    none = FALSE
  )
  mask <- new_plyxp_manager.SummarizedExperiment(obj = .data)
  poke_ctx_local("plyxp:::caller_env", .env)
  poke_ctx_local("plyxp:::manager", mask)
  poke_ctx_local("plyxp:::dplyr_verb", "summarise")
  quos <- plyxp_quos(..., .ctx = c("assays", "rows", "cols"))
  ctxs <- vapply(quos, attr, FUN.VALUE = "", which = "plyxp:::ctx")

  nms <- names(quos)
  mask <- plyxp_evaluate(mask, quos, ctxs, nms, .env)
  chops <- mask$apply(\(m) lapply(m$added, m$get_chop))
  assay_chops <- chops$assays
  group_vars_ <- group_vars_se_impl(.data)
  row_data <- col_data <- NULL
  .nrow <- .ncol <- 1L
  row_chops_sizes <- col_chops_sizes <- 1L
  row_names <- col_names <- NULL
  grouped_rows <- is_grouped_rows(.groups)
  grouped_cols <- is_grouped_cols(.groups)
  is_grouped <- grouped_rows || grouped_cols
  .byrow <- FALSE
  if (grouped_rows || "rows" %in% ctxs) {
    # get all chop data, groups and evaled
    row_chops <- chops$rows
    if (grouped_rows) {
      row_group_vars <- group_vars_$row_groups
      row_group_vars <- row_group_vars[!row_group_vars %in% names(row_chops)]
      row_chops <- c(
        as.list(.groups$row_groups[row_group_vars]),
        row_chops
      )
    }
    # some settings
    if (.retain && !grouped_rows) {
      row_chops_sizes <- .nrow <- nrow(.data)
    } else {
      .byrow <- TRUE
      row_chops_sizes <- .nrow <- 1L
      if (grouped_rows) {
        .nrow <- nrow(.groups$row_groups)
        # slice grouped columns
        row_chops[group_vars_$row_groups] <- map(
          row_chops[group_vars_$row_groups],
          function(group_vec) {
            map(group_vec, vec_slice, 1L)
          }
        )
      }
    }
    # recycle each chop to required length
    row_chops <- assert_chops_size(row_chops, size = row_chops_sizes)
    row_data <- methods::new(
      "DFrame",
      listData = map(
        row_chops,
        vctrs::list_unchop
      ),
      nrows = .nrow
    )
  }
  if (grouped_cols || "cols" %in% ctxs) {
    # get all of the chops, including any groups
    col_chops <- chops$cols
    if (grouped_cols) {
      col_group_vars <- group_vars_$col_groups
      col_group_vars <- col_group_vars[!col_group_vars %in% names(col_chops)]
      col_chops <- c(
        as.list(.groups$col_groups[col_group_vars]),
        col_chops
      )
    }
    # settings
    if (.retain && !grouped_cols) {
      col_chops_sizes <- .ncol <- ncol(.data)
    } else {
      .byrow <- FALSE
      col_chops_sizes <- .ncol <- 1L
      if (grouped_cols) {
        .ncol <- nrow(.groups$col_groups)
        # if grouped, grab only the first instance
        col_chops[group_vars_$col_groups] <- map(
          col_chops[group_vars_$col_groups],
          function(group_vec) {
            map(group_vec, vec_slice, 1L)
          }
        )
      }
    }
    # recycle each chop to required length
    col_chops <- assert_chops_size(col_chops, size = col_chops_sizes)
    col_data <- methods::new(
      "DFrame",
      listData = map(
        col_chops,
        vctrs::list_unchop
      ),
      nrows = .ncol
    )
  } else {
    col_data <- methods::new("DFrame",
      listData = set_names(list(), character()),
      nrows = .ncol
    )
  }
  # finally, if retained and not grouped, reassign back
  # to original row_data/col_data
  if (.retain) {
    if (!grouped_rows) {
      row_chops_sizes <- .nrow <- nrow(.data)
      row_data <- replace(rowData(.data), names(row_data), row_data)
    }
    if (!grouped_cols) {
      col_chops_sizes <- .ncol <- ncol(.data)
      col_data <- replace(colData(.data), names(col_data), col_data)
    }
  }


  if (".features" %in% names(row_data)) {
    row_names <- row_data$.features
    row_data$.features <- NULL
  }
  if (".samples" %in% names(col_data)) {
    col_names <- col_data$.samples
    col_data$.samples <- NULL
  }

  # we should have some type of value to view from
  # assays as it was enforced earlier.
  assay_data <- assert_chops_size(assay_chops,
    size = row_chops_sizes * col_chops_sizes
  ) |>
    map(
      vctrs::list_unchop
    ) |>
    map(
      matrix,
      nrow = .nrow,
      ncol = .ncol,
      byrow = .byrow
    )

  out <- SummarizedExperiment(
    assays = assay_data,
    rowData = row_data,
    colData = col_data,
    metadata = metadata(.data),
    checkDimnames = FALSE
  )
  if (!is.null(row_names)) {
    rownames(out) <- row_names
  }
  if (!is.null(col_names)) {
    colnames(out) <- col_names
  }
  if (is_grouped) {
    group_data_se_impl(out) <- plyxp_groups(
      row_data[group_vars_$row_groups],
      col_data[group_vars_$col_groups]
    )
  }
  out
}


#' @rdname summarize
#' @export
summarise.PlySummarizedExperiment <- summarize.PlySummarizedExperiment


assert_chops_size <- function(chops, size = 1L) {
  imap(
    chops,
    function(vec, name, size) {
      # get the underlying vec_recycle
      # method for this vec class
      fn <- method(vec_recycle, object = vec[[1]])
      map(vec, fn, size = size, x_arg = name)
    },
    size = size
  )
}

mask_pull_chops <- function(mask, names = NULL) {
  chop_env <- mask$environments@env_data_chop
  names <- names %||% mask$added
  names(names) <- names
  lapply(names, function(name) chop_env[[name]])
}

get_mask_chops <- function(mask) {
  lapply(mask$masks, mask_pull_chops)
}

#' @importFrom dplyr mutate

#' @name mutate
#' @title Mutate a PlySummarizedExperiment object
#' @description
#' Mutate a PlySummarizedExperiment object under an data mask. Unlike a few other
#' `dplyr` implementations, all contextual evaluations of `mutate()` for
#' `SummarizedExperiment` are valid.
#' @param .data An object Inheriting from `PlySummarizedExperiment`, the wrapper
#' class for `SummarizedExperiment` objects
#' @param ... expressions to evaluate
#' @return an object inheriting PlySummarizedExperiment class
#' @examples
#'
#' mutate(se_simple,
#'   counts_1 = counts + 1,
#'   logp_counts = log(counts_1),
#'   # access assays context with ".assays" pronoun,
#'   # note that assays are sliced into a list to
#'   # fit dimensions of cols context
#'   cols(sum = purrr::map_dbl(.assays$counts, sum)),
#'   # access assays context "asis" with the same pronoun
#'   # but with a "_asis" suffix.
#'   rows(sum = rowSums(.assays_asis$counts))
#' )
#' @export
mutate.PlySummarizedExperiment <- function(.data, ...) {
  plyxp(.data, mutate_se_impl, ...)
}

mutate_se_impl <- function(.data, ...) {
  #
  .env <- caller_env()
  mask <- new_plyxp_manager.SummarizedExperiment(obj = .data)
  poke_ctx_local("plyxp:::caller_env", .env)
  poke_ctx_local("plyxp:::manager", mask)
  poke_ctx_local("plyxp:::dplyr_verb", "mutate")
  quos <- plyxp_quos(
    ...,
    .ctx = c("assays", "rows", "cols"),
    .trans = list(
      assays = quote(\(.data) {
        matrix(
          .data,
          nrow = `plyxp:::ctx:::nrow`,
          ncol = `plyxp:::ctx:::ncol`
        )
      })
    )
  )
  ctxs <- vapply(quos, attr, FUN.VALUE = "", which = "plyxp:::ctx")
  nms <- names(quos)
  mask <- plyxp_evaluate(mask, quos, ctxs, nms, .env)
  results <- mask$results()

  nms <- names(results$rows)
  if (length(nms)) {
    if (".features" %in% nms) {
      rownames(.data) <- results$rows$.features
      results$rows$.features <- NULL
      nms <- names(results$rows)
    }
    for (i in seq_along(results$rows)) {
      rowData(.data)[[nms[i]]] <- results$rows[[i]]
    }
  }

  nms <- names(results$cols)
  if (length(nms)) {
    if (".samples" %in% nms) {
      colnames(.data) <- results$cols$.samples
      results$cols$.samples <- NULL
      nms <- names(results$cols)
    }
    for (i in seq_along(results$cols)) {
      colData(.data)[[nms[i]]] <- results$cols[[i]]
    }
  }
  # set assays last to reset dimnames
  nms <- names(results$assays)
  dim_nms <- dimnames(.data)
  for (i in seq_along(results$assays)) {
    new_assay <- results$assays[[i]]
    if (!is.null(new_assay)) {
      # could be removing in which we cannot set
      # this attrib
      dimnames(new_assay) <- dim_nms
    }
    assay(.data, nms[i], withDimnames = FALSE) <- new_assay
  }

  .data
}

abort_invalid_quo <- function() {
  rlang::abort("`plyxp_manager$eval()` requires quosure from `plyxp_quosures()`",
    class = "plyxp_invalid_quo"
  )
}

# [`new_plyxp_manager()`][plyxp::new_plyxp_manager]

#' @title `plyxp` Data Mask Manager
#' @name PlyxpMaskManager
#' @description
#' This object organizes serveral plyxps, allowing
#' expressions to be evaluated in different contexts. This object is the return
#' value of `new_plyxp_manager()`s
#'
#' The "connectedness" of each mask managed by this object is dependent on the
#' developer. The plyxps passed to `.mask` argument may stem from the same
#' shared environment, or may have cyclical relationships.
#' @return An R6 object inheriting `plyxp_manager`
#'
#' @noRd
plyxp_manager <- R6::R6Class(
  "plyxp_manager",
  public = list(
    #' @param .data Original data
    #' @param .masks list of named plyxp objects
    #' @param .ctx_env shared context environment
    #' @param .extended_env other extended environments
    initialize = function(.data, .masks, .ctx_env, .extended_env) {
      private$.data <- .data
      private$.masks <- .masks
      private$.ctx_env <- .ctx_env
      private$.extended_env <- .extended_env
    },
    #' @description
    #' provides a sequence for iterate over the groups
    along_ctx = function() {
      seq_len(private$.ctx_env[["plyxp:::n_groups"]])
    },
    #' @description
    #' eval an expression in the current context
    #' @param quo a quosure or quoted expression
    #' @param env an environment
    #' @return returns evaluated `quo` in the form of a chop
    eval = function(quo, env = caller_env()) {
      mask <- private$.masks[[private$.ctx_env[["plyxp:::ctx"]]]]
      # expand across into more plyxp_quos
      quos <- expand_across(quo, mask = self, error_call = caller_call())
      for (k in seq_along(quos)) {
        quo <- quos[[k]]
        quo_data <- attr(quo, "plyxp:::data") %||% abort_invalid_quo()
        chop_out <- plyxp_manager_eval(
          quo = quo,
          env = env,
          n_groups = self$n_groups,
          mask = mask,
          private = private
        )
        name <- if (quo_data$is_named) {
          quo_data$name
        } else {
          as_label(quo_get_expr(quo))
        }
        mask$bind(name = name, value = chop_out)
      }
      invisible(self)
    },
    #' @description
    #' collections the envaluated result of a given name
    result = function(name) {
      self$apply(function(m, name) m$unchop(name), name = name)
    },
    #' @description
    #' collects the evaluated results with plyxps
    #' @param .from_masks index vector from which masks to collect results.
    #' a missing argument will collect all results.
    #' @return named list for each mask containing named list of evaluated
    #' expressions.

    results = function(.from_masks) {
      self$apply(function(m) m$results(), .on_masks = .from_masks)
    },
    #' @description
    #' apply a function to each mask this object manages
    #' @param .f a function to apply to the managed masks
    #' @param ... additional arguments to pass to `.f`
    #' @param .on_masks index vector indicating which masks to apply `.f` to.
    #' a missing argument will collect all results.
    #' @return named list containing the results of each function
    apply = function(.f, ..., .on_masks) {
      lapply(private$.masks[.on_masks], .f, ...)
    }
  ),
  active = list(
    #' @field ctx get and set the current context
    ctx = function(ctx) {
      if (!missing(ctx)) {
        private$.ctx_env[["plyxp:::ctx"]] <- match.arg(
          ctx,
          c("assays", "rows", "cols")
        )
      }
      private$.ctx_env[["plyxp:::ctx"]]
    },
    #' @field ctx_mask get the current context plyxp
    ctx_mask = function(value) {
      if (!missing(value)) stop("`$ctx_mask` is read only")
      private$.masks[[self$ctx]]
    },
    #' @field n_groups get the current context plyxp group size
    n_groups = function(value) {
      if (!missing(value)) stop("`$n_groups` is read only")
      private$.ctx_env[["plyxp:::n_groups"]]
    },
    #' @field group_id get and set the current context plyxp group id
    group_id = function(id) {
      if (!missing(id)) {
        private$.ctx_env[["plyxp:::ctx:::group_id"]] <- id
      }
      private$.ctx_env[["plyxp:::ctx:::group_id"]]
    },
    #' @field masks get the private list of masks
    masks = function(value) {
      if (!missing(value)) stop("`$masks` is read only")
      private$.masks
    },
    #' @field extended other environments extended from a context mask.
    extended = function(value) {
      if (!missing(value)) stop("`$exteded` is read only")
      private$.extended_env[[private$.ctx_env[["plyxp:::ctx"]]]]
    }
  ),
  private = list(
    .data = NULL,
    .masks = list(),
    .ctx_env = NULL,
    .extended_env = list()
  )
)

# Created this scoped function so that on.exit could be called
# in case of an error. Need to write test
# mutate(se, counts = stop("check rlang::env_parents()"))
plyxp_manager_eval <- function(quo, env, n_groups, mask, private) {
  chop_out <- vector("list", n_groups)
  if (!is.null(quo_get_expr(quo))) {
    # weird bug with eval_tidy?
    # parent structure gets changed
    on.exit(env_poke_parent(top_env, baseenv()), add = TRUE)
    for (i in seq_len(n_groups)) {
      private$.ctx_env[["plyxp:::ctx:::group_id"]] <- i
      result <- mask$eval(quo, env = env)
      chop_out[[i]] <- result
    }
  }
  chop_out
}

## created for a hypothetical usage of passing a `plyxp_manager`
## as the data argument to `plyxp_eval_select()`.
## This use case is not used within the package, so we should not
## write documentation for something that isn't used until we actual
## use it...
# setOldClass("plyxp_manager")
#
# setMethod("assays", signature = "plyxp_manager",
#           definition = function(x, withDimnames = TRUE, ...) {
#             x$masks[["assays"]]$ptype
#           })
#
# setMethod("rowData", signature = "plyxp_manager",
#           definition = function(x, withDimnames = TRUE, ...) {
#             x$masks[["rows"]]$ptype
#           })
#
# setMethod("colData", signature = "plyxp_manager",
#           definition = function(x, withDimnames = TRUE, ...) {
#             x$masks[["cols"]]$ptype
#           })

#' @returns
#' API for using S4 classes with rlang data masks
#' @keywords internal
"_PACKAGE"

## usethis namespace: start
#' @import rlang
#' @importFrom dplyr across
#' @importFrom dplyr arrange
#' @importFrom dplyr bind_cols
#' @importFrom dplyr everything
#' @importFrom dplyr filter
#' @importFrom dplyr group_by
#' @importFrom dplyr group_data
#' @importFrom dplyr group_vars
#' @importFrom dplyr group_split
#' @importFrom dplyr groups
#' @importFrom dplyr mutate
#' @importFrom dplyr n
#' @importFrom dplyr pull
#' @importFrom dplyr reframe
#' @importFrom dplyr rename
#' @importFrom dplyr rename_with
#' @importFrom dplyr rows_update
#' @importFrom dplyr select
#' @importFrom dplyr summarise
#' @importFrom dplyr slice
#' @importFrom dplyr ungroup
#' @importFrom methods new
#' @importFrom pillar align
#' @importFrom pillar ctl_new_pillar
#' @importFrom pillar ctl_new_rowid_pillar
#' @importFrom pillar dim_desc
#' @importFrom pillar new_ornament
#' @importFrom pillar new_pillar
#' @importFrom pillar new_pillar_shaft
#' @importFrom pillar new_pillar_shaft_simple
#' @importFrom pillar pillar
#' @importFrom pillar pillar_component
#' @importFrom pillar pillar_shaft
#' @importFrom pillar style_subtle
#' @importFrom pillar tbl_format_footer
#' @importFrom pillar tbl_format_setup
#' @importFrom pillar tbl_sum
#' @importFrom purrr imap
#' @importFrom purrr iwalk
#' @importFrom purrr map
#' @importFrom purrr map_int
#' @importFrom purrr map2
#' @importFrom purrr pmap
#' @importFrom purrr reduce
#' @importFrom purrr walk
#' @importFrom rlang .env
#' @importFrom S4Vectors metadata
#' @importFrom S4Vectors metadata<-
#' @importFrom S7 method
#' @importFrom S7 method<-
#' @importFrom S7 new_generic
#' @importFrom S7 S7_dispatch
#' @importFrom SummarizedExperiment assay
#' @importFrom SummarizedExperiment assay<-
#' @importFrom SummarizedExperiment assays
#' @importFrom SummarizedExperiment assays<-
#' @importFrom SummarizedExperiment colData
#' @importFrom SummarizedExperiment colData<-
#' @importFrom SummarizedExperiment rowData
#' @importFrom SummarizedExperiment rowData<-
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom tibble as_tibble
#' @importFrom tibble tibble
#' @importFrom tidyr nest unnest chop
#' @importFrom tidyselect eval_select
#' @importFrom tidyselect starts_with
#' @importFrom utils .AtNames
#' @importFrom vctrs field
#' @importFrom vctrs new_list_of
#' @importFrom vctrs new_rcrd
#' @importFrom vctrs obj_is_list
#' @importFrom vctrs vec_check_size
#' @importFrom vctrs vec_ptype
#' @importFrom vctrs vec_ptype_abbr
#' @importFrom vctrs vec_recycle_common
#' @importFrom vctrs vec_restore
#' @importFrom vctrs vec_size_common
## usethis namespace: end
NULL

# rlang functions -- figure out all dependencies later
# abort %||% is_empty eval_tidy quo_set_env new_data_mask
# call2 new_quosure expr caller_env new_environment as_label splice enquos
# dots_list env_bind env_bind_lazy env_bind_active new_function is_expression
# env_parents inject as_data_pronoun quo_get_env syms

#' @name as.data.frame
#' @title create data.frame
#' @param x `SummarizedExperiment` object
#' @param ... unused arguments
#' @return a data.frame object
#' @examples
#' as.data.frame(se_simple)
#'
#' @export
as.data.frame.PlySummarizedExperiment <- function(x, ...) {
  x <- se(x)
  nc <- ncol(x)
  nr <- nrow(x)
  nn <- nc * nr
  .features <- rownames(x) %||% as.character(seq_len(nr))
  .samples <- colnames(x) %||% as.character(seq_len(nc))
  out <- c(
    list(
      .features = vec_rep(.features, times = nc),
      .samples = vec_rep_each(.samples, times = nr)
    ),
    lapply(assays(x), as_vec),
    lapply(rowData(x), vec_rep, times = nc),
    lapply(colData(x), vec_rep_each, times = nr)
  )
  attr(out, "row.names") <- c(NA_integer_, -nn)
  class(out) <- "data.frame"
  out
}

##########
# UNUSED #
##########

# this function is likely going to be unused in the future. This was made to
# address a possible branch the codebase was possibly going towards, specifically
# for multi-grouped contexts and cross referencing issues.
# The NEW (and likely more stable assumption) is that if multigrouped context
# exists and we try to access colData from a row context, we pull the colData
# as-is, without being grouped.
case_key <- function(x, ...) {
  if (!inherits(x, "vctrs_grouped_list")) {
    cli::cli_abort(
      "x is not a {.cls vctrs_grouped_list}"
    )
  }
  group_keys <- attr(x, ".key")
  env <- current_env()
  dots <- list2(...)
  n_args <- length(dots)
  pairs <- map(dots, \(x) {
    list(lhs = f_lhs(x), rhs = f_rhs(x))
  })
  lhs_eval <- vector("list", n_args)
  rhs_eval <- vector("list", n_args)
  for (i in seq_along(dots)) {
    pair <- pairs[[i]]
    lhs_eval[[i]] <- eval_tidy(pair$lhs, env = env)
    rhs_eval[[i]] <- eval_tidy(pair$rhs, data = group_keys)
  }
  .size <- vec_size_common(!!!lhs_eval)
  conditions <- vec_recycle_common(!!!lhs_eval, .size = .size)
  seen <- logical(.size)
  out <- vector("list", .size)
  for (i in seq_along(conditions)) {
    cond <- conditions[[i]]
    selection <- rhs_eval[[i]]
    adding <- (!seen) & cond
    out[adding] <- map2(x[adding], list(selection), ~ .x[.y])
    seen <- seen | adding
    if (all(seen)) break
  }

  if (all(map_int(out, length) == 1L)) {
    out <- unlist(out, recursive = FALSE)
  }
  out
}

#' @name arrange
#' @title arrange rows or columns of PlySummarizedExperiment
#' @description
#' `arrange()` orders either the rows or columns of a `PlySummarizedExperiment`
#' object. Note, to guarentee a valid `PlySummarizedExperiment` is returned,
#' arranging in the `assays` evaluation context is disabled.
#'
#' Unlike other dplyr verbs, `arrange()` largely ignores grouping. The
#' `PlySummarizedExperiment` method also provides the same functionality via the
#' `.by_group` argument.
#'
#' @param .data An object Inheriting from `PlySummarizedExperiment`, the wrapper
#' class for `SummarizedExperiment` objects
#' @inheritParams dplyr::arrange
#' @return an object inheriting `PlySummarizedExperiment` class
#' @examples
#'
#' # arrange within rows/cols contexts separately
#' arrange(
#'   se_simple,
#'   rows(direction),
#'   cols(dplyr::desc(condition))
#' )
#'
#' # access assay data to compute arrangement
#' arrange(
#'   se_simple,
#'   rows(rowSums(.assays_asis$counts)),
#'   cols(colSums(.assays_asis$counts))
#' )
#'
#' # assay context is disabled
#' arrange(se_simple, counts) |> try()
#'
#' # convert to `data.frame` first
#' as.data.frame(se_simple) |>
#'   arrange(counts)
#'
#' @export
arrange.PlySummarizedExperiment <- function(.data, ..., .by_group = FALSE) {
  plyxp(.data, arrange_se_impl, ..., .by_group = .by_group)
}

arrange_se_impl <- function(.data, ..., .by_group = FALSE) {
  .env <- caller_env()
  quos <- plyxp_quos(..., .ctx = c("assays", "rows", "cols"))
  if (.by_group) {
    quos <- c(
      plyxp_quos(
        !!!plyxp_curr_groups(.data),
        .ctx = c("assays", "rows", "cols")
      ),
      quos
    )
  }
  ctxs <- vapply(quos, attr, FUN.VALUE = "", which = "plyxp:::ctx")
  if (any(err <- ctxs %in% "assays")) {
    plyxp_assays_cannot(do = "arrange", review = err)
  }
  nms <- names(quos)
  # to make this function consistent
  groups <- group_data_se_impl(.data)
  group_data_se_impl(.data) <- NULL
  mask <- new_plyxp_manager.SummarizedExperiment(obj = .data)
  poke_ctx_local("plyxp:::caller_env", .env)
  poke_ctx_local("plyxp:::manager", mask)
  poke_ctx_local("plyxp:::dplyr_verb", "arrange")
  mask <- plyxp_evaluate(mask, quos, ctxs, nms, .env)
  results <- mask$results()
  type <- ""
  ro <- co <- NULL
  if (!is_empty(results$rows)) {
    type <- "row"
    rows <- lapply(results$rows, vec_recycle, size = nrow(.data))
    ro <- exec("order", splice(rows), method = "radix")
  }

  if (!is_empty(results$cols)) {
    type <- paste0(type, "col")
    cols <- lapply(results$cols, vec_recycle, size = ncol(.data))
    co <- exec("order", splice(cols), method = "radix")
  }
  if (!is.null(groups)) {
    group_data_se_impl(.data) <- groups
  }

  switch(type,
    rowcol = plyxp_slice_se(.data, ro, co),
    row = plyxp_slice_se(.data, ro),
    col = plyxp_slice_se(.data, , co),
    .data
  )
}

# @seealso [plyxp::PlyxpMaskManager]

#' @title New Plyxp mask
#' @name new_plyxp_manager
#' @description
#' Create a plyxp for an object
#' @param obj Dispatch Object
#' @param ... Not used
#' @return a plyxp_manager R6 class object
#' @keywords internal
#' @noRd
#' @examples
#'
#' manager <- new_plyxp_manager(se_simple)
#' manager$ctx
#' q <- plyxp_quos(
#'   counts_1 = counts + 1,
#'   cols(is_drug = condition == "drug"),
#'   .ctx_default = "assays",
#'   .ctx_opt = c("rows", "cols")
#' )
#' manager$eval(q[[1]])
#' manager$results()
#' # evaluating second quo without switching contexts will error
#' manager$eval(q[[2]]) |> try()
#' manager$ctx <- "cols"
#' manager$ctx
#' manager$eval(q[[2]])
#' manager$results()
#'
new_plyxp_manager <- function(obj, ...) {
  UseMethod("new_plyxp_manager")
}

#' @export
new_plyxp_manager.SummarizedExperiment <- function(obj, ...) {
  groups <- group_details(obj)
  expanded <- expand_groups2(groups$row_groups, groups$col_groups)
  nr <- nrow(obj)
  nc <- ncol(obj)
  shared_ctx_env <- prepare_shared_ctx_env(groups = groups, expanded = expanded)

  mask_assay <- plyxp_assay$new(
    assays(obj),
    get_group_indices(groups, expanded, "assay"),
    .nrow = nr,
    .ncol = nc,
    .env_bot = shared_ctx_env,
    .env_top = top_env
  )
  mask_rows <- plyxp_mask$new(
    prepend_rownames(rowData(obj), column = ".features"),
    get_group_indices(groups, expanded, "rowData"),
    .env_bot = shared_ctx_env,
    .env_top = top_env
  )
  mask_cols <- plyxp_mask$new(
    prepend_rownames(colData(obj), column = ".samples"),
    get_group_indices(groups, expanded, "colData"),
    .env_bot = shared_ctx_env,
    .env_top = top_env
  )

  extended_environments <- connect_masks(
    mask_assays = mask_assay,
    mask_rows = mask_rows,
    mask_cols = mask_cols
  )

  plyxp_manager$new(
    .data = obj,
    .masks = list(
      assays = mask_assay,
      rows = mask_rows,
      cols = mask_cols
    ),
    .ctx_env = shared_ctx_env,
    .extended_env = extended_environments
  )
}

plyxp_evaluate <- function(mask, quos, ctxs, nams, env) {
  .call <- caller_call()
  # if (.matrix) {
  #   quos <- enforce_matrix(quos, ctxs)
  # }
  n_quo <- length(quos)
  curr_quo <- NULL
  try_fetch(
    {
      for (i in seq_len(n_quo)) {
        curr_quo <- quos[[i]]
        # nm <- nams[i]
        mask$ctx <- ctxs[[i]]
        mask$eval(curr_quo, env = env)
      }
    },
    error = function(cnd) {
      current_ctx <- mask$ctx
      current_gid <- mask$group_id
      message <- if (mask$n_groups > 1) {
        "error in expression {i} occured in group {current_gid} of the `{current_ctx}` context"
      } else {
        "error in expression {i} occured in the `{current_ctx}` context"
      }
      cli::cli_abort(
        message = message,
        parent = cnd,
        call = curr_quo,
        class = "plyxp_dplyr_eval_error"
      )
    }
  )
  invisible(mask)
}

#' @title Plyxp Simple Example Summarized Experiment
#' 
#' @description
#' A small data SummarizedExperiment Object of 20 observations, 5 rows and 4 
#' columns.
#' 
#' @format ## `se_simple`
#' \describe{
#' 
#'  \item{`assays`}{
#'    \describe{
#'      \item{counts}{sampled data points between 1:20}
#'      \item{logcounts}{log transform of `counts`}
#'    }
#'  }
#'  \item{`rowData`/`.features`}{
#'    \describe{
#'      \item{gene}{fake gene name}
#'      \item{length}{fake gene length}
#'      \item{direction}{fake strand}
#'    }
#'  }
#'  \item{`colData`/`.samples`}{
#'    \describe{
#'      \item{sample}{fake sample name}
#'      \item{condition}{control or drug treatment}
#'    }
#'  }
#' }
#' @return a `SummarizedExperiment` object
#' @examples
#' SummarizedExperiment::assays(se_simple)
#' SummarizedExperiment::rowData(se_simple)
#' SummarizedExperiment::colData(se_simple)
"se_simple"

## ----message=FALSE, warning=FALSE---------------------------------------------
library(airway)
data(airway)
library(dplyr)

## ----echo=FALSE---------------------------------------------------------------
# clean up the metadata a bit to make it easier to view
colData(airway) <- colData(airway)[,1:4]
rowData(airway) <- rowData(airway)[,c(1:2,4)]

## ----message=FALSE------------------------------------------------------------
library(plyxp)
# to use plyxp, call `new_plyxp()` on your SummarizedExperiment object
xp <- new_plyxp(airway)

## -----------------------------------------------------------------------------
# add data (mutate) to any of the three tables,
# assay, colData, rowData,
# ...using contextual helpers cols() and rows()
xp |>
  mutate(log_counts = log1p(counts),
         cols(treated = dex == "trt"),
         rows(new_id = paste0("gene-", gene_name)))

## -----------------------------------------------------------------------------
# suppose a variable, `sizeFactor`, in the colData
xp$sizeFactor <- runif(8, .9, 1.1)

# we wish to scale the counts in the matrix using the size factor,
# then compute row means over the scaled counts matrix:
xp |>
  mutate(scaled_counts = counts / .cols$sizeFactor, #
         rows(ave_scl_cts = rowMeans(.assays_asis$scaled_counts)))

## -----------------------------------------------------------------------------
xp |>
  mutate(scaled_counts = counts / .cols$sizeFactor,
         # You may expect a list when accessing other contexts
         # from either the rows() or cols() contexts.
         rows(ave_scl_cts = purrr::map_dbl(.assays$scaled_counts, mean)))

## -----------------------------------------------------------------------------
summary <- xp |>
  group_by(rows(gene_biotype)) |>
  summarize(col_sums = colSums(counts),
            # may rename rows with .features
            rows(.features = unique(gene_biotype)))
# summarize returns a SummarizedExperiment here,
# retaining rowData and colData

summary |> rowData()

# visualizing the output as a tibble:
library(tibble)
summary |>
  pull(col_sums) |>
  as_tibble(rownames = "type")

## -----------------------------------------------------------------------------
se(xp)

## -----------------------------------------------------------------------------
knitr::include_graphics("../man/figures/Overview-bindings.png")

## -----------------------------------------------------------------------------
knitr::include_graphics("../man/figures/Overview-pronouns.png")

## -----------------------------------------------------------------------------
# here the `.cols$` pronoun reshapes the data to fit the `assays` context
xp |>
  mutate(scaled_counts = counts / .cols$sizeFactor)

# this is equivalent to the following, where we have to transpose
# the `counts` assay data twice to enable the correct recycling
# of the size factor vector
xp |>
  mutate(scaled_counts = t(t(counts) / .cols_asis$sizeFactor))

## -----------------------------------------------------------------------------
knitr::include_graphics("../man/figures/contextual_groups.png")

## ----eval=FALSE---------------------------------------------------------------
# group_by(se_simple, rows(direction), cols(condition)) |>
#   mutate(rows(data_from_cols = .cols$condition))

## ----eval=FALSE---------------------------------------------------------------
# options("show_SummarizedExperiment_as_tibble_abstraction" = TRUE)

## -----------------------------------------------------------------------------
se_simple
# moving data to rownames and colnames
se_simple |>
  mutate(
    orig_names = sprintf(
      "%s-%s",
      # .features is installed in the rows() context
      .rows$.features,
      # .samples is installed in the cols() context
      .cols$.samples),
    rows(.features = gene,
         # deleting rowData column
         gene = NULL),
    cols(.samples = sample,
         # deleting colData column
         sample = NULL)
  )


## ----eval=FALSE---------------------------------------------------------------
# .data |>
#   mutate(foo = bar) |>
#   mutate(baz = foo^2)

## ----eval=FALSE---------------------------------------------------------------
# .data |>
#   mutate(
#     foo = bar,
#     baz = foo^2
#   )

## -----------------------------------------------------------------------------
devtools::session_info()

#' @include vctrs-S4-.R

#' @title Get observations of a vector
#' @name vctrs_slice
#' @description
#' This extends `vctrs::vec_slice` to `S4Vectors::Vector` class by masking
#' `vec_slice` with `S7::new_generic`. Atomic vectors and other base S3 classes
#'  (list, data.frame, factor, Dat, POSIXct) will dispatch to the
#' `vctrs::vec_slice` method as normal. Dispatch support on the
#' `S4Vectors::Vector` and `S4Vectors::DataFrame` classes provides a unified
#' framework for working with base R vectors and `S4Vectors`.
#'
#' ### `S4Vectors::Vector` Implementation
#'
#' This method will naively call the `[` method for any S4 class that inherits
#' from the `S4Vectors::Vector` class. This may not be a very efficient way to
#' slice up an S4 class, but will work.
#'
#' With this implementation, the `x@mcol` data is expected to be retained after
#' a call to `plyxp::vec_slice(x, i)`.
#'
#' ### `S4Vectors::DataFrame` Implementation
#'
#' The `DataFrame` implementation works similar to how `vctrs::vec_slice` works
#' on a `data.frame` object. What is being sliced is the rows of `x@listData`.
#' To maintain the size stability of the `DataFrame` object, we change `@nrows`
#' to the appropriate value, and perform a recursive call if `@elementMetadata`
#' is not `NULL`.
#'
#' ## Performance
#'
#' Depending on the size and complexity of your S4 Vector object, you may find
#' the standard subset operation is extremely slow. For example, consider a
#' `SummarizedExperiment` whose rowData contains a `CompressedGRangesList`
#' object assigned to the name "exons" and whose length is 250,000 and
#' underlying `@unlistData` is length 1,600,000. Performing a by `.features`
#' grouping operation and attempting to evaluate the `exons` within the row
#' context would force the `CompressedGRangesList` object to be
#' chopped element-wise.
#'
#' Unfortunately, there is a massive performance hit in attempting to construct
#' 250,000 `GRanges`. Unless you do not mind waiting over an hour for each
#' `dplyr` verb in which `exons` gets evaluated, doing so  is not recommended.
#'
#' The `plyxp` package is planning to export a new generic
#' named `plyxp_s4_proxy_vec()`.
#' This attempts to reconstruct certain standard `S4Vectors::Vectors` as
#' standard vectors or tibbles. The equivalent `exons` object would require
#' much more memory use, but at the advantage of only taking several seconds to
#' construct. When you are done, you can attempt to restore the original S4
#' Vector with `plyxp_restore_s4_proxy()`.
#'
#' In development, `plyxp_s4_proxy_vec()` is faster to work with because there
#' are less checks on the object validity and all `@elementMetadata` and
#' `@metadata` are dropped from the objects.
#'
#' @inheritParams vctrs::vec_slice
#' @return a new S3 or S4 vector subsetted by `i`
#' @examples
#' vec_slice(1:10, i = 5)
#' vec_slice(S4Vectors::Rle(rep(1:3, each = 3)), i = 5)
#'
#' @export
vec_slice <- S7::new_generic(
  "vec_slice",
  dispatch_args = "x",
  function(x, i, ...) {
    S7_dispatch()
  }
)

method(vec_slice, class_vctrs) <- function(
  x,
  i,
  ...,
  error_call = current_env()
) {
  vctrs::vec_slice(x, i, ..., error_call = error_call)
}

method(vec_slice, getClass("CompressedGRangesList")) <- function(x, i, ...) {
  st <- IRanges::start(x@partitioning)
  en <- IRanges::end(x@partitioning)
  w <- IRanges::width(x@partitioning)[i]
  seqs <- purrr::map2(st[i], en[i], `:`)

  gr <- IRanges::extractROWS(x@unlistData, vctrs::vec_c(rlang::splice(seqs)))

  # cgr <- as(gr, "CompressedGRangesList")
  S4Vectors::new2(
    "CompressedGRangesList",
    unlistData = gr,
    partitioning = IRanges::PartitioningByEnd(
      x = cumsum(w),
      names = names(x@partitioning)[i]
    ),
    elementType = "GRanges",
    elementMetadata = IRanges::extractROWS(x@elementMetadata, i),
    metadata = x@metadata
  )
}

method(vec_slice, class_vec_phantom) <- function(x, i, ...) {
  attr(x, "phantomData") <- vec_slice(attr(x, "phantomData"), i)
  x
}

method(vec_slice, S7::class_any) <- function(x, i, ...) {
  x[i]
}

method(vec_slice, class_s4_vctrs) <- function(x, i, ...) {
  x[i]
}

method(vec_slice, class_DF) <- function(x, i, ...) {
  x@listData <- purrr::map(x@listData, vec_slice, i = i)
  x@nrows <- length(i)
  if (!is.null(rnames <- rownames(x))) {
    x@rownames <- vec_slice(rnames, i = i)
  }
  x
}

vec_chop2 <- new_generic(
  "vec_chop2",
  dispatch_args = "x",
  function(x, ..., indices = NULL) {
    S7_dispatch()
  }
)

method(vec_chop2, class_vctrs) <- function(
  x,
  ...,
  indices = NULL,
  sizes = NULL
) {
  vctrs::vec_chop(x = x, ..., indices = indices, sizes = sizes)
}

method(vec_chop2, class_s4_vctrs) <- function(x, ..., indices = NULL) {
  fun <- method(vec_slice, object = x)
  if (is.null(indices)) {
    indices <- seq_along(x)
  }
  purrr::map(indices, fun, x = x)
}

# cgr_as_lst <- function(x) {
#   n <- length(x)
#   st <- IRanges::start(x@partitioning)
#   en <- IRanges::end(x@partitioning)
#   seqs <- purrr::map2(st, en, `:`)
#   ldata <- x@unlistData
#   box::use(vctrs[vec_chop], S4Vectors[new2])
#   C_obj <- methods:::C_new_object
#   IRANGE <- getClass("IRanges")
#   seqnames <- rep(ldata@seqnames@values, times = ldata@seqnames@lengths) |>
#     vec_chop(indices = seqs) |> purrr::map(S4Vectors::Rle, .progress = TRUE)
#   ranges_start <- ldata@ranges@start |> vec_chop(indices = seqs)
#   ranges_width <- ldata@ranges@width |> vec_chop(indices = seqs)
#   ranges_names <- ldata@ranges@NAMES |> vec_chop(indices = seqs)
#   iranges <- rep(list(.Call(C_obj, IRANGE)), times = length(ranges_start))
#   ranges <- purrr::pmap(
#     list(ranges_start, ranges_width, ranges_names, iranges),
#     function(st, wd, nm, obj) {
#       obj@start <- st
#       obj@width <- wd
#       names(obj) <- nm
#       obj
#     }, .progress = TRUE)
#   strand <- rep(ldata@strand@values, times = ldata@strand@lengths) |>
#     vec_chop(indices = seqs) |> purrr::map(S4Vectors::Rle, .progress = TRUE)
#   vslice <- vctrs::vec_slice
#   new_gr <- S4Vectors::new2
#   RLE <- S4Vectors::Rle
#   irange <- IRanges::IRanges
#   purrr::pmap(
#     list(
#       seqnames = seqnames,
#       ranges = ranges,
#       strand = strand
#     ),
#     function(seqnames, ranges,
#              strand) {
#       new_gr(
#         "GRanges",
#         seqnames = seqnames,
#         ranges = ranges,
#         strand = seqnames,
#         # elementMetadata = ldata@elementMetadata[i,],
#         seqinfo = ldata@seqinfo,
#         check = FALSE
#       )
#     },
#     .progress = T
#
#   )
#   # purrr::pmap(
#   #   seqs,
#   #   function(i, seqnames, ranges_start,
#   #            ranges_width, ranges_names,
#   #            strand) {
#   #     new_gr(
#   #       "GRanges",
#   #       seqnames = RLE(vslice(seqnames, i)),
#   #       ranges = irange(
#   #         start = vslice(ranges_start, i),
#   #         width = vslice(ranges_width, i),
#   #         names = vslice(ranges_names, i)
#   #       ),
#   #       strand = RLE(vslice(strand, i)),
#   #       elementMetadata = ldata@elementMetadata[i,],
#   #       seqinfo = ldata@seqinfo,
#   #       check = FALSE
#   #     )
#   #   },
#   #   seqnames = seqnames,
#   #   ranges_start = ranges_start,
#   #   ranges_width = ranges_width,
#   #   ranges_names = ranges_names,
#   #   strand = strand,
#   #   .progress = T
#   #
#   # )
#
# }

# cgr_as_lst(y)
# ?furrr::furrr_options()
# seq_len(nrow(x)) |>
#   purrr::map(slice_cgr, x = y, .progress = TRUE) -> ylist

#' @title Create Group Indices
#' @name vec_group_id
#' @description
#' A alternative to [`vctrs::vec_group_id`][vctrs::vec_group_id] and
#' [`vctrs::vec_group_loc`][vctrs::vec_group_loc] as
#' an S4 generic function to allow `S4Vectors`.
#' @param x a vctrs vector or an S4Vector
#' @param ... unsued arguments
#' @return either a tibble or DataFrame object
#' @examples
#'
#' data <- S4Vectors::DataFrame(
#'   letter = sample(letters, 500, TRUE),
#'   LETTER = sample(letters, 500, TRUE)
#' )
#'
#' vec_group_id(data)
#' vec_group_loc(data)
#'
#' @export
vec_group_id <- new_generic(
  "vec_group_id",
  "x"
)

method(
  vec_group_id,
  class_vctrs
) <- function(x, ...) {
  vctrs::vec_group_id(x = x)
}

method(
  vec_group_id,
  class_s4_vctrs
) <- function(x, ...) {
  as(BiocGenerics::match(x, BiocGenerics::unique(x)), "integer")
}


method(
  vec_group_id,
  class_DF
) <- function(x, ...) {
  lapply(x@listData, vec_group_id) |>
    as.data.frame() |>
    vctrs::vec_group_id()
}


## -----

#' @rdname vec_group_id
#' @export
vec_group_loc <- new_generic(
  "vec_group_loc",
  "x"
)

method(
  vec_group_loc,
  class_vctrs
) <- function(x, ...) {
  vctrs::vec_group_loc(x = x)
}

method(
  vec_group_loc,
  class_s4_vctrs
) <- function(x, ...) {
  # bioc_group_id is based on the object `x` and NOT
  # the mcols data. So for any arbitrary class `x` may
  # be, we do not consider the elementMetadata
  #
  # `Vector` extends Annotated, thus `mcols(x)` exists
  S4Vectors::mcols(x) <- NULL
  id <- vec_group_id(x)
  loc <- length(x) |>
    seq_len() |>
    split(f = id) |>
    unname()

  S4Vectors::DataFrame(
    key = S4Vectors::I(vec_slice(x, vapply(loc, `[`, 1L, 1L))),
    loc = S4Vectors::I(loc)
  )
}


method(
  vec_group_loc,
  class_DF
) <- function(x, ...) {
  out <- lapply(x@listData, vec_group_id) |>
    as.data.frame() |>
    vctrs::vec_group_loc()
  S4Vectors::DataFrame(
    key = S4Vectors::I(vec_slice(x, vapply(out$loc, `[`, 1L, 1L))),
    loc = S4Vectors::I(out$loc)
  )
}


# #' create groups
# #' @export
# create_groups <- function(.data, .rename = ".indices") {
#   #
#   # check if length > 0
#   if (is_empty(.data)) {
#     return(NULL)
#   }
#   # check first index has length > 0
#   # assumes all others have similar length (probably not always true)
#   if (length(.data[[1]]) == 0) {
#     .data <- tibble::as_tibble(.data)
#     .data[[.rename]] <- list()
#     .data[[sprintf("%s_group_id", .rename)]] <- integer()
#     return(.data)
#   }
#   grouped <- bioc_group_loc(.data)
#   .data <- c(
#     as.list(grouped$key),
#     setNames(list(grouped$loc), .rename),
#     setNames(list(seq_len(length(grouped$loc))), sprintf("%s_group_id", .rename))
#   )
#   # .data <- as(grouped$key, "DataFrame")
#   # .data[[.rename]] <- grouped$loc
#   # .data[[sprintf("%s_group_id", .rename)]] <- seq_len(length(grouped$loc))
#   as_DF(.data)
# }

# The following functions should
# be available to users from our package

#' @export
SummarizedExperiment::SummarizedExperiment

#' @export
SummarizedExperiment::assay

#' @export
SummarizedExperiment::`assay<-`

#' @export
SummarizedExperiment::assays

#' @export
SummarizedExperiment::`assays<-`

#' @export
SummarizedExperiment::rowData

#' @export
SummarizedExperiment::`rowData<-`

#' @export
SummarizedExperiment::colData

#' @export
SummarizedExperiment::`colData<-`

#' @export
S4Vectors::metadata

#' @export
S4Vectors::`metadata<-`

#' @include vctrs-S4-.R

#' @title chop a vector
#' @name vctrs-vec_chop
#' @description
#' A re-export of [`vctrs::vec_chop`][vctrs::vec_chop] as an S7 generic
#' function to allow `S4Vectors`.
#' @inheritParams vctrs::vec_chop
#' @return a S3 or S4 vector
#' @examples
#' vec_chop(1L)
#' vec_chop(S4Vectors::Rle(c(rep(1, 3), rep(4, 5))), indices = list(c(2, 3, 4), c(1, 5:8)))
#'
#' @export
vec_chop <- new_generic(
  "vec_chop", "x",
  function(x, ..., indices = NULL) S7_dispatch()
)


method(
  vec_chop,
  class_vctrs
) <-
  function(x,
           ...,
           sizes = NULL,
           indices = NULL) {
    vctrs::vec_chop(x = x, ..., indices = indices, sizes = sizes)
  }



# method(
#   vec_chop,
#   class_vctrs_vec
# ) <-
#   function(x,
#            ...,
#            sizes = NULL,
#            indices = NULL) {
#     vctrs::vec_chop(x = x, ..., indices = indices, sizes = sizes)
#   }


method(
  vec_chop,
  class_s4_vctrs
) <-
  function(x,
           ...,
           indices = NULL) {
    fun <- method(vec_slice, object = x)
    if (is.null(indices)) {
      indices <- seq_len(length(x))
    }
    lapply(indices, fun, x = x)
  }


# cgr_as_lst <- function(x) {
#   n <- length(x)
#   st <- IRanges::start(x@partitioning)
#   en <- IRanges::end(x@partitioning)
#   seqs <- purrr::map2(st, en, `:`)
#   ldata <- x@unlistData
#   box::use(vctrs[vec_chop], S4Vectors[new2])
#   C_obj <- methods:::C_new_object
#   IRANGE <- getClass("IRanges")
#   seqnames <- rep(ldata@seqnames@values, times = ldata@seqnames@lengths) |>
#     vec_chop(indices = seqs) |> purrr::map(S4Vectors::Rle, .progress = TRUE)
#   ranges_start <- ldata@ranges@start |> vec_chop(indices = seqs)
#   ranges_width <- ldata@ranges@width |> vec_chop(indices = seqs)
#   ranges_names <- ldata@ranges@NAMES |> vec_chop(indices = seqs)
#   iranges <- rep(list(.Call(C_obj, IRANGE)), times = length(ranges_start))
#   ranges <- purrr::pmap(
#     list(ranges_start, ranges_width, ranges_names, iranges),
#     function(st, wd, nm, obj) {
#       obj@start <- st
#       obj@width <- wd
#       names(obj) <- nm
#       obj
#     }, .progress = TRUE)
#   strand <- rep(ldata@strand@values, times = ldata@strand@lengths) |>
#     vec_chop(indices = seqs) |> purrr::map(S4Vectors::Rle, .progress = TRUE)
#   vslice <- vctrs::vec_slice
#   new_gr <- S4Vectors::new2
#   RLE <- S4Vectors::Rle
#   irange <- IRanges::IRanges
#   purrr::pmap(
#     list(
#       seqnames = seqnames,
#       ranges = ranges,
#       strand = strand
#     ),
#     function(seqnames, ranges,
#              strand) {
#       new_gr(
#         "GRanges",
#         seqnames = seqnames,
#         ranges = ranges,
#         strand = seqnames,
#         # elementMetadata = ldata@elementMetadata[i,],
#         seqinfo = ldata@seqinfo,
#         check = FALSE
#       )
#     },
#     .progress = T
#
#   )
#   # purrr::pmap(
#   #   seqs,
#   #   function(i, seqnames, ranges_start,
#   #            ranges_width, ranges_names,
#   #            strand) {
#   #     new_gr(
#   #       "GRanges",
#   #       seqnames = RLE(vslice(seqnames, i)),
#   #       ranges = irange(
#   #         start = vslice(ranges_start, i),
#   #         width = vslice(ranges_width, i),
#   #         names = vslice(ranges_names, i)
#   #       ),
#   #       strand = RLE(vslice(strand, i)),
#   #       elementMetadata = ldata@elementMetadata[i,],
#   #       seqinfo = ldata@seqinfo,
#   #       check = FALSE
#   #     )
#   #   },
#   #   seqnames = seqnames,
#   #   ranges_start = ranges_start,
#   #   ranges_width = ranges_width,
#   #   ranges_names = ranges_names,
#   #   strand = strand,
#   #   .progress = T
#   #
#   # )
#
# }

# cgr_as_lst(y)
# ?furrr::furrr_options()
# seq_len(nrow(x)) |>
#   purrr::map(slice_cgr, x = y, .progress = TRUE) -> ylist

---
title: "plyxp Usage Guide"
author:
    - name: Justin Landis
      orcid: 0000-0001-5501-4934
    - name: Michael Love
      orcid: 0000-0001-8401-0545
date: "`r format(Sys.time(), '%m/%d/%Y')`"
output: rmarkdown::html_document
bibliography: library.bib
link-citations: true
vignette: |
  %\VignetteIndexEntry{plyxp Usage Guide}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

# Introduction

`plyxp` provides efficient abstractions to the *SummarizedExperiment* such
that using common dplyr functions feels as natural to operating on a
*data.frame* or *tibble*. `plyxp` uses
[data-masking](https://rlang.r-lib.org/reference/topic-data-mask-programming.html)
from the `rlang` package in order to connect dplyr functions to
*SummarizedExperiment* slots in a manner that aims to be intuitive and avoiding
ambiguity in outcomes. For more details on the design and benchmarking of
`plyxp`, see @plyxp.

## Enabling dplyr verbs

`plyxp` works on *SummarizedExperiment* objects, as well as most
classes derived from this, including *DESeqDataSet*,
*SingleCellExperiment*, etc.

It supports the following operations:

* `mutate`
* `select`
* `summarize`
* `pull`
* `filter`
* `arrange`

## Typical use case

```{r message=FALSE, warning=FALSE}
library(airway)
data(airway)
library(dplyr)
```

```{r echo=FALSE}
# clean up the metadata a bit to make it easier to view
colData(airway) <- colData(airway)[,1:4]
rowData(airway) <- rowData(airway)[,c(1:2,4)]
```

```{r message=FALSE}
library(plyxp)
# to use plyxp, call `new_plyxp()` on your SummarizedExperiment object
xp <- new_plyxp(airway)
```

```{r}
# add data (mutate) to any of the three tables,
# assay, colData, rowData,
# ...using contextual helpers cols() and rows()
xp |>
  mutate(log_counts = log1p(counts),
         cols(treated = dex == "trt"),
         rows(new_id = paste0("gene-", gene_name)))
```

The operations can span contexts, and only the necessary data will be extracted
from each context for computation:

```{r}
# suppose a variable, `sizeFactor`, in the colData
xp$sizeFactor <- runif(8, .9, 1.1)

# we wish to scale the counts in the matrix using the size factor,
# then compute row means over the scaled counts matrix:
xp |>
  mutate(scaled_counts = counts / .cols$sizeFactor, #
         rows(ave_scl_cts = rowMeans(.assays_asis$scaled_counts)))
```

Calling `.cols` in the assay context produces an object of the matching size and
orientation to the other assay data.

Alternatively we could have used *purrr* to compute row means:

```{r}
xp |>
  mutate(scaled_counts = counts / .cols$sizeFactor,
         # You may expect a list when accessing other contexts
         # from either the rows() or cols() contexts.
         rows(ave_scl_cts = purrr::map_dbl(.assays$scaled_counts, mean)))
```

See below for details on how objects are made available across contexts.

`plyxp` also enables common grouping and summarization routines:


```{r}
summary <- xp |>
  group_by(rows(gene_biotype)) |>
  summarize(col_sums = colSums(counts),
            # may rename rows with .features
            rows(.features = unique(gene_biotype)))
# summarize returns a SummarizedExperiment here,
# retaining rowData and colData

summary |> rowData()

# visualizing the output as a tibble:
library(tibble)
summary |>
  pull(col_sums) |>
  as_tibble(rownames = "type")
```

To extract the *SummarizedExperiment* (if needed):

```{r}
se(xp)
```

## Related work

We note that `plyxp` is highly related to other *tidyomics* projects including:

* *tidySummarizedExperiment*
* *plyranges*
* *DFplyr*

Here we have focused on the design principles of:
(1) function *endomorphism* (returning the same class of object that was input),
(2) avoiding code ambiguity through strictly defined behavior and scope,
and (3) allowing the user the convenience of multiple expressions for the same
result, which may involve a trade-off between efficiency and verbosity.

### A Note on `tidySummarizedExperiment`

Some of the optimized routines in `plyxp` for operating on objects are called
by some of the functions implemented in *tidySummarizedExperiment*.
`plyxp` and `tidySummarizedExperiment` both provide *dplyr*-style interfaces to
*SummarizedExperiment* objects, and can easily be loaded and used in the same R
session without the functions conflicting. By casting objects with the
`new_plyxp` constructor, users can enable the `plyxp`-driven functionality. 

# `plyxp` grammar

The `SummarizedExperiment` object contains three main components/"contexts" that we mask,
the `assays()`, `rowData()`[^1] and `colData()`.

[^1]: At this moment `rowRanges()` is not supported in `plyxp` but may become
its own pronoun in the future.

```{r}
#| fig.cap: Simplified view of data masking structure. Figure made with [Biorender](https://biorender.com)
#| echo: false
knitr::include_graphics("../man/figures/Overview-bindings.png")
```

`plyxp` provides variables as-is to data **within their current contexts** enabling you
to call S4 methods on S4 objects with `dplyr` verbs. If you require access to
variables _outside the context_, you may use
pronouns made available through `plyxp` to specify where to find those
variables.

```{r}
#| echo: false
#| fig.cap: Simplified view of reshaping pronouns. Arrows indicates to where the pronoun provides access. For each pronoun listed, there is an `_asis` variant that returns underlying data without reshaping it to fit the context. Figure made with [Biorender](https://biorender.com)
knitr::include_graphics("../man/figures/Overview-pronouns.png")
```

The `.assays`, `.rows` and `.cols` pronouns outputs depends on the evaluating
context. Users should expect that the underlying data returned from `.rows` or
`.cols` pronouns in the _**assays context**_ is a vector, replicated to match
size of the assay context.

\

Alternatively, using a pronoun in either the `rows()` or `cols()`
contexts will return a list equal in length to either `nrows(rowData())`
or `nrows(colData())` respectively.

## assay context
<!-- taken from the presentation -->
* Default evaluation context
* `.assays` $\to$ contextual pronoun, returns list of the matrix, sliced by the dimension it was referenced from.
  * within the rowData context: `.assays$foo` is an alias for `lapply(seq_len(nrow()), \(i, x) x[i,,drop=FALSE], x = foo)`
  * within the colData context: `.assays$foo` is an alias for `lapply(seq_len(ncol()), \(i, x) x[,i,drop=FALSE], x = foo)`
* `.assays_asis` $\to$ pronoun to direct bindings in `assays()`
* `assay_ctx(expr, asis = FALSE)` $\to$ short hand to bind the assay context in front of the current context.

## rows context

* `rows(...)` $\to$ sentinel function call to indicate evaluation context.
* `.rows` $\to$ contextual pronoun
  * within assay context: `.rows$foo` is an alias for `vctrs::vec_rep(foo, times = ncol())`
  * within colData context: `.rows$foo` is an alias for `vctrs::vec_rep(list(foo), times = n())`
* `.rows_asis` $\to$ pronoun to direct bindings in `rowData()`
* `row_ctx(expr, asis = FALSE)` $\to$ shorthand to bind the rowData context in front of the current context

## cols context

* `cols(...)` $\to$ sentinel function call to indicate evaluation context.
* `.cols` $\to$ contextual pronoun
  * within assay context: `.cols$foo` is an alias for `vctrs::vec_rep_each(foo, times = nrow())`
  * within rowData context: `.rows$foo` is an alias for `vctrs::vec_rep(list(foo), times = n())`
* `.cols_asis` $\to$ pronoun to direct bindings in `colData()`
* `col_ctx(expr, asis = FALSE)` $\to$ shorthand to bind the colData context in front of the current context

## Multiple expressions enabled via `plyxp`

We can compare two ways of dividing out a vector from `colData` along the
columns of `assay` data:

```{r}
# here the `.cols$` pronoun reshapes the data to fit the `assays` context
xp |>
  mutate(scaled_counts = counts / .cols$sizeFactor)

# this is equivalent to the following, where we have to transpose
# the `counts` assay data twice to enable the correct recycling
# of the size factor vector
xp |>
  mutate(scaled_counts = t(t(counts) / .cols_asis$sizeFactor))
```

# Advanced features

## Object integrity

`plyxp` provides an opinionated framework for how `dplyr` verbs should interact
with `SummarizedExperiment` objects. In general, `plyxp` will not allow any
operations that it could not guarantee a valid return object.

It is for this reason that `arrange()`,  `filter()` and `group_by()` do not
allow operations in the default assay context, as this would likely break the
assumed structure of a `SummarizedExperiment` object.

## `group_by()`

`plyxp` also supports `group_by` operations allowing users to query information
with `dplyr::n()` or `dplyr::cur_group_id()`. However due to the linked structure
of a `SummarizedExperiment` object and `plyxp` providing multiple evaluation
contexts, grouping operations would be complex and return values would be
potentionally ambiguous.

It is for this reason that groupings are themselves **contextual**. The assay
context is dependently linked to both the groupings of the rows and cols contexts
but, the grouping of rows is ignored when viewed from the cols context and
similarly the grouping of cols is ignored when viewed from the rows context.
In this way, we have chosen to make the groupings of rows and cols independent
between each other. The below figure attempts to show how
groupings are conditionally dropped for the scope of an evaluation.

```{r}
#| echo: false
#| fig.cap: When evaluating in row context, groupings along `colData()` are temporarily ignored. Figure created with [Biorender](https://biorender.com)
knitr::include_graphics("../man/figures/contextual_groups.png")
```

To further motivate this choice, suppose we did not drop grouping values. Assume
you have a small 5 by 4 `SummarizedExperiment` object. Both of the `rowData()`
and `colData()` are grouped such that there are 2 groups in both `rowData()` and
`colData()` totaling in 4 groups across the assays.

```{r eval=FALSE}
group_by(se_simple, rows(direction), cols(condition)) |>
  mutate(rows(data_from_cols = .cols$condition))
```

The above syntax implies we wish to move data from the `colData()` into the
`rowData()`. From a previously established conventions, we would expect the
output to be an alias for `vctrs::vec_rep(list(condition), times = n())`.\
Additionally the `rows()` sentinal will expect that the output of `.cols$condition`
will need to match the size of the evaluation context.

Unfortunately, this becomes extremely difficult to resolve with the current
conventions. Without dropping the `cols()` groupings, each `rows()` grouping is
evaluated equal to the number of groups in `cols()`. At first glance, this may
seem desirable, but the problem arises when considering how theses outputs
across groups should be stored per group of `rows()`. For example, should the
output of the `.cols$condition` return a list equal to the number
of groups of the column context? If yes, we would need to consider the size stability
of the output context! Assuming that `rowData()` has at least one group with three
elements, there is no guarentee it would fit (this also makes a poor assumption
that the elements of `rowData()` somehow correspond to the groups of `colData()`).
Thus we would be left with wrapping all the results in a list and replicating to the
appropriate size. When its all said and done, we would have a list of lists, which
is difficult to reason about, potentionally unexpected and painful to work with.
For this reason the only groupings present in the `rowData()` context are the
groupings in `rowData()`, and similarly for the `colData()` context.

## Printing

Motivated by the `show`/`print` function in *tidySummarizedExperiment*, we
visualize the data as if it was tabular. `plyxp` offers the option to opt-in
on this behavior by setting the associated global option:

```{r eval=FALSE}
options("show_SummarizedExperiment_as_tibble_abstraction" = TRUE)
```

Alternatively, you may use helper functions `use_show_tidy()` and
`use_show_default()` to enable and disable this alternative printing respectively.

Since `plyxp` aims to leave the input data as-is when possible, we have considered
providing support for printing `S4Vectors` within a `tibble()`. To be clear,
`plyxp` **will not** allow you to put `S4Vectors` inside a `tibble()`, but
will allow for `S4Vectors` to be printed with `pillar()`, the formatting engine
behind `tibble()` pretty printing.

To enable this behavior, before any data is reported to the user, we proxy any
`S4Vector` with a custom `vctrs_vctr` object with `plyxp::vec_phantom()`. In
truth, the `vec_phantom` object is a simple integer vector with a "phantomData"
attribute. This allows us to carry along `S4Vector` through `pillar()`'s printing
pipeline until it is time to print the column.

The `pillar_shaft()` method for `vec_phantom` will format the S4 data with
`plyxp_pillar_format()` generic, which by default calls
`S4Vectors::showAsCell()`. Users are free to create their own methods for S4
vectors that differ from `S4Vectors::showAsCell()` if they like, as seen in
``?`plyxp-printing` ``

## renaming rows or columns

Inspired by `tidySummarizedExperiment`, `plyxp` provides access to the
rownames and colnames of a `SummarizedExperiment` object by installing `.features`
and `.samples` into the `rowData()` and `colData()` contexts respectively.
These are special in that assigning a value to `.features` in the `rowData()`
context or `.samples` in the `colData()` context does not create a new column,
but changes the rownames or colnames of the resulting object.

```{r}
se_simple
# moving data to rownames and colnames
se_simple |>
  mutate(
    orig_names = sprintf(
      "%s-%s",
      # .features is installed in the rows() context
      .rows$.features,
      # .samples is installed in the cols() context
      .cols$.samples),
    rows(.features = gene,
         # deleting rowData column
         gene = NULL),
    cols(.samples = sample,
         # deleting colData column
         sample = NULL)
  )

```

# Troubleshooting and best practices

while `plyxp` takes inspiration from the data masks used in `dplyr`, they
are unfortunately more complex. This means there is some overhead in creating
the evaluation mask per dplyr verb. Try to reduce the number of `dplyr` verb
calls and instead increase the content of each verb. For example instead of
doing:

```{r eval=FALSE}
.data |>
  mutate(foo = bar) |>
  mutate(baz = foo^2)
```

do the following

```{r eval=FALSE}
.data |>
  mutate(
    foo = bar,
    baz = foo^2
  )
```

# Community and support

Please feel free to post questions about `plyxp` to:

* the [Bioconductor support site](https://support.bioconductor.org/)
* as an [Issue](https://github.com/jtlandis/plyxp/issues) on GitHub
* in the `#tidiness_in_bioc` channel on the *community-bioc* Slack

For code contributions:

* For small fixes, feel free to post a PR on GitHub
* For larger structural changes to the package code, please reach out to the
  development team first through one of the above channels.

Thanks for your interest in `plyxp`!

# Session info

```{r}
devtools::session_info()
```

# References

# Default printing is `SummarizedExperiment`

    Code
      se(se_simple)
    Output
      class: SummarizedExperiment 
      dim: 5 4 
      metadata(0):
      assays(2): counts logcounts
      rownames(5): row_1 row_2 row_3 row_4 row_5
      rowData names(3): gene length direction
      colnames(4): col_1 col_2 col_3 col_4
      colData names(2): sample condition

# enabling `plyxp` printing

    Code
      use_show_tidy()
      se(se_simple)
    Output
      # A SummarizedExperiment-tibble Abstraction: 5 x 4
          .features .samples | counts logcounts | gene  length direction | sample
          <chr>     <chr>    |  <int>     <dbl> | <chr>  <int> <chr>     | <chr> 
        1 row_1     col_1    |     14      2.64 | g1         1 -         | s1    
        2 row_2     col_1    |     19      2.94 | g2        24 +         | s1    
        3 row_3     col_1    |     16      2.77 | g3        60 +         | s1    
        4 row_4     col_1    |     11      2.40 | g4        39 -         | s1    
        5 row_5     col_1    |     18      2.89 | g5        37 +         | s1    
        ~   ~         ~             ~        ~     ~         ~ ~            ~    
      n-4 row_1     col_4    |      9      2.20 | g1         1 -         | s4    
      n-3 row_2     col_4    |      4      1.39 | g2        24 +         | s4    
      n-2 row_3     col_4    |     20      3.00 | g3        60 +         | s4    
      n-1 row_4     col_4    |      3      1.10 | g4        39 -         | s4    
      n   row_5     col_4    |      5      1.61 | g5        37 +         | s4    
      # i n = 20
      # i 1 more variable: condition <chr>

# re-enabling default printing

    Code
      use_show_default()
      se(se_simple)
    Output
      class: SummarizedExperiment 
      dim: 5 4 
      metadata(0):
      assays(2): counts logcounts
      rownames(5): row_1 row_2 row_3 row_4 row_5
      rowData names(3): gene length direction
      colnames(4): col_1 col_2 col_3 col_4
      colData names(2): sample condition

# force `plyxp` printing

    Code
      show_tidy(se(se_simple))
    Output
      # A SummarizedExperiment-tibble Abstraction: 5 x 4
          .features .samples | counts logcounts | gene  length direction | sample
          <chr>     <chr>    |  <int>     <dbl> | <chr>  <int> <chr>     | <chr> 
        1 row_1     col_1    |     14      2.64 | g1         1 -         | s1    
        2 row_2     col_1    |     19      2.94 | g2        24 +         | s1    
        3 row_3     col_1    |     16      2.77 | g3        60 +         | s1    
        4 row_4     col_1    |     11      2.40 | g4        39 -         | s1    
        5 row_5     col_1    |     18      2.89 | g5        37 +         | s1    
        ~   ~         ~             ~        ~     ~         ~ ~            ~    
      n-4 row_1     col_4    |      9      2.20 | g1         1 -         | s4    
      n-3 row_2     col_4    |      4      1.39 | g2        24 +         | s4    
      n-2 row_3     col_4    |     20      3.00 | g3        60 +         | s4    
      n-1 row_4     col_4    |      3      1.10 | g4        39 -         | s4    
      n   row_5     col_4    |      5      1.61 | g5        37 +         | s4    
      # i n = 20
      # i 1 more variable: condition <chr>

# printing `PlySummarizedExperiment` as is

    Code
      se_simple
    Output
      # A SummarizedExperiment-tibble Abstraction: 5 x 4
          .features .samples | counts logcounts | gene  length direction | sample
          <chr>     <chr>    |  <int>     <dbl> | <chr>  <int> <chr>     | <chr> 
        1 row_1     col_1    |     14      2.64 | g1         1 -         | s1    
        2 row_2     col_1    |     19      2.94 | g2        24 +         | s1    
        3 row_3     col_1    |     16      2.77 | g3        60 +         | s1    
        4 row_4     col_1    |     11      2.40 | g4        39 -         | s1    
        5 row_5     col_1    |     18      2.89 | g5        37 +         | s1    
        ~   ~         ~             ~        ~     ~         ~ ~            ~    
      n-4 row_1     col_4    |      9      2.20 | g1         1 -         | s4    
      n-3 row_2     col_4    |      4      1.39 | g2        24 +         | s4    
      n-2 row_3     col_4    |     20      3.00 | g3        60 +         | s4    
      n-1 row_4     col_4    |      3      1.10 | g4        39 -         | s4    
      n   row_5     col_4    |      5      1.61 | g5        37 +         | s4    
      # i n = 20
      # i 1 more variable: condition <chr>

# printing `PlySummarizedExperiment` with `show_tidy()`

    Code
      show_tidy(se_simple)
    Output
      # A SummarizedExperiment-tibble Abstraction: 5 x 4
          .features .samples | counts logcounts | gene  length direction | sample
          <chr>     <chr>    |  <int>     <dbl> | <chr>  <int> <chr>     | <chr> 
        1 row_1     col_1    |     14      2.64 | g1         1 -         | s1    
        2 row_2     col_1    |     19      2.94 | g2        24 +         | s1    
        3 row_3     col_1    |     16      2.77 | g3        60 +         | s1    
        4 row_4     col_1    |     11      2.40 | g4        39 -         | s1    
        5 row_5     col_1    |     18      2.89 | g5        37 +         | s1    
        ~   ~         ~             ~        ~     ~         ~ ~            ~    
      n-4 row_1     col_4    |      9      2.20 | g1         1 -         | s4    
      n-3 row_2     col_4    |      4      1.39 | g2        24 +         | s4    
      n-2 row_3     col_4    |     20      3.00 | g3        60 +         | s4    
      n-1 row_4     col_4    |      3      1.10 | g4        39 -         | s4    
      n   row_5     col_4    |      5      1.61 | g5        37 +         | s4    
      # i n = 20
      # i 1 more variable: condition <chr>

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr-group_by.R
\name{group_by}
\alias{group_by}
\alias{group_by.PlySummarizedExperiment}
\alias{ungroup.PlySummarizedExperiment}
\title{apply groups to PlySummarizedExperiment}
\usage{
\method{group_by}{PlySummarizedExperiment}(.data, ..., .add = FALSE)

\method{ungroup}{PlySummarizedExperiment}(x, ...)
}
\arguments{
\item{.data}{An object Inheriting from \code{PlySummarizedExperiment}, the wrapper
class for \code{SummarizedExperiment} objects
\subsection{S4 Compatibility}{

At the moment, grouping on S4 Vectors is not yet supported. This is due to
\code{plyxp} using \verb{[vec_group_loc][vctrs::vec_group_loc]} to form grouping
information. \code{plyxp} will eventually develop a method to handle S4 Vectors.
}}

\item{...}{\link[=plyxp-context]{contextual expressions} specifying
which columns to ungroup. Omitting \code{...} ungroups the entire object.}

\item{.add}{When \code{FALSE}, the default, \code{group_by()} will override
existing groups.}

\item{x}{An object Inheriting from \code{PlySummarizedExperiment}, the wrapper
class for \code{SummarizedExperiment} objects}
}
\value{
\code{PlySummarizedExperiment} object
}
\description{
create grouping variables about the rowData and colData of a
\code{PlySummarizedExperiment} object. Unlike the \code{data.frame} method
the resulting output class is left unchanged. Thus \code{dplyr} generics for
\code{PlySummarizedExperiment} must check grouping information manually.
}
\section{Functions}{
\itemize{
\item \code{ungroup(PlySummarizedExperiment)}: Ungroup a PlySummarizedExperiment object

}}
\examples{

group_by(se_simple, rows(direction), cols(condition))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/context-utils.R
\name{plyxp-context}
\alias{plyxp-context}
\alias{cols}
\alias{rows}
\alias{col_ctx}
\alias{row_ctx}
\alias{assay_ctx}
\title{plyxp contexts}
\usage{
cols(...)

rows(...)

col_ctx(x, asis = FALSE)

row_ctx(x, asis = FALSE)

assay_ctx(x, asis = FALSE)
}
\arguments{
\item{x, ...}{expressions to evaluate within its associated context}

\item{asis}{asis = FALSE (the default) will indicate using active bindings
that attempt to coerce the underlying data into a format that is appropriate
for the current context. Indicating TRUE will instead bind the underlying data
as is.}
}
\value{
function called for its side-effects
}
\description{
Contextual user-facing helper function for dplyr verbs with SummarizedExperiment
objects. These functions are intended to be used as the top level call to
any dplyr verbs \code{...} argument, similar to that of \code{across()}/\code{if_any()}/\code{if_all()}.

Specifies that the following expressions should be evaluated within the
colData context.

Specifies that the following expressions should be evaluated within the
rowData context.

Specify a single expression to evaluate in another context

Specify a single expression to evaluate in another context

Specify a single expression to evaluate in another context
}
\examples{

# cols
mutate(se_simple,
  cols(is_drug = condition == "drug"),
  # bind a different context
  effect = col_ctx(counts + (is_drug * rbinom(n(), 20, .3)))
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr-group_by.R
\name{group_data}
\alias{group_data}
\alias{group_data.PlySummarizedExperiment}
\alias{ungroup}
\title{get grouping data}
\usage{
\method{group_data}{PlySummarizedExperiment}(.data)
}
\arguments{
\item{.data}{An object Inheriting from \code{PlySummarizedExperiment}, the wrapper
class for \code{SummarizedExperiment} objects}
}
\value{
list of groupings for an SummarizedExperiment
}
\description{
retrieve grouping information from a \code{SummarizedExperiment} object. This
is stored within the \code{metadata()} of the object.
}
\examples{
group_by(se_simple, rows(direction), cols(condition)) |> group_data()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vctrs-S4-unchop.R
\name{vec_ptype2}
\alias{vec_ptype2}
\title{Create a common prototype of two vectors}
\usage{
vec_ptype2(x, y, ...)
}
\arguments{
\item{x}{first object}

\item{y}{second object}

\item{...}{unused arguments}
}
\value{
an object of size 0.
}
\description{
given two objects, \code{vec_ptype2()} finds a common prototype
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr-mutate.R
\name{mutate}
\alias{mutate}
\alias{mutate.PlySummarizedExperiment}
\title{Mutate a PlySummarizedExperiment object}
\usage{
\method{mutate}{PlySummarizedExperiment}(.data, ...)
}
\arguments{
\item{.data}{An object Inheriting from \code{PlySummarizedExperiment}, the wrapper
class for \code{SummarizedExperiment} objects}

\item{...}{expressions to evaluate}
}
\value{
an object inheriting PlySummarizedExperiment class
}
\description{
Mutate a PlySummarizedExperiment object under an data mask. Unlike a few other
\code{dplyr} implementations, all contextual evaluations of \code{mutate()} for
\code{SummarizedExperiment} are valid.
}
\examples{

mutate(se_simple,
  counts_1 = counts + 1,
  logp_counts = log(counts_1),
  # access assays context with ".assays" pronoun,
  # note that assays are sliced into a list to
  # fit dimensions of cols context
  cols(sum = purrr::map_dbl(.assays$counts, sum)),
  # access assays context "asis" with the same pronoun
  # but with a "_asis" suffix.
  rows(sum = rowSums(.assays_asis$counts))
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plyxp-package.R
\docType{package}
\name{plyxp-package}
\alias{plyxp-package}
\title{plyxp: Data masks for SummarizedExperiment enabling dplyr-like manipulation}
\value{
API for using S4 classes with rlang data masks
}
\description{
The package provides `rlang` data masks for the SummarizedExperiment class. The enables the evaluation of unquoted expression in different contexts of the SummarizedExperiment object with optional access to other contexts. The goal for `plyxp` is for evaluation to feel like a data.frame object without ever needing to unwind to a rectangular data.frame.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/jtlandis/plyxp}
  \item \url{https://jtlandis.github.io/plyxp}
  \item Report bugs at \url{https://www.github.com/jtlandis/plyxp/issues}
}

}
\author{
\strong{Maintainer}: Justin Landis \email{jtlandis314@gmail.com} (\href{https://orcid.org/0000-0001-5501-4934}{ORCID})

Authors:
\itemize{
  \item Michael Love \email{michaelisaiahlove@gmail.com} (\href{https://orcid.org/0000-0001-8401-0545}{ORCID})
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr-group_by.R
\name{group_split}
\alias{group_split}
\alias{group_split.PlySummarizedExperiment}
\title{Split a PlySummarizedExperiment based on groups}
\usage{
\method{group_split}{PlySummarizedExperiment}(.tbl, ..., .keep = TRUE)
}
\arguments{
\item{.tbl}{a PlySummarizedExperiment object}

\item{...}{ignored if the \code{.tbl} is grouped, otherwise it is passed to
\link{group_by}.}

\item{.keep}{logical indicating of grouping variables should be kept}
}
\value{
A list of PlySummarizedExperiment objects
}
\description{
Splits a grouped PlySummarizedExperiment based on groups. Note the elements
of the return value are ungrouped PlySummarizedExperiment objects.
}
\examples{

gse <- group_by(se_simple, rows(direction), cols(condition))
gse |> group_split()
gse |> group_split(.keep = FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr-slice.R
\name{slice}
\alias{slice}
\alias{slice.PlySummarizedExperiment}
\title{Slice a PlySummarizedExperiment}
\usage{
\method{slice}{PlySummarizedExperiment}(.data, ..., .preserve = FALSE)
}
\arguments{
\item{.data}{a PlySummarizedExperiment object}

\item{...}{expressions that resolve to integer values to slice, .data by.
Note that only the \code{rows()} and \code{cols()} contexts are available here.}

\item{.preserve}{Logical value. When FALSE, the default, group combinations
are recomputed based on the resulting data. When TRUE, group combinations
are retained, despite any groups being empty.}
}
\description{
\code{slice()} selects rows and/or columns by position.
}
\examples{
gse <- group_by(se_simple, rows(direction), cols(condition))
sgse <- slice(gse, rows(which(direction == "-")))
group_data(gse)
group_data(sgse)
sgse2 <- slice(gse, rows(which(direction == "-")), .preserve = TRUE)
group_data(sgse2)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vctrs-S4-unchop.R
\name{vec_ptype_common}
\alias{vec_ptype_common}
\title{find the common ptype}
\usage{
vec_ptype_common(..., .ptype = NULL)
}
\arguments{
\item{...}{<\code{\link[rlang:dyn-dots]{dynamic-dots}}> a collection of objects}

\item{.ptype}{the expected prototype}
}
\value{
an object of size 0.
}
\description{
find the common ptype
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/group_utils.R
\name{group_vars}
\alias{group_vars}
\alias{group_vars.PlySummarizedExperiment}
\title{get PlySummarizedExperiment grouping Variables}
\usage{
\method{group_vars}{PlySummarizedExperiment}(x)
}
\arguments{
\item{x}{PlySummarizedExperiment}
}
\value{
NULL or list containing names of grouping columns
}
\description{
like in \code{\link[dplyr:group_data]{dplyr::group_vars()}} will get character strings for
groupings with the exection of the return value
being a list for each grouped context
}
\examples{

out <- group_by(se_simple, rows(direction))
group_vars(out)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/print.R
\name{vec_phantom}
\alias{vec_phantom}
\alias{plyxp-printing}
\alias{plyxp_pillar_format}
\alias{show_tidy}
\alias{use_show_tidy}
\alias{use_show_default}
\title{Printing within tibble with S4 objects}
\usage{
vec_phantom(x)

plyxp_pillar_format(x, ...)

show_tidy(x, ...)

use_show_tidy()

use_show_default()
}
\arguments{
\item{x}{The S4 object}

\item{...}{other arguments passed from \code{\link[pillar:pillar_shaft]{pillar_shaft}}}
}
\value{
\code{plyxp_pillar_format} -> formatted version of your S4 vector
\code{vec_phantom} -> integer vector with arbitrary object in \code{phatomData} attribute.
}
\description{
\code{plyxp} uses \link[pillar:pillar-package]{pillar} for its printing.
If you want to change how your S4 object is printed within
\code{plyxp}'s print method, consider writing a method for
this function.

To print S4 objects in a tibble, \code{plyxp} hacks a custom
integer vector built from \code{\link[vctrs:new_vctr]{vctrs}} where
the S4 object lives in an attribute named "phantomData".
You can create your own S4 phantom vector with \code{vec_phantom()}.
This function is not used outside of printing for \code{plyxp}

The default method for formatting a \code{vec_phantom()} is to call
\code{\link[S4Vectors:show-utils]{showAsCell()}}.
}
\section{tidy printing}{


By default, \code{plyxp} will not affect the show method for
\code{SummarizedExperiment} objects. The \code{PlySummarizedExperiment} object will
always use the tibble abstraction method. If you want to use tibble
abstraction, you may use \code{use_show_tidy()} to enable or \code{use_show_default()} #' to disable this feature. These functions are called for their side effects, #' modifying the global option
"show_SummarizedExperiment_as_tibble_abstraction".

To show an object as the tibble abstraction regardless of the set option,
use the S3 generic \code{show_tidy(...)}.
}

\examples{

if (require("IRanges")) {
  ilist <- IRanges::IntegerList(list(c(1L, 2L, 3L), c(5L, 6L)))
  phantom <- vec_phantom(ilist)
  pillar::pillar_shaft(phantom)

  plyxp_pillar_format.CompressedIntegerList <- function(x) {
    sprintf("Int: [\%i]", lengths(x))
  }
  print(pillar::pillar_shaft(phantom))
  rm(plyxp_pillar_format.CompressedIntegerList)
}

# default printing for PlySummarizedExperiment object
se_simple
# default printing for SummarizedExperiment object
se <- se(se_simple)
se
# use `plyxp` tibble abstraction
use_show_tidy()
se
# restore default print
use_show_default()
se
# explicitly using tibble abstraction
show_tidy(se)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plyxp-class.R
\name{plyxp}
\alias{plyxp}
\alias{plyxp_on}
\title{Modify SummarizedExperiment Object}
\usage{
plyxp(.data, .f, ..., .caller = caller_env())

plyxp_on(.data, .f, ..., .on, .caller = caller_env())
}
\arguments{
\item{.data}{a PlySummarizedExperiment object}

\item{.f}{within \code{plyxp()}: a function that returns a SummarizedExperiment object.
within \code{plyxp_on()}: \code{.f} should return a value compatible with \verb{.on(se)<-}}

\item{...}{additional arguments passed to \code{.f}}

\item{.caller}{environment in which plyxp should signal an error if one occurs.}

\item{.on}{a symbol matching an accessor and setter function for the
\code{SummarizedExperiment} Class.}
}
\value{
a PlySummarizedExperiment object
}
\description{
Modify the underlying SummarizedExperiment object with a function.
}
\section{Functions}{
\itemize{
\item \code{plyxp_on()}: pass a function to the result of an accessor of the
\code{SummarizedExperiment} Class
This function is a wrapper for the expression:
\preformatted{
 plyxp::plyxp(.data, function(se, ...) {
   .f <- rlang::as_function(.f)
   obj <- .on(se)
   obj <- .f(se, ...)
   .on(se) <- obj
   se
 }, ...)
}
where \code{.on} is the symbol for the accessor function into a
\code{SummarizedExperiment} Class. Note: the setter variant must exist in the
environment that \code{plyxp_on()} is called. All other arguments are diffused
as quosures and will be evaluated in the environment they were quoted.

}}
\examples{
plyxp(se_simple, function(x) x)
plyxp_on(se_simple,
  .f = lapply, # function to call on `.on` args,
  .on = rowData, # data `.f` will be used on
  paste, "foo"
) # arguments for `.f`
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr-pull.R
\name{pull}
\alias{pull}
\alias{pull.PlySummarizedExperiment}
\title{extract data from object}
\usage{
\method{pull}{PlySummarizedExperiment}(.data, var = -1, name = NULL, ...)
}
\arguments{
\item{.data}{An object Inheriting from \code{PlySummarizedExperiment}, the wrapper
class for \code{SummarizedExperiment} objects}

\item{var}{A variable as specified by \link[dplyr:pull]{dplyr::pull}}

\item{name}{ignored argument. Due to the range of data types a
\code{PlySummarizedExperiment} this argument is not supported}

\item{...}{unused argument}
}
\value{
an element from either the assays, rowData, or colData of a
\code{SummarizedExperiment} object
}
\description{
similar to \code{dplyr::pull.data.frame} except allows to extract objects
from different contexts.
}
\examples{

# last element of default context (assays)
pull(se_simple, var = -1)
# first element of rows context
pull(se_simple, var = rows(1))
# element from col context by literal variable name
pull(se_simple, var = cols(condition))

# use `pull()` to return contextual info
mutate(se_simple, rows(counts = .assays$counts)) |>
  # get last stored element
  pull(rows(-1))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vctrs-S4-chop.R
\name{vctrs-vec_chop}
\alias{vctrs-vec_chop}
\alias{vec_chop}
\title{chop a vector}
\usage{
vec_chop(x, ..., indices = NULL)
}
\arguments{
\item{x}{A vector}

\item{...}{These dots are for future extensions and must be empty.}

\item{indices}{For \code{vec_chop()}, a list of positive integer vectors to
slice \code{x} with, or \code{NULL}. Can't be used if \code{sizes} is already specified.
If both \code{indices} and \code{sizes} are \code{NULL}, \code{x} is split into its individual
elements, equivalent to using an \code{indices} of \code{as.list(vec_seq_along(x))}.

For \code{list_unchop()}, a list of positive integer vectors specifying the
locations to place elements of \code{x} in. Each element of \code{x} is recycled to
the size of the corresponding index vector. The size of \code{indices} must
match the size of \code{x}. If \code{NULL}, \code{x} is combined in the order it is
provided in, which is equivalent to using \code{\link[vctrs:vec_c]{vec_c()}}.}
}
\value{
a S3 or S4 vector
}
\description{
A re-export of \code{\link[vctrs:vec_chop]{vctrs::vec_chop}} as an S7 generic
function to allow \code{S4Vectors}.
}
\examples{
vec_chop(1L)
vec_chop(S4Vectors::Rle(c(rep(1, 3), rep(4, 5))), indices = list(c(2, 3, 4), c(1, 5:8)))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr-select.R
\name{select}
\alias{select}
\alias{select.PlySummarizedExperiment}
\title{select assays, rowData, and colData names}
\usage{
\method{select}{PlySummarizedExperiment}(.data, ...)
}
\arguments{
\item{.data}{An object Inheriting from \code{PlySummarizedExperiment}, the wrapper
class for \code{SummarizedExperiment} objects}

\item{...}{<\code{\link[dplyr:dplyr_tidy_select]{tidy-select}}> one or more selection
expressions. Supports wrapping expressions within the
<\code{\link[=plyxp-context]{plyxp-contexts}}>.}
}
\value{
an object inheriting PlySummarizedExperiment class
}
\description{
Select one or more values from each context. By default omitting an expression
for a context is the same as selecting NOTHING from that context.

The <\code{\link[dplyr:dplyr_tidy_select]{tidy-select}}> implementation within
\code{plyxp} is almost similar to \code{dplyr} except when used within the
\code{across()} function. When used from \code{accross()}, the data provided to
\link[tidyselect:eval_select]{eval_select} is a zero length slice of the data.
This was an intentional choice to prevent the evaluation of potentionally
expensive chopping operations for S4Vectors. This means that predicate
function from \code{\link[tidyselect:where]{where()}} will NOT be able to query the
original data.
}
\examples{


# only keep assays, other contexts are dropped
select(se_simple, everything())

# only keep rowData, other contexts are dropped
select(se_simple, rows(everything()))

select(se_simple, rows(where(is.numeric)))

# Note on `where()` clause, all data is available within select
select(se_simple, rows(where(~ any(grepl("-", .x)))))

# within an `across()`, only a zero-length slice avialble, so the
# `where()` predicate cannot access the data
mutate(
  se_simple,
  rows(
    across(
      where(~ any(grepl("-", .x))),
      ~ sprintf("\%s foo", .x)
    )
  )
)
# here is an acceptable usage of the `where()` predicate
mutate(
  se_simple,
  rows(
    across(
      where(is.character),
      ~ sprintf("\%s foo", .x)
    )
  )
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vctrs-S4-group.R
\name{vec_group_id}
\alias{vec_group_id}
\alias{vec_group_loc}
\title{Create Group Indices}
\usage{
vec_group_id(x, ...)

vec_group_loc(x, ...)
}
\arguments{
\item{x}{a vctrs vector or an S4Vector}

\item{...}{unsued arguments}
}
\value{
either a tibble or DataFrame object
}
\description{
A alternative to \code{\link[vctrs:vec_group]{vctrs::vec_group_id}} and
\code{\link[vctrs:vec_group]{vctrs::vec_group_loc}} as
an S4 generic function to allow \code{S4Vectors}.
}
\examples{

data <- S4Vectors::DataFrame(
  letter = sample(letters, 500, TRUE),
  LETTER = sample(letters, 500, TRUE)
)

vec_group_id(data)
vec_group_loc(data)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plyxp-class.R
\name{se}
\alias{se}
\alias{se,PlySummarizedExperiment-method}
\alias{se<-}
\alias{se<-,PlySummarizedExperiment-method}
\alias{se,SummarizedExperiment-method}
\alias{se<-,SummarizedExperiment-method}
\alias{PlySummarizedExperiment-methods}
\alias{assays,PlySummarizedExperiment-method}
\alias{assays<-,PlySummarizedExperiment,list-method}
\alias{assays<-,PlySummarizedExperiment,SimpleList-method}
\alias{assay,PlySummarizedExperiment,missing-method}
\alias{assay,PlySummarizedExperiment,numeric-method}
\alias{assay,PlySummarizedExperiment,character-method}
\alias{assay<-,PlySummarizedExperiment,missing-method}
\alias{assay<-,PlySummarizedExperiment,numeric-method}
\alias{assay<-,PlySummarizedExperiment,character-method}
\alias{rowData,PlySummarizedExperiment-method}
\alias{rowData<-,PlySummarizedExperiment-method}
\alias{colData,PlySummarizedExperiment-method}
\alias{colData<-,PlySummarizedExperiment,DataFrame-method}
\alias{colData<-,PlySummarizedExperiment,NULL-method}
\alias{metadata,PlySummarizedExperiment-method}
\alias{metadata<-,PlySummarizedExperiment-method}
\alias{rownames,PlySummarizedExperiment-method}
\alias{colnames,PlySummarizedExperiment-method}
\alias{nrow,PlySummarizedExperiment-method}
\alias{ncol,PlySummarizedExperiment-method}
\alias{dimnames,PlySummarizedExperiment-method}
\alias{dimnames<-,PlySummarizedExperiment,list-method}
\alias{dimnames<-,PlySummarizedExperiment,NULL-method}
\title{PlySummarizedExperiment Methods}
\usage{
se(x)

\S4method{se}{PlySummarizedExperiment}(x)

se(x) <- value

\S4method{se}{PlySummarizedExperiment}(x) <- value

\S4method{se}{SummarizedExperiment}(x)

\S4method{se}{SummarizedExperiment}(x) <- value

\S4method{assays}{PlySummarizedExperiment}(x, withDimnames = TRUE, ...)

\S4method{assays}{PlySummarizedExperiment,list}(x, withDimnames = TRUE, ...) <- value

\S4method{assays}{PlySummarizedExperiment,SimpleList}(x, withDimnames = TRUE, ...) <- value

\S4method{assay}{PlySummarizedExperiment,missing}(x, i, withDimnames = TRUE, ...)

\S4method{assay}{PlySummarizedExperiment,numeric}(x, i, withDimnames = TRUE, ...)

\S4method{assay}{PlySummarizedExperiment,character}(x, i, withDimnames = TRUE, ...)

\S4method{assay}{PlySummarizedExperiment,missing}(x, i, withDimnames = TRUE, ...) <- value

\S4method{assay}{PlySummarizedExperiment,numeric}(x, i, withDimnames = TRUE, ...) <- value

\S4method{assay}{PlySummarizedExperiment,character}(x, i, withDimnames = TRUE, ...) <- value

\S4method{rowData}{PlySummarizedExperiment}(x, use.names = TRUE, ...)

\S4method{rowData}{PlySummarizedExperiment}(x, ...) <- value

\S4method{colData}{PlySummarizedExperiment}(x, ...)

\S4method{colData}{PlySummarizedExperiment,DataFrame}(x, ...) <- value

\S4method{colData}{PlySummarizedExperiment,NULL}(x, ...) <- value

\S4method{metadata}{PlySummarizedExperiment}(x, ...)

\S4method{metadata}{PlySummarizedExperiment}(x, ...) <- value

\S4method{rownames}{PlySummarizedExperiment}(x)

\S4method{colnames}{PlySummarizedExperiment}(x)

\S4method{nrow}{PlySummarizedExperiment}(x)

\S4method{ncol}{PlySummarizedExperiment}(x)

\S4method{dimnames}{PlySummarizedExperiment}(x)

\S4method{dimnames}{PlySummarizedExperiment,list}(x) <- value

\S4method{dimnames}{PlySummarizedExperiment,NULL}(x) <- value
}
\arguments{
\item{x}{PlySummarizedExperiment object}

\item{value}{replacement value}

\item{withDimnames}{logical}

\item{...}{additional arguments}

\item{i}{character or numeric index}

\item{use.names}{logical}
}
\value{
Replacement functions return a PlySummarizedExperiment object. Other functions will return the same object as the method from SummarizedExperiment.
}
\description{
Methods from SummarizedExperiment package re-implemented for PlySummarizedExperiment.
}
\section{Functions}{
\itemize{
\item \code{se(PlySummarizedExperiment)}: get the se slot of the PlySummarizedExperiment object

\item \code{se(x) <- value}: set the se slot of the PlySummarizedExperiment object

\item \code{se(PlySummarizedExperiment) <- value}: set the se slot of the PlySummarizedExperiment object

\item \code{se(SummarizedExperiment)}: get the SummarizedExperiment object

\item \code{se(SummarizedExperiment) <- value}: get the SummarizedExperiment object

\item \code{assays(PlySummarizedExperiment)}: get the assays o the PlySummarizedExperiment object

\item \code{assays(x = PlySummarizedExperiment) <- value}: set the assays of the PlySummarizedExperiment object

\item \code{assays(x = PlySummarizedExperiment) <- value}: set the assays of the PlySummarizedExperiment object

\item \code{assay(x = PlySummarizedExperiment, i = missing)}: get the first assay of the PlySummarizedExperiment object

\item \code{assay(x = PlySummarizedExperiment, i = numeric)}: get assay from a PlySummarizedExperiment object

\item \code{assay(x = PlySummarizedExperiment, i = character)}: get assay from a PlySummarizedExperiment object

\item \code{assay(x = PlySummarizedExperiment, i = missing) <- value}: set assay in a PlySummarizedExperiment object

\item \code{assay(x = PlySummarizedExperiment, i = numeric) <- value}: set assay in a PlySummarizedExperiment object

\item \code{assay(x = PlySummarizedExperiment, i = character) <- value}: set assay in a PlySummarizedExperiment object

\item \code{rowData(PlySummarizedExperiment)}: get rowData in a PlySummarizedExperiment object

\item \code{rowData(PlySummarizedExperiment) <- value}: set rowData in a PlySummarizedExperiment object

\item \code{colData(PlySummarizedExperiment)}: get colData in a PlySummarizedExperiment object

\item \code{colData(x = PlySummarizedExperiment) <- value}: set colData in a PlySummarizedExperiment object

}}
\examples{
assays(se_simple)
rowData(se_simple)
colData(se_simple)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr-arrange.R
\name{arrange}
\alias{arrange}
\alias{arrange.PlySummarizedExperiment}
\title{arrange rows or columns of PlySummarizedExperiment}
\usage{
\method{arrange}{PlySummarizedExperiment}(.data, ..., .by_group = FALSE)
}
\arguments{
\item{.data}{An object Inheriting from \code{PlySummarizedExperiment}, the wrapper
class for \code{SummarizedExperiment} objects}

\item{...}{<\code{\link[rlang:args_data_masking]{data-masking}}> Variables, or
functions of variables. Use \code{\link[dplyr:desc]{desc()}} to sort a variable in descending
order.}

\item{.by_group}{If \code{TRUE}, will sort first by grouping variable. Applies to
grouped data frames only.}
}
\value{
an object inheriting \code{PlySummarizedExperiment} class
}
\description{
\code{arrange()} orders either the rows or columns of a \code{PlySummarizedExperiment}
object. Note, to guarentee a valid \code{PlySummarizedExperiment} is returned,
arranging in the \code{assays} evaluation context is disabled.

Unlike other dplyr verbs, \code{arrange()} largely ignores grouping. The
\code{PlySummarizedExperiment} method also provides the same functionality via the
\code{.by_group} argument.
}
\examples{

# arrange within rows/cols contexts separately
arrange(
  se_simple,
  rows(direction),
  cols(dplyr::desc(condition))
)

# access assay data to compute arrangement
arrange(
  se_simple,
  rows(rowSums(.assays_asis$counts)),
  cols(colSums(.assays_asis$counts))
)

# assay context is disabled
arrange(se_simple, counts) |> try()

# convert to `data.frame` first
as.data.frame(se_simple) |>
  arrange(counts)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/context-utils.R
\docType{data}
\name{dot-pronouns}
\alias{dot-pronouns}
\alias{.assays}
\alias{.assays_asis}
\alias{.rows}
\alias{.rows_asis}
\alias{.cols}
\alias{.cols_asis}
\title{contextual plyxp pronouns}
\format{
An object of class \code{NULL} of length 0.

An object of class \code{NULL} of length 0.

An object of class \code{NULL} of length 0.

An object of class \code{NULL} of length 0.

An object of class \code{NULL} of length 0.

An object of class \code{NULL} of length 0.
}
\usage{
.assays

.assays_asis

.rows

.rows_asis

.cols

.cols_asis
}
\value{
access to specific values behind the rlang pronoun
}
\description{
\code{plyxp} utilizes its own version of \code{rlang::.data} pronouns. These may be
used to gain access to other evaluation contexts for a managed set of
data-masks.

Similar to \code{rlang::.data}, \code{plyxp::.assays} and other exported pronouns
are exported to pass R CMD Checks. When using a \code{plyxp} within your package,
import the associated pronoun from \code{plyxp} but only use the fully unqualified
name, \code{.assays}, \code{.assays_asis}, etc.
}
\examples{
mutate(
  se_simple,
  # access via pronoun
  rows(sum = rowSums(.assays_asis$counts)),
  cols(sum = vapply(.assays$counts, sum, numeric(1)))
)

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vctrs-S4-slice.R
\name{vctrs_slice}
\alias{vctrs_slice}
\alias{vec_slice}
\title{Get observations of a vector}
\usage{
vec_slice(x, i, ...)
}
\arguments{
\item{x}{A vector}

\item{i}{An integer, character or logical vector specifying the
locations or names of the observations to get/set. Specify
\code{TRUE} to index all elements (as in \code{x[]}), or \code{NULL}, \code{FALSE} or
\code{integer()} to index none (as in \code{x[NULL]}).}

\item{...}{These dots are for future extensions and must be empty.}
}
\value{
a new S3 or S4 vector subsetted by \code{i}
}
\description{
This extends \code{vctrs::vec_slice} to \code{S4Vectors::Vector} class by masking
\code{vec_slice} with \code{S7::new_generic}. Atomic vectors and other base S3 classes
(list, data.frame, factor, Dat, POSIXct) will dispatch to the
\code{vctrs::vec_slice} method as normal. Dispatch support on the
\code{S4Vectors::Vector} and \code{S4Vectors::DataFrame} classes provides a unified
framework for working with base R vectors and \code{S4Vectors}.
\subsection{\code{S4Vectors::Vector} Implementation}{

This method will naively call the \code{[} method for any S4 class that inherits
from the \code{S4Vectors::Vector} class. This may not be a very efficient way to
slice up an S4 class, but will work.

With this implementation, the \code{x@mcol} data is expected to be retained after
a call to \code{plyxp::vec_slice(x, i)}.
}

\subsection{\code{S4Vectors::DataFrame} Implementation}{

The \code{DataFrame} implementation works similar to how \code{vctrs::vec_slice} works
on a \code{data.frame} object. What is being sliced is the rows of \code{x@listData}.
To maintain the size stability of the \code{DataFrame} object, we change \verb{@nrows}
to the appropriate value, and perform a recursive call if \verb{@elementMetadata}
is not \code{NULL}.
}

\subsection{Performance}{

Depending on the size and complexity of your S4 Vector object, you may find
the standard subset operation is extremely slow. For example, consider a
\code{SummarizedExperiment} whose rowData contains a \code{CompressedGRangesList}
object assigned to the name "exons" and whose length is 250,000 and
underlying \verb{@unlistData} is length 1,600,000. Performing a by \code{.features}
grouping operation and attempting to evaluate the \code{exons} within the row
context would force the \code{CompressedGRangesList} object to be
chopped element-wise.

Unfortunately, there is a massive performance hit in attempting to construct
250,000 \code{GRanges}. Unless you do not mind waiting over an hour for each
\code{dplyr} verb in which \code{exons} gets evaluated, doing so  is not recommended.

The \code{plyxp} package is planning to export a new generic
named \code{plyxp_s4_proxy_vec()}.
This attempts to reconstruct certain standard \code{S4Vectors::Vectors} as
standard vectors or tibbles. The equivalent \code{exons} object would require
much more memory use, but at the advantage of only taking several seconds to
construct. When you are done, you can attempt to restore the original S4
Vector with \code{plyxp_restore_s4_proxy()}.

In development, \code{plyxp_s4_proxy_vec()} is faster to work with because there
are less checks on the object validity and all \verb{@elementMetadata} and
\verb{@metadata} are dropped from the objects.
}
}
\examples{
vec_slice(1:10, i = 5)
vec_slice(S4Vectors::Rle(rep(1:3, each = 3)), i = 5)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vctrs-S4-unchop.R
\name{list_unchop}
\alias{list_unchop}
\title{unchop a list of objects}
\usage{
list_unchop(x, ptype = NULL, ..., indices = NULL)
}
\arguments{
\item{x}{a list}

\item{ptype}{the expected prototype of the output}

\item{...}{unused arguments}

\item{indices}{optional list of integer vectors whose size is equal to that
of x. This maps the the final index of each element in the output.}
}
\value{
an object of type \code{ptype} or the common ptype of elements of x.
}
\description{
A generic version of \code{\link[vctrs:vec_chop]{vctrs::list_unchop}} meant to
support S4 Vectors.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plyxp-class.R
\docType{class}
\name{new_plyxp}
\alias{new_plyxp}
\alias{PlySummarizedExperiment}
\alias{PlySummarizedExperiment-class}
\title{SummarizedExperiment Shell Object}
\usage{
new_plyxp(se)

PlySummarizedExperiment(se)
}
\arguments{
\item{se}{SummarizedExperiment object}
}
\value{
PlySummarizedExperiment object
}
\description{
A container object for the SummarizedExperiment class.

This S4 class is implemented to bring unique \code{dplyr}
syntax to the \code{SummarizedExperiment} object without clashing with the
\code{tidySummarizedExperiment} package. As such, this is a simple wrapper that
contains one slot, which holds a \code{SummarizedExperiment} object.
}
\section{Slots}{

\describe{
\item{\code{se}}{contains the underlying \code{SummarizedExperiment} class.}
}}

\examples{
se <- SummarizedExperiment(
  assays = list(counts = matrix(1:6, nrow = 3)),
  colData = S4Vectors::DataFrame(condition = c("A", "B"))
)
new_plyxp(se = se)
# or
PlySummarizedExperiment(se = se)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vctrs-S4-.R
\docType{data}
\name{vectors}
\alias{vectors}
\alias{class_vctrs}
\alias{class_s4_vctrs}
\alias{class_DF}
\title{S7 classes for vctrs and S4 Vectors}
\format{
An object of class \code{S7_union} of length 1.

An object of class \code{classRepresentation} of length 1.

An object of class \code{classRepresentation} of length 1.
}
\usage{
class_vctrs

class_s4_vctrs

class_DF
}
\value{
S7 class union or base class
}
\description{
A set of S7 classes and Class unions that help establish S7 method dispatch.
These classes were made to re-export several \code{vctrs} functions such that
internals for \code{plyxp} were consistent with room for optimization.
}
\examples{
# used for defining methods on S7 generics

S7::method(vec_slice, class_s4_vctrs)

}
\seealso{
\code{\link[=vec_rep]{vec_rep()}},\code{\link[=vec_recycle]{vec_recycle()}},\code{\link[=vec_slice]{vec_slice()}}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr-summarise.R
\name{summarize}
\alias{summarize}
\alias{summarize.PlySummarizedExperiment}
\alias{summarise}
\alias{summarise.PlySummarizedExperiment}
\title{Summarize PlySummarizedExperiment}
\usage{
\method{summarize}{PlySummarizedExperiment}(.data, ..., .retain = c("auto", "ungrouped", "none"))

\method{summarise}{PlySummarizedExperiment}(.data, ..., .retain = c("auto", "ungrouped", "none"))
}
\arguments{
\item{.data}{An object Inheriting from \code{PlySummarizedExperiment}, the wrapper
class for \code{SummarizedExperiment} objects}

\item{...}{expressions to summarize the object}

\item{.retain}{This argument controls how \code{rowData()} or \code{colData()} is retained
after summarizing. When "auto" (the default), \code{.retain} behavior depends on
the groupings of \code{.data}. When exactly one dimension is grouped, "auto"
behaves like "ungrouped-dim", and "none" otherwise. When "ungrouped-dim",
the ungrouped dimension's data are retained in the resulting
\code{SummarizedExperiment} object and scalar outputs are recycled to the length
of the ungrouped dimension. When "none", all outputs are expected to be
scalar and only computed values are retained in \code{rowData()} and \code{colData()}}
}
\value{
an object inheriting PlySummarizedExperiment class
}
\description{
Summarize PlySummarizedExperiment
}
\examples{

# outputs in assay context may be either
# length 1, or the length of the ungrouped
# dimension while .retain = "auto"/"ungrouped-dim"
se_simple |>
  group_by(rows(direction)) |>
  summarise(
    col_sums = colSums(counts),
    sample = sample(1:20, 1L)
  )

# .retain = "none" will drop ungrouped dimensions and
# outputs of assay context should be length 1.
se_simple |>
  group_by(rows(direction)) |>
  summarise(
    col_sums = list(colSums(counts)),
    .retain = "none"
  )

# using an `across()` function will help
# nest ungrouped dimensions
se_simple |>
  group_by(rows(direction)) |>
  summarise(
    col_sums = list(colSums(counts)),
    cols(across(everything(), list)),
    .retain = "none"
  )

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vctrs-S4-recycle.R
\name{vctrs-vec_recycle}
\alias{vctrs-vec_recycle}
\alias{vec_recycle}
\title{Recycle a vector}
\usage{
vec_recycle(x, size, ..., x_arg = "", call = caller_env())
}
\arguments{
\item{x}{A vector to recycle.}

\item{size}{Desired output size.}

\item{...}{Depending on the function used:
\itemize{
\item For \code{vec_recycle_common()}, vectors to recycle.
\item For \code{vec_recycle()}, these dots should be empty.
}}

\item{x_arg}{Argument name for \code{x}. These are used in error
messages to inform the user about which argument has an
incompatible size.}

\item{call}{The execution environment of a currently
running function, e.g. \code{caller_env()}. The function will be
mentioned in error messages as the source of the error. See the
\code{call} argument of \code{\link[rlang:abort]{abort()}} for more information.}
}
\value{
a S3 or S4 vector
}
\description{
A re-export of \code{\link[vctrs:vec_recycle]{vctrs::vec_recycle}} as an S7 generic
function to allow \code{S4Vectors}.
}
\examples{
vec_recycle(1L, size = 5L)
vec_recycle(S4Vectors::Rle(1L), size = 5L)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{se_simple}
\alias{se_simple}
\title{Plyxp Simple Example Summarized Experiment}
\format{
\subsection{\code{se_simple}}{

\describe{

\item{\code{assays}}{
\describe{
\item{counts}{sampled data points between 1:20}
\item{logcounts}{log transform of \code{counts}}
}
}
\item{\code{rowData}/\code{.features}}{
\describe{
\item{gene}{fake gene name}
\item{length}{fake gene length}
\item{direction}{fake strand}
}
}
\item{\code{colData}/\code{.samples}}{
\describe{
\item{sample}{fake sample name}
\item{condition}{control or drug treatment}
}
}
}
}
}
\usage{
se_simple
}
\value{
a \code{SummarizedExperiment} object
}
\description{
A small data SummarizedExperiment Object of 20 observations, 5 rows and 4
columns.
}
\examples{
SummarizedExperiment::assays(se_simple)
SummarizedExperiment::rowData(se_simple)
SummarizedExperiment::colData(se_simple)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr-filter.R
\name{filter}
\alias{filter}
\alias{filter.PlySummarizedExperiment}
\title{filter PlySummarizedExperiment}
\usage{
\method{filter}{PlySummarizedExperiment}(.data, ..., .preserve = FALSE)
}
\arguments{
\item{.data}{An object Inheriting from \code{PlySummarizedExperiment}, the wrapper
class for \code{SummarizedExperiment} objects}

\item{...}{conditions to filter on. These must be wrapped in \code{cols()} and or
\code{rows()}}

\item{.preserve}{Relevant when the .data input is grouped. If .preserve = FALSE
(the default), the grouping structure is recalculated based on the resulting data,
i.e. the number of groups may change.}
}
\value{
an object inheriting \code{PlySummarizedExperiment} class
}
\description{
The \code{filter()} function is used to subset an object, returning the observations
that satisfy your conditions. An observation must return TRUE for all conditions
within a context to be retained. Note, to guarantee a valid
\code{PlySummarizedExperiment} is returned, filtering in the \code{assays} evaluation
context is disabled.
}
\examples{
# example code
filter(
  se_simple,
  rows(length > 30),
  cols(condition == "drug")
)

filter(
  se_simple,
  rows(rowSums(.assays_asis$counts) > 40),
  cols(colSums(.assays_asis$counts) < 50)
)

# assay context is disabled
filter(
  se_simple,
  counts > 12
) |> try()

# convert to `data.frame` first
as.data.frame(se_simple) |>
  filter(counts > 12)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/as.data.frame.R
\name{as.data.frame}
\alias{as.data.frame}
\alias{as.data.frame.PlySummarizedExperiment}
\title{create data.frame}
\usage{
\method{as.data.frame}{PlySummarizedExperiment}(x, ...)
}
\arguments{
\item{x}{\code{SummarizedExperiment} object}

\item{...}{unused arguments}
}
\value{
a data.frame object
}
\description{
create data.frame
}
\examples{
as.data.frame(se_simple)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vctrs-S4-rep.R
\name{vctrs-vec_rep}
\alias{vctrs-vec_rep}
\alias{vec_rep}
\alias{vec_rep_each}
\title{replicate a vector}
\usage{
vec_rep(
  x,
  times,
  ...,
  error_call = caller_env(),
  x_arg = "x",
  times_arg = "times"
)

vec_rep_each(
  x,
  times,
  ...,
  error_call = caller_env(),
  x_arg = "x",
  times_arg = "times"
)
}
\arguments{
\item{x}{A vector.}

\item{times}{For \code{vec_rep()}, a single integer for the number of times to repeat
the entire vector.

For \code{vec_rep_each()}, an integer vector of the number of times to repeat
each element of \code{x}. \code{times} will be \link[vctrs:theory-faq-recycling]{recycled} to
the size of \code{x}.}

\item{...}{These dots are for future extensions and must be empty.}

\item{error_call}{The execution environment of a currently
running function, e.g. \code{caller_env()}. The function will be
mentioned in error messages as the source of the error. See the
\code{call} argument of \code{\link[rlang:abort]{abort()}} for more information.}

\item{x_arg, times_arg}{Argument names for errors.}
}
\value{
a new S3 or S4 vector replicated by specified times
}
\description{
A re-export of \code{\link[vctrs:vec-rep]{vctrs::vec_rep}} and
\code{\link[vctrs:vec-rep]{vctrs::vec_rep_each}} as an S7 generic
function to allow \code{S4Vectors}.
}
\examples{
vec_rep(1:2, times = 5)
vec_rep(S4Vectors::Rle(1:2), times = 5)

vec_rep_each(1:2, times = 5)
vec_rep_each(S4Vectors::Rle(1:2), times = 5)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reexports-SummarizedExperiment.R,
%   R/reexports-dplyr.R
\docType{import}
\name{reexports}
\alias{reexports}
\alias{SummarizedExperiment}
\alias{assay}
\alias{assay<-}
\alias{assays}
\alias{assays<-}
\alias{rowData}
\alias{rowData<-}
\alias{colData}
\alias{colData<-}
\alias{metadata}
\alias{metadata<-}
\title{Objects exported from other packages}
\value{
exported functions available from \code{plyxp}
}
\examples{
arrange(se_simple, rows(direction)) |>
  mutate(logp_counts = log1p(counts)) |>
  filter(cols(condition == "drug"))

assays(se_simple)
rowData(se_simple)
colData(se_simple)

}
\seealso{
\code{\link[=arrange]{arrange()}} \code{\link[=mutate]{mutate()}} \code{\link[=filter]{filter()}}
\code{\link[=summarize]{summarize()}} \code{\link[=select]{select()}} \code{\link[=pull]{pull()}} \code{\link[=group_by]{group_by()}}
\code{\link[=group_data]{group_data()}} \code{\link[=group_vars]{group_vars()}} \code{\link[=ungroup]{ungroup()}}
\code{\link[=group_split]{group_split()}}

\link{PlySummarizedExperiment-methods}
}
\keyword{internal}
\description{
These objects are imported from other packages. Follow the links
below to see their documentation.

\describe{
  \item{S4Vectors}{\code{\link[S4Vectors:Annotated-class]{metadata}}, \code{\link[S4Vectors:Annotated-class]{metadata<-}}}

  \item{SummarizedExperiment}{\code{\link[SummarizedExperiment:SummarizedExperiment-class]{assay}}, \code{\link[SummarizedExperiment:SummarizedExperiment-class]{assay<-}}, \code{\link[SummarizedExperiment:SummarizedExperiment-class]{assays}}, \code{\link[SummarizedExperiment:SummarizedExperiment-class]{assays<-}}, \code{\link[SummarizedExperiment:SummarizedExperiment-class]{colData}}, \code{\link[SummarizedExperiment:SummarizedExperiment-class]{colData<-}}, \code{\link[SummarizedExperiment:SummarizedExperiment-class]{rowData}}, \code{\link[SummarizedExperiment:SummarizedExperiment-class]{rowData<-}}, \code{\link[SummarizedExperiment:SummarizedExperiment-class]{SummarizedExperiment}}}
}}
